rem @echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

:SETUP
	if "%~1" equ "" goto :HELP
	
	set bat_return=GOTO :EOF
	set bat_logfile=%~0.log

	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	
	set bat_targetdir=%~1
	set bat_targetdrive=!bat_targetdir:~0,2!
	if /i "!bat_targetdrive:~1,1!" neq ":" (
		!bat_echolog!
		!bat_echolog! Invalid path ["!bat_targetdir!"]
	)
	
	set bat_autonomous=
	if /i "%~2" equ "autonomous" (
		set bat_autonomous="autonomous"
	)
	
	set bat_returncode=0

:TARGETDIR
	!bat_echolog! ========================================================================
	!bat_echolog! %date% %time% - %~0 %*
	!bat_echolog!

	rem The bat_outputfile is the temp file the appears as a header
	rem to ftpdetectinfo*.txt files.  The bat_outputfile contains the
	rem proper Meteor Count = value
	set bat_outputfile=%bat_targetdir%\meteorcount.txt

	for /f "usebackq tokens=*" %%a in ('"!bat_targetdir!"') do (
		set bat_archdirname=%%~nxa
		set bat_dirdate=!bat_archdirname:~0,10!
	)
	
	set bat_curryyyy=!bat_dirdate:~0,4!
	set bat_currmm=!bat_dirdate:~5,2!
	set bat_currdd=!bat_dirdate:~8,2!
	set bat_currdate=!bat_dirdate:~0,10!
	set bat_caldate=!bat_curryyyy!!bat_currmm!!bat_currdd!


	!bat_echolog!      bat_targetdir=!bat_targetdir!
	!bat_echolog!      bat_targetdrive=!bat_targetdrive!
	!bat_echolog!      bat_outputfile=!bat_outputfile!
	!bat_echolog!      bat_exedir=!bat_exedir!
	!bat_echolog!      bat_dirdate=!bat_dirdate!
	!bat_echolog!      bat_currdate=!bat_currdate!

	if /i "!bat_targetdir!" equ "" (
		!bat_echolog!
		!bat_echolog!      The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		!bat_echolog!      Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		!bat_echolog!
		if not defined bat_autonomous (
			set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		) else (
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=!bat_returncode!
			goto :DONE
		)
		
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)
goto :MAIN %*

:MAIN
!bat_echolog! goto :MAIN %*
	call :GETCAMERAFROMFILES
	!bat_echolog! bat_returncode=[!bat_returncode!]
	if /i "!bat_returncode!" equ "0" (
		call :APPLYBEGIN
	)
goto :DONE



rem *************************************************************
rem ***** This should be made into a standalone batch file ******
rem *************************************************************
:APPLY1
!bat_echolog! :APPLY1
:APPLYBEGIN
!bat_echolog! call :APPLYBEGIN %*
	!bat_echolog!
	!bat_echolog!     This step runs FTP_ApplyCal2Detectinfo
	!bat_echolog!
	if not defined bat_autonomous (
		!bat_echolog!     You will be asked to 'Navigate to FTP Detection File to 
		!bat_echolog!     Process for Coincidence'.  Instead, navigate to and select
		!bat_echolog!     "!bat_detectfile1!".
		!bat_echolog!
		set bat_choice=
		set /p bat_choice=   [A]pply cal, [S]kip, or [Q]uit : 
		if /i "!bat_choice!" equ "s" goto :APPLY4
		if /i "!bat_choice!" neq "a" goto :APPLYBEGIN
		if /i "!bat_choice!" equ "q" (
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
	)

	find /i ".bin" "!bat_detectfile1!">nul:
	if !errorlevel! neq 0 (
		!bat_echolog! '    ERROR - No events found in "!bat_detectfile1!"
		set bat_returncode=1
		!bat_echolog! '    set bat_returncode=!bat_returncode!
		goto :APPLY5
	)

	!bat_echolog!     call "!bat_exedir!\FTP_ApplyCal2Detectinfo.exe" "!bat_detectfile1!"
				      call "!bat_exedir!\FTP_ApplyCal2Detectinfo.exe" "!bat_detectfile1!"<CRLF.inp

	set bat_ffname=
	set bat_calname=
	echo     for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".bin" "!bat_targetdir!\!bat_detectfile3!C.txt"`^) do>>"!bat_logfile!"
	echo     for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".bin" "!bat_targetdir!\!bat_detectfile3!C.txt"`^) do
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".bin" "!bat_targetdir!\!bat_detectfile3!C.txt"`) do (
		if not defined bat_ffname ( set bat_ffname=%%a)
	)
	
	echo     for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_targetdir!\!bat_detectfile3!C.txt"`^) do>>"!bat_logfile!"
	echo     for /f "usebackq tokens=* skip=2" %%a in ^(`find /i ".txt" "!bat_targetdir!\!bat_detectfile3!C.txt"`^) do 
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_targetdir!\!bat_detectfile3!C.txt"`) do (
		if not defined bat_calname ( set bat_calname=%%a)
	)

	!bat_echolog!
	!bat_echolog!
	!bat_echolog!   The FF file and the CAL files should have matching dates
	!bat_echolog!   with possibly different times.  The time of the cal file
	!bat_echolog!   should match the time of the FF file chosen for 
	!bat_echolog!   calibration ^(that you wrote down^).
	!bat_echolog!
	!bat_echolog!   This routine should have applied your latest calibration 
	!bat_echolog!   file with the cmatching date/time in the listed cal filename.
	!bat_echolog!
	
	if defined bat_ffname (
		!bat_echolog! '   !bat_ffname!
	) else (
		!bat_echolog! '    ERROR - Could not find ".bin" files in "!bat_targetdir!\!bat_detectfile3!C.txt"
		set bat_returncode=1
		!bat_echolog! '    set bat_returncode=!bat_returncode!
		goto :APPLY5
	)
	
	if defined bat_calname (
		!bat_echolog! '   !bat_calname!
	) else (
		!bat_echolog! '    ERROR - Could not find ".txt" files in "!bat_targetdir!\!bat_detectfile3!C.txt"
		set bat_returncode=1
		!bat_echolog! '    set bat_returncode=!bat_returncode!
		goto :APPLY5
	)
	
	!bat_echolog!   FF  file date: !bat_ffname:~6,8!   !bat_ffname!
	!bat_echolog!   Cal file date: !bat_calname:~7,8!   !bat_calname!
	!bat_echolog!

	if /i "!bat_ffname:~6,8!" equ "!bat_calname:~7,8!" (
		!bat_echolog!   So far, they seem to match OK.
		!bat_echolog!
	) else (
		!bat_echolog!   They don't seem to match.
		!bat_echolog!
		if defined bat_autonomous (
			!bat_echolog! ERROR - The calibration was not able to be applied to
			!bat_echolog!         '!bat_detectfile1'. 
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
	)
	
	!bat_echolog!
	if not defined bat_autonomous (
		set bat_choice=
		set /p bat_choice=   If this is correct, enter [C]ontinue, [R]eject and try again, or [Q]uit : 
		if /i "!bat_choice!" equ "c" goto :APPLYEND
		if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
		if /i "!bat_choice!" equ "q" (
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
	) else (
		goto :APPLYEND
	)

:APPLYEND	
!bat_echolog! :APPLYEND

	!bat_echolog!     move /y "!bat_targetdir!\!bat_detectfile3!C.txt" "!bat_detectfile4!"
	                  move /y "!bat_targetdir!\!bat_detectfile3!C.txt" "!bat_detectfile4!"

:APPLY4
!bat_echolog! :APPLY4
	if exist "!bat_targetdir!\!bat_detectfile3!C.txt" (
		!bat_echolog!     ERROR - The {apply} file wasn't able to be moved to the detect file
		!bat_echolog!     "!bat_targetdir!\!bat_detectfile3!C.txt"
		
		if defined bat_autonomous (
			goto :APPLY5
		) else (
			set /p bat_choice=  [C]ontinue, [R]etry, or [Q]uit?  
			if /i "!bat_choice!" equ "c" goto :DONE
			if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
			if /i "!bat_choice!" equ "q" (
				set bat_returncode=1
				!bat_echolog! '    set bat_returncode=!bat_returncode!
				goto :APPLY5
			)
			goto :APPLY4
		)
	) else (
		find /i /c "!bat_calname!" "!bat_detectfile4!">nul:
		if "!errorlevel!" equ "0" (
			!bat_echolog!
			!bat_echolog!   SUCCESS - '!bat_calname!' was applied to '!bat_detectfile4!'
			!bat_echolog!
		) else (
			!bat_echolog!
			!bat_echolog!   ERROR - '!bat_calname!' was NOT applied to '!bat_detectfile4!'
			!bat_echolog!
			set bat_returncode=1
			!bat_echolog! '    set bat_returncode=!bat_returncode!
			goto :APPLY5
		)
	)

:APPLY5
!bat_echolog! return-:APPLYBEGIN [!bat_returncode!]
%bat_return%


:GETCAMERAFROMFILES
!bat_echolog! call :GETCAMERAFROMFILES %*
	rem First, try FFCorruptFilesLog_Case001.txt
	set bat_camera=000
	
	set bat_detectfile2=FTPdetectinfo.txt
	set bat_detectfile1=!bat_targetdir!\FTPdetectinfo.txt
	set bat_detectfile3=FTPdetectinfo
	set bat_detectfile4=!bat_targetdir!\FTPdetectinfo.txt
	
	if exist "!bat_targetdir!\FFCorruptFilesLog.txt" (
		!bat_echolog! '    Getting camera from "!bat_targetdir!\FFCorruptFilesLog.txt"
		for /f "usebackq tokens=1-9" %%a in (`type "!bat_targetdir!\FFCorruptFilesLog.txt"`) do (
			set bat_temp=%%i
			set bat_camera=!bat_temp:~2,3!
			set bat_detectfile1=!bat_targetdir!\FTPdetectinfo.txt
			set bat_detectfile2=FTPdetectinfo.txt
			set bat_detectfile3=FTPdetectinfo
		)
	) else (
		if exist "!bat_targetdir!\FFCorruptFilesLog_Case001.txt" (
			!bat_echolog! '    Getting camera from "!bat_targetdir!\FFCorruptFilesLog_Case001.txt"
			for /f "usebackq tokens=1-9" %%a in (`type "!bat_targetdir!\FFCorruptFilesLog_Case001.txt"`) do (
				set bat_temp=%%i
				set bat_camera=!bat_temp:~2,3!
				set bat_detectfile1=!bat_targetdir!\FTPdetectinfo.txt
				set bat_detectfile2=FTPdetectinfo.txt
				set bat_detectfile3=FTPdetectinfo
			)
		) else (
			if exist "!bat_targetdir!\FTPdetectinfo.txt" (
				rem Get Camera from FTPdetectinfo.txt
				!bat_echolog! '    Getting camera from "!bat_targetdir!\FTPdetectinfo.txt"
			for /f "usebackq tokens=1 skip=2" %%a in (`find /i ".bin" "!bat_targetdir!\FTPdetectinfo.txt"`) do (
					set bat_temp=%%a
					set bat_camera=!bat_temp:~2,3!
					set bat_detectfile1=!bat_targetdir!\FTPdetectinfo.txt
					set bat_detectfile2=FTPdetectinfo.txt
					set bat_detectfile3=FTPdetectinfo
				)
				) else (
				if exist "!bat_targetdir!\FTPdetectinfo_????_????_??_??.txt" (
					!bat_echolog! '    Getting camera from `dir "!bat_targetdir!\FTPdetectinfo_????_????_??_??.txt" /s/b /a-d`
					for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdir!\FTPdetectinfo_????_????_??_??.txt" /s/b /a-d`) do (
						set bat_detectfile1=%%~a
						set batZ_detectfile2=%%~nxa
						set bat_detectfile3=%%~na
					)

					for /f "usebackq tokens=1 skip=2" %%a in (`find /i ".bin" "!bat_targetdir!\FTPdetectinfo_????_????_??_??.txt"`) do (
						set bat_temp=%%a
						set bat_camera=!bat_temp:~2,3!
					)
				)
			)
		)
	)

	if "!bat_camera!" equ "000" (
		!bat_echolog! '    ERROR - Unable to determine camera number
		set bat_returncode=1
		!bat_echolog! '    set bat_returncode=!bat_returncode!
	)

	!bat_echolog! '      bat_camera=!bat_camera!
	!bat_echolog! '      bat_detectfile1=!bat_detectfile1!
	!bat_echolog! '      bat_detectfile2=!bat_detectfile2!
	!bat_echolog! '      bat_detectfile3=!bat_detectfile3!
!bat_echolog! return-:GETCAMERAFROMFILES bat_camera=!bat_camera! [bat_returncode=!bat_returncode!]
%bat_return%





:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp= %*
	set bat_echolog_temp=!bat_echolog_temp:"=^"!

	set bat_echolog_temp=%bat_echolog_temp:~1,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=%*
	
	if /i "%*" equ "'" (
		echo.>>"!bat_logfile!"
		%bat_return%
	)
	
		set bat_echolog_temp= %bat_echolog_temp:~2,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%










:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. Typically, this directory is the 
	echo     ArchivedFiles subdir.
	echo.
	echo     The script was designed to perform the following tasks:
	echo       1) Run FTP_ApplyCal2Detectinfo 
	echo       2) Test the resulting FTPdetectinfoC.txt for proper cal
	echo       3) Move the resulting FTPdetectinfoC.txt
	echo       4) Test the resulting FTPdetectinfo.txt for proper cal
exit /b



:DONE
	!bat_echolog! goto :DONE
	!bat_echolog! ApplyCal.bat return code=[!bat_returncode!]
	exit /b !bat_returncode!
