@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


:SETUP
	if "%~1" equ "" goto :HELP

	set bat_exedir=%~dp0::&						rem f:\CAMS\::
	set bat_exedir=!bat_exedir:\::=!&			rem f:\CAMS
	set bat_exedir=!bat_exedir:::=!&			rem f:\CAMS
	
	set bat_targetdir=%~1
	set bat_targetdrive=!bat_targetdir:~0,2!
	if /i "!bat_targetdrive:~1,1!" neq ":" (
		echo.
		echo Invalid path ["!bat_targetdir!"]
	)

:TARGETDIR

	rem The bat_outputfile is the temp file the appears as a header
	rem to ftpdetectinfo*.txt files.  The bat_outputfile contains the
	rem proper Meteor Count = value
	set bat_outputfile=%bat_targetdir%\meteorcount.txt

	for /f "usebackq tokens=*" %%a in ('"!bat_targetdir!"') do (
		set bat_archdirname=%%~nxa
		set bat_dirdate=!bat_archdirname:~0,10!
	)
	
	set bat_curryyyy=!bat_dirdate:~0,4!
	set bat_currmm=!bat_dirdate:~5,2!
	set bat_currdd=!bat_dirdate:~8,2!
	set bat_currdate=!bat_dirdate:~0,10!
	set bat_caldate=!bat_curryyyy!!bat_currmm!!bat_currdd!


	echo bat_targetdir=!bat_targetdir!
	echo bat_targetdrive=!bat_targetdrive!
	echo bat_outputfile=!bat_outputfile!
	echo bat_exedir=!bat_exedir!
	echo bat_dirdate=!bat_dirdate!
	echo bat_currdate=!bat_currdate!

	if /i "!bat_targetdir!" equ "" (
		echo.
		echo The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		echo Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		echo.
		set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)

:MAIN
	echo ========================================================================
	echo %~0 %*
	echo.

	rem need camera number
	call :GETCAMERAFROMFILES
	call :APPLYBEGIN
goto :DONE



rem *************************************************************
rem ***** This should be made into a standalone batch file ******
rem *************************************************************
:APPLY1
:APPLYBEGIN
	echo.
	echo     This step runs FTP_ApplyCal2Detectinfo
	echo.
	echo     You will be asked to "Navigate to FTP Detection File to 
	echo     Process for Coincidence".  Instead, navigate to and 
	echo     select "!bat_targetdir!\FTPdetectinfo.txt".
	echo.
	set bat_choice=
	set /p bat_choice=   [A]pply cal, [S]kip, or [Q]uit : 
	if /i "!bat_choice!" equ "s" goto :APPLY4
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" neq "a" goto :APPLYBEGIN

	echo call echo.^|FTP_ApplyCal2Detectinfo
	     call echo.|FTP_ApplyCal2Detectinfo

	set bat_ffname=
	set bat_calname=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".bin" "!bat_targetdir!\FTPdetectinfoC.txt"`) do (
		if not defined bat_ffname ( set bat_ffname=%%a )
	)

	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_targetdir!\FTPdetectinfoC.txt"`) do (
		if not defined bat_calname ( set bat_calname=%%a )
	)

	echo.
	echo   !bat_ffname!
	echo   !bat_calname!
	echo.
	echo   The FF file and the CAL files should have matching dates
	echo   with possibly different times.  The time of the cal file
	echo   should match the time of the FF file chosen for calibration.
	echo.
	echo   It should have applied your latest calibration file with the
	echo   matching date/time in the listed cal filename.
	echo.
	if /i "!bat_ffname:~6,8!" equ "!bat_calname:~7,8!" (
		echo   FF  file date: !bat_ffname:~6,8!   !bat_ffname!
		echo   Cal file date: !bat_calname:~7,8!   !bat_calname!
		echo.
		echo   So far, they seem to match OK.
		echo.
	) else (
		echo   FF  file date: !bat_ffname:~6,8!   !bat_ffname!
		echo   Cal file date: !bat_calname:~7,8!   !bat_calname!
		echo.
		echo   They don't seem to match.
		echo.
	)
	echo.
	set bat_choice=
	set /p bat_choice=   If this is correct, enter [C]ontinue, [R]eject and try again, or [Q]uit : 
	if /i "!bat_choice!" equ "c" goto :APPLYEND
	if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
	if /i "!bat_choice!" equ "q" goto :EOF

:APPLYEND	

	echo     move /y "!bat_targetdir!\FTPdetectinfoC.txt" "!bat_targetdir!\FTPdetectinfo.txt"
	         move /y "!bat_targetdir!\FTPdetectinfoC.txt" "!bat_targetdir!\FTPdetectinfo.txt"

:APPLY4
	if exist "!bat_targetdir!\FTPdetectinfoC.txt" (
		echo     ERROR - The {apply} file wasn't able to be moved to the detect file
		echo     "!bat_targetdir!\FTPdetectinfoC.txt"
		set /p bat_choice=  [C]ontinue, [R]etry, or [Q]uit?  
		if /i "!bat_choice!" equ "c" goto :DONE
		if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
		if /i "!bat_choice!" equ "q" goto :DONE
		goto :APPLY4
	)

goto :EOF


:GETCAMERAFROMFILES
	rem First, try FFCorruptFilesLog_Case001.txt
	set bat_camera=000
	
	if exist "!bat_targetdir!\FFCorruptFilesLog_Case001.txt" (
		for /f "usebackq tokens=1" %%a in (`type "!bat_targetdir!\FFCorruptFilesLog_Case001.txt"`) do (
			set bat_temp=%%a
			set bat_camera=!bat_temp:~2,3!
		)
	) else (
		rem Get Camera from FTPdetectinfo.txt
		for /f "usebackq tokens=1 skip=2" %%a in (`find /i ".bin" "!bat_targetdir!\FTPdetectinfo.txt"`) do (
			set bat_temp=%%a
			set bat_camera=!bat_temp:~2,3!
		)
	)
	echo :GETCAMERAFROMFILES bat_camera=!bat_camera!
goto :EOF










:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. Typically, this directory is the 
	echo     ArchivedFiles subdir.
	echo.
	echo     The script was designed to perform the following tasks:
	echo       1) Run FTP_ApplyCal2Detectinfo 
	echo       2) Test the resulting FTPdetectinfoC.txt for proper cal
	echo       3) Move the resulting FTPdetectinfoC.txt
	echo       4) Test the resulting FTPdetectinfo.txt for proper cal
exit /b



:DONE
