@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


:SETUP
	if "%~1" equ "" goto :HELP


:TARGETDIR
	set bat_targetdir=%~1
	set bat_targetdrive=!bat_targetdir:~0,2!
	if /i "!bat_targetdrive:~1,1!" neq ":" (
		echo.
		echo Invalid path ["!bat_targetdir!"]
	)

	rem The bat_outputfile is the temp file the appears as a header
	rem to ftpdetectinfo*.txt files.  The bat_outputfile contains the
	rem proper Meteor Count = value
	set bat_outputfile=%bat_targetdir%\meteorcount.txt
	set bat_exedir=%cd%

	for /f "usebackq tokens=*" %%a in ('"c:\cams\ArchivedFiles\2011_08_26_03_00_13"') do (
		set bat_archdirname=%%~nxa
		set bat_dirdate=!bat_archdirname:~0,10!
	)
	
	set bat_curryyyy=!bat_dirdate:~0,4!
	set bat_currmm=!bat_dirdate:~5,2!
	set bat_currdd=!bat_dirdate:~8,2!
	set bat_currdate=!bat_dirdate:~0,10!
	set bat_caldate=!bat_curryyyy!!bat_currmm!!bat_currdd!


	echo bat_targetdir=!bat_targetdir!
	echo bat_targetdrive=!bat_targetdrive!
	echo bat_outputfile=!bat_outputfile!
	echo bat_exedir=!bat_exedir!
	echo bat_dirdate=!bat_dirdate!
	echo bat_currdate=!bat_currdate!

	if /i "!bat_targetdir!" equ "" (
		echo.
		echo The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		echo Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		echo.
		set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)

:MAIN
	echo ========================================================================
	echo %~0 %*
	echo.

	rem need camera number
	call :GETCAMERAFROMFILES
	call :APPLY1
	goto :EOF

:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "%%a"
		echo     call WaitForFile rw "%%a"
		     call WaitForFile rw "%%a"
	)
	echo.
	


	rem temporary concat to fix the meteor count
	rem This section concats without the header
:TEMPCONCAT
	ECHO :TEMPCONCAT %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%%~a"
		) else (
			set bat_string=!bat_string!+"%%~a"
		)
	)
	echo     copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"
	         copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT
	for /f "usebackq tokens=1-4" %%a in (`find /i /c ".bin" "%bat_targetdir%\FTPdetectinfo.txt"`) do (
		set bat_count=%%c
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!


	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
	set /a bat_linecount=0
	echo for /f "usebackq tokens=*" %%a in ^(`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			echo Meteor Count = !bat_count!>"%bat_outputfile%"
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_targetdrive!!bat_FFfolder:~15,255!
				echo !bat_FFfolder!>>"%bat_outputfile%"
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_targetdrive!!bat_CALfolder:~15,255!
					echo !bat_CALfolder!>>"%bat_outputfile%"
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					echo %%a>>"%bat_outputfile%"
				)
			)
		)
	)
:CONCATFINAL
	echo copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"
	     copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"

	del "!bat_outputfile!"
	echo.
	if not exist "!bat_targetdir!\FTPdetectinfo.txt" (
:CONCATPROMPT
		echo Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		echo file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		echo the following command
		echo    %~0 %*
		set /p bat_choice=Enter [R]estart, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE

	echo.
	echo     Date/Time           Size           File name
	echo     ------------------- -------------  ----------------------------------------------
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdir!\FTPdetectinfo.txt" /s/b /a-d`) do (
		set bat_filesize=             %%~za
		set bat_filesize=!bat_filesize:~-13!
		set bat_filedate=%%~ta
		set bat_filename=%%a
		echo     !bat_filedate! !bat_filesize!  !bat_filename!
	)
	echo.

	echo     Excerpt from "!bat_targetdir!\FTPdetectinfo.txt", please review the following: 
	echo     - Meteor Count   [should be !bat_count!]
	echo     - FF folder      [should be "!bat_targetdir!"]
	echo     - CAL folder     [should be where the cal file is]
	echo     - Cal file       [should match the date/time of file chosen in meteor cal update]
	echo.
	echo    Please wait while opening the file...
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_targetdir!\FTPdetectinfo.txt"`) do (
		set /a bat_counter+=1
		if !bat_counter! LSS 15 (
			echo         %%a
		) else (
			if !bat_counter! equ 15 (
				echo.
				echo     Please wait while skipping the rest of the file...
			)
		)
	)

:CONCATDISPLAY


:VALIDATE01B
	echo.
	echo.
	set /p bat_choice=Is there an FTPdetectinfo.txt file and do the date/time and size seem right Y/N? 
	if /i "!bat_choice!" equ "y" goto :VALIDATE02
	if /i "!bat_choice!" equ "n" goto :DONE
goto :VALIDATE01B
:VALIDATE02



rem *************************************************************
rem ***** This should be made into a standalone batch file ******
rem *************************************************************
:APPLY1
:APPLYBEGIN
	echo.
	echo     This step runs FTP_ApplyCal2Detectinfo
	echo.
	echo     You will be asked to "Navigate to FTP Detection File to 
	echo     Process for Coincidence".  Instead, navigate to and 
	echo     select "!bat_targetdir!\FTPdetectinfo.txt".
	echo.
	set /p bat_choice=   [A]pply cal, [S]kip, or [Q]uit : 
	if /i "!bat_choice!" equ "s" goto :APPLY4
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" neq "a" goto :APPLYBEGIN

	echo call echo.^|FTP_ApplyCal2Detectinfo
	     call echo.|FTP_ApplyCal2Detectinfo

	set bat_ffname=
	set bat_calname=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".bin" "!bat_targetdir!\FTPdetectinfoC.txt"`) do (
		if not defined bat_ffname ( set bat_ffname=%%a )
	)

	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_targetdir!\FTPdetectinfoC.txt"`) do (
		if not defined bat_calname ( set bat_calname=%%a )
	)

	echo.
	echo   !bat_ffname!
	echo   !bat_calname!
	echo.
	echo   The FF file and the CAL files should have matching dates
	echo   with possibly different times.  The time of the cal file
	echo   should match the time of the FF file chosen for calibration.
	echo.
	echo   It should have applied your latest calibration file with the
	echo   matching date/time in the listed cal filename.
	echo.
	set /p bat_choice=   If this is correct, enter [C]ontinue, [R]eapply, or [Q]uit : 
	if /i "!bat_choice!" equ "c" goto :APPLYEND
	if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
	if /i "!bat_choice!" equ "q" goto :EOF

:APPLYEND	

	echo     move /y "!bat_targetdir!\FTPdetectinfoC.txt" "!bat_targetdir!\FTPdetectinfo.txt"
	         move /y "!bat_targetdir!\FTPdetectinfoC.txt" "!bat_targetdir!\FTPdetectinfo.txt"

:APPLY4

	if exist "!bat_targetdir!\FTPdetectinfoC.txt" (
		echo     ERROR - The {apply} file wasn't able to be moved to the detect file
		echo     "!bat_targetdir!\FTPdetectinfoC.txt"
		set /p bat_choice=  [C]ontinue, [R]etry, or [Q]uit?  
		if /i "!bat_choice!" equ "c" goto :DONE
		if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
		if /i "!bat_choice!" equ "q" goto :DONE
		goto :APPLY4
	)

goto :EOF


:GETCAMERAFROMFILES
	rem First, try FFCorruptFilesLog_Case001.txt
	set bat_camera=000
	
	if exist "!bat_targetdir!\FFCorruptFilesLog_Case001.txt" (
		for /f "usebackq tokens=1" %%a in (`type "!bat_targetdir!\FFCorruptFilesLog_Case001.txt"`) do (
			set bat_temp=%%a
			set bat_camera=!bat_temp:~2,3!
		)
	) else (
		rem Get Camera from FTPdetectinfo.txt
		for /f "usebackq tokens=1 skip=2" %%a in (`find /i ".bin" "!bat_targetdir!\FTPdetectinfo.txt"`) do (
			set bat_temp=%%a
			set bat_camera=!bat_temp:~2,3!
		)
	)
	echo :GETCAMERAFROMFILES bat_camera=!bat_camera!
goto :EOF

:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. Typically, this directory is the 
	echo     ArchivedFiles subdir.
	echo.
	echo     The script was designed to perform the following tasks:
	echo       1) Run FTP_ApplyCal2Detectinfo 
	echo       2) Test the resulting FTPdetectinfoC.txt for proper cal
	echo       3) Move the resulting FTPdetectinfoC.txt
	echo       4) Test the resulting FTPdetectinfo.txt for proper cal
exit /b



:DONE
