  @echo off
	setlocal enableextensions enabledelayedexpansion

:SETUP
	set bat_logfile=%~0.log
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG

    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	set bat_return=goto :EOF

	echo.>"!bat_logfile!"
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - %~0 %*

	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!

	set bat_CD_flag=%~1
	set bat_camera=%~2
	set bat_duration=%~3
	set bat_targetlocation=%~4
	set bat_savetargetlocation=%~4

	set bat_autonomous=
	if /i "%~5" equ "autonomous" (
		set bat_autonomous=autonomous
	)
	if /i "%~5" equ "auto" (
		set bat_autonomous=autonomous
	)
	
	set bat_testmode=
    echo.%*|find /i "/testmode">nul:
    if %errorlevel% equ 0 (
    	set bat_testmode=testmode
    )
	
goto :MAIN %*



:MAIN
!bat_echolog! call :MAIN %*
	call :CURDATETIME %*
	call :PRECAPTURE %*
	call :LAUNCHCAPTURE %*

	set bat_runautocams=
	call :GETCAPTUREDIR %*
	if "!bat_retval!" neq "failed" (
		set bat_runautocams=!bat_retval!
		call :GETARCHIVEDDIR %*
		call :GETDETECTFILE %*
		call :WAITCAPTUREDETECT %*
		call :COPYARCHIVED %*

		call :POSTCAPTURE %*
		if /i "!bat_retval!" neq "success" (goto :DONE)

		rem call :MULTISCAN
		rem call :WAITFORMULTISCAN
		rem call :POSTMULTISCAN
		rem call :CAMSMENU
		
		!bat_echolog! '    AutoCams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
		                   AutoCams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
	)

!bat_echolog! end-:MAIN
goto :DONE




:CURDATETIME
!bat_echolog! call :CURDATETIME %*
	set ftp_wmdy=%date%

	set ftp_hhmmssdd=%time%

	set ftp_year=%ftp_wmdy:~-4%
	set ftp_mo=%ftp_wmdy:~4,2%
	set ftp_mo2=%ftp_mo%
	if %ftp_mo% LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	set ftp_da=%ftp_wmdy:~7,2%
	set ftp_da2=%ftp_da%
	if %ftp_da% LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

	set ftp_hr=%ftp_hhmmssdd:~0,2%
	set ftp_mi=%ftp_hhmmssdd:~3,2%
	set ftp_se=%ftp_hhmmssdd:~6,5%

	call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	rem set /a ftp_jd=%ftp_jd%-1
	call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2
!bat_echolog! return-:CURDATETIME
%bat_return%



:LAUNCHCAPTURE
!bat_echolog! call :LAUNCHCAPTURE %*
	!bat_echolog!
	!bat_echolog! Killing any existing FTP_CaptureAndDetect.exe processes that might be running...
	!bat_echolog! %date% %time% - calling process -k FTP_CaptureAndDetect.exe
	call process -k FTP_CaptureAndDetect.exe

	!bat_echolog!
	!bat_echolog! Starting FTP_CaptureAndDetect.exe...
	echo %date% %time% "FTP_CaptureAndDetect start" %1 %2 %3 %4>>"!bat_logfile!"
	title "[%date% %time%]  FTP_CaptureAndDetect" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!
	echo start "FTP_CaptureAndDetect.exe !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!" /abovenormal /wait "FTP_CaptureAndDetect.exe" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!>>"!bat_logfile!"
rem goto :LAUNCHCAPTURE2
	if exist "entervideodevice0.inp" (
	     call "!bat_exedir!\FTP_CaptureAndDetect.exe" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!<"entervideodevice0.inp"
	) else (
		if exist "entervideodevice1.inp" (
			 call "!bat_exedir!\FTP_CaptureAndDetect.exe" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!<"entervideodevice1.inp"
	    ) else (
	    	call "!bat_exedir!\FTP_CaptureAndDetect.exe" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!
	    )
	)
:LAUNCHCAPTURE2
	echo  %date% %time% "FTP_CaptureAndDetect end" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!>>"!bat_logfile!"
	echo  %date% %time% "FTP_CaptureAndDetect end" !bat_CD_flag! !bat_camera! !bat_duration! !bat_targetlocation!
	
!bat_echolog! return-:LAUNCHCAPTURE
%bat_return%

	



:PRECAPTURE
%bat_echolog% call :PRECAPTURE %*
		set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	
		rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
		rem ordered ascending by date. The last one will be the one created by the 
		rem FTP_CaptureAndDetect.exe program.
		set bat_precaptureddir=
		!bat_echolog!     for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
		for                   /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
			if /i "!bat_targetsearchspec!\%%~nxa" neq "movies" (
				if /i "!bat_targetsearchspec!\%%~nxa" neq "displayJPEGS" (
					if /i "!bat_targetsearchspec!\%%~nxa" neq "gefdat" (
								 set bat_precaptureddir=!bat_targetsearchspec!\%%~a
					)
				)
			)
		)
		
		if not defined bat_precaptureddir (set bat_precaptureddir= )
		%bat_echolog% '     bat_precaptureddir="!bat_precaptureddir!"
%bat_echolog% return-:PRECAPTURE %*
%bat_return%


:GETCAPTUREDIR
!bat_echolog! call :GETCAPTUREDIR %*
	set bat_retval=failed
	rem This section is attempting to determine the directory name that FTP_CaptureAndDetect.exe
	rem created.  It uses the Year, Month, and Day (YYYY_MM_DD) to do a matching directory
	rem search. The last one in the list should be the most recent FTP_CaptureAndDetect directory.

	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%

	rem This for loop will complete with the newest directory with the specified date
	rem as the prefix.  Even if there are multiple directories with the same date, the 
	rem newest one be contained in resulting value of ftp_captureddir.

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles

	rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe program.  Careful, there is a chance that it didn't 
	rem create a directory and you'd be choosing the wrong dir.

	set bat_targetsearchdir=
	set bat_captureddir=
	set bat_captureddirname=
	set bat_capturedbasedir=
	set bat_captureddate=
	echo '     for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...>>!bat_logfile!"
	for            /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "!bat_targetsearchspec!\%%~nxa" neq "movies" (
			if /i "!bat_targetsearchspec!\%%~nxa" neq "displayJPEGS" (
				if /i "!bat_targetsearchspec!\%%~nxa" neq "gefdat" (
					rem Example: bat_targetsearchdir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					 set bat_targetsearchdir=!bat_targetsearchspec!\%%~a

					rem Example: bat_captureddir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					 set bat_captureddir=!bat_targetsearchspec!\%%~a

					rem example: bat_captureddirname=2012_01_18_01_00_13
					 set bat_captureddirname=%%~nxa

					rem example: bat_capturedbasedir=C:\CAMS\CapturedFiles
					set bat_capturedbasedir=%%~dpa::
					set bat_capturedbasedir=!bat_capturedbasedir:\::=!
					set bat_capturedbasedir=!bat_capturedbasedir:::=!
				)
			)
		)
	)

	!bat_echolog! '    if /i "!bat_captureddir!" equ "!bat_precaptureddir!" ...
	if /i "!bat_captureddir!" equ "!bat_precaptureddir!" (
		!bat_echolog!
		!bat_echolog! '    ERROR - Capture did not produce a new directory. Interpreting that as a
		!bat_echolog! '    capture failure. 
	) else (
		!bat_echolog! '    bat_targetsearchdir=!bat_targetsearchdir!>>"!bat_logfile!"
		!bat_echolog! '    bat_captureddir=!bat_captureddir!>>"!bat_logfile!"
		!bat_echolog! '    bat_captureddirname=!bat_captureddirname!


		rem Example: bat_captureddate=2012_01_18
		set bat_captureddate=!bat_captureddirname:~0,10!

		set bat_cap>>"!bat_logfile!"
		set bat_retval=!bat_captureddir!
	)
	
!bat_echolog! return-:GETCAPTUREDIR [!bat_retval!]
%bat_return%




:GETARCHIVEDDIR
!bat_echolog! call :GETARCHIVEDDIR %*
		rem This section is attempting to determine the directory name that FTP_CaptureAndDetect.exe
		rem created for ArchivedFiles.  It uses the Year, Month, and Day (YYYY_MM_DD) to do a 
		rem matching directory search. The last one in the list should be the most recent 
		rem FTP_CaptureAndDetect directory.
	
		set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%
	
		rem This for loop will complete with the newest directory with the specified date
		rem as the prefix.  Even if there are multiple directories with the same date, the 
		rem newest one be contained in resulting value of ftp_captureddir.
	
		set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles
	
		rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
		rem ordered ascending by date. The last one will be the one created by the 
		rem FTP_CaptureAndDetect.exe program.  CAREFUL, there is a chance that
		rem there is no matching ArchivedFiles dir. 
		
		set bat_targetsearchdir=
		set bat_archiveddir=
		set bat_archiveddirname=
		set bat_archivedbasedir=
		set bat_archiveddate=
		echo     for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od^|find /i "!bat_captureddate!"`^) do...>>"!bat_logfile!"
		for          /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od^|find /i "!bat_captureddate!"`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
						rem Example: bat_targetsearchdir=C:\CAMS\ArchivedFiles\2012_01_18_01_00_13
						set bat_targetsearchdir=!bat_targetsearchspec!\%%~a

						rem Example: bat_captureddir=C:\CAMS\CapturedArchivedFiles\2012_01_18_01_00_13
						set bat_archiveddir=!bat_targetsearchspec!\%%~a

						rem example: bat_archiveddirname=2012_01_18_01_00_13
						set bat_archiveddirname=%%~nxa

						rem example: bat_archivedbasedir=C:\CAMS\ArchivedFiles
						set bat_archivedbasedir=!bat_targetsearchspec!
					)
				)
			)
		)

		!bat_echolog! '     bat_targetsearchdir=!bat_targetsearchdir!
		!bat_echolog! '     bat_archiveddir=!bat_archiveddir!>>"!bat_logfile!"
		!bat_echolog! '     bat_archiveddirname=!bat_archiveddirname!
		
		rem Example: bat_archiveddate=2012_01_18
		set bat_archiveddate=!bat_archiveddirname:~0,10!

	set bat_archived
!bat_echolog! return-:GETARCHIVEDDIR [!bat_archiveddir!]
%bat_return%


:GETDETECTFILE
!bat_echolog! call :GETDETECTFILE %*
	set bat_detectfile=!bat_archiveddir!\FTPdetectinfo_0!bat_camera!_????_??_??.txt
	if not exist "!bat_detectfile!" (
		set bat_detectfile=!bat_archiveddir!\FTPdetectinfo.txt
	)
	
	for /f "usebackq tokens=*" %%a in (`dir "!bat_detectfile!" /b /a-d /od`) do (
		set bat_detectfile=!bat_archiveddir!\%%~a
		set bat_detectfile3=%%~na
		set bat_detectfile4=%%~nxa
	)

!bat_echolog! return-:GETDETECTFILE [!bat_detectfile!]
%bat_return%


:WAITCAPTUREDETECT
echo :WAITCAPTUREDETECT %*
	echo     WaitForFile rw "!bat_detectfile!"
	         WaitForFile rw "!bat_detectfile!"
	echo.
	echo     "!bat_detectfile!" is ready to use...
	echo.
%bat_return%


:COPYARCHIVED
!bat_echolog! call :COPYARCHIVED %*
	echo     copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"
	         copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"

rem 	echo     move /y "!bat_detectfile!" "!bat_archiveddir!\FTPdetectinfo.txt"
rem 	         move /y "!bat_detectfile!" "!bat_archiveddir!\FTPdetectinfo.txt"

rem 	set bat_detectfile=!bat_archiveddir!\FTPdetectinfo.txt
rem 	set bat_detectfile3=FTPdetectinfo
rem 	set bat_detectfile4=FTPdetectinfo.txt
!bat_echolog! return-:COPYARCHIVED [!bat_detectfile!]
%bat_return%


:POSTCAPTURE
!bat_echolog! call :POSTCAPTURE %*
	set bat_retval=success
	rem set bat_detectfile=!bat_bat_archiveddir!\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	if not exist "!bat_detectfile!" (
		echo.>>"!bat_logfile!"
		echo.
		echo ERROR - "!bat_detectfile!" not found...>>"!bat_logfile!"
		echo ERROR - "!bat_detectfile!" not found...
		echo.>>"!bat_logfile!"
		echo.
		dir "!bat_captureddir!\ftpdetect*.*" /s/b /a-d /od>>"!bat_logfile!"
		dir "!bat_captureddir!\ftpdetect*.*" /s/b /a-d /od
		set bat_retval=postcapture failed
		%bat_return%
	)


	set bat_capturedcount=0
	if exist "!bat_captureddir!\*.bin" (
		for /f "usebackq tokens=*" %%b in (`dir "!bat_captureddir!\*.bin" /a-d /s/b^|find /i /c ".bin"`) do (
			set /a bat_capturedcount=%%~b
		)
	)
	echo     !bat_captureddir!    [Files=!bat_capturedcount!]
	echo.


	set bat_capturedfilesdir=!bat_captureddir!
	set bat_targetdrive=!bat_capturedfilesdir:~0,2!
	set bat_archivedfilesdir=!bat_archiveddir!

	call :READCONFIG
	call :SAVECONFIG
!bat_echolog! return-:POSTCAPTURE [!bat_captureddir!]
%bat_return%




:MULTISCAN
echo :MULTISCAN
rem set bat_targetsearchspec=!bat_targetsearchspec!\2011_12_22_01_31_3?
set bat_targetsearchspec
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b`^) do...>>!bat_logfile!"
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_targetsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo bat_targetsearchdir=%%~a>>"!bat_logfile!"
					 set bat_targetsearchdir=%%~a

					echo bat_captureddir=%%~a>>"!bat_logfile!"
					 set bat_captureddir=%%~a
					 set bat_captureddate=%%~nxa
					 set bat_captureddate=!bat_captureddate:~0,10!

					set bat_targetcount=0
					if exist "%%~a\*.bin" (
						for /f "usebackq tokens=*" %%b in (`dir "%%~a" /a-d /s/b^|find /i /c ".bin"`) do (
							set /a bat_targetcount=%%~b
						)
					)
					echo     !bat_captureddir!    [Files=!bat_targetcount!]
				)
			)
		)
	)
	echo.
	
	set bat_capturedfilesdir=!bat_captureddir!
	set bat_targetdrive=!bat_capturedfilesdir:~0,2!
	set bat_archivedfilesdir=!bat_archiveddir!
	call :READCONFIG
	call :SAVECONFIG

:MAKERERUNFILE
	echo.>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo @echo off>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo setlocal enableextensions enabledelayedexpansion>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	for /f "usebackq tokens=*" %%a in (`set`) do (
		echo set %%~a>>"!bat_captureddir!\rerun_makeCaseListing.bat"
	)
	echo call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!">>"!bat_captureddir!\rerun_makeCaseListing.bat"
	echo call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!">>"!bat_logfile!"
	echo call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!"
	     call "!bat_exedir!\makeCaseListing.bat" "!bat_captureddir!"

	
%bat_return%



:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo :WAITFORMULTISCAN Waiting 60 seconds for makeCaseListing.bat to finish
	start /w wait 60

	set bat_archivedsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles\!bat_captureddate!*.*
set bat_archivedsearchspec
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedsearchspec!" /ad /s/b`^) do...>>!bat_logfile!"
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedsearchspec!" /ad /s/b`^) do...
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_archivedsearchspec!" /ad /s/b`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					echo bat_archiveddir=%%~a>>"!bat_logfile!"
					set bat_archiveddir=%%~a
					set bat_archivedfilesdir=%%~a
				)
			)
		)
	)

	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archiveddir!\ftpdetectinfo_Case???.txt" /s/b /a-d`) do (
		echo call WaitForFile rw "%%a"
		     call WaitForFile rw "%%a"
		echo.
		echo     FINISHED with: "%%a"
	)

:MERGE
	echo call "!bat_exedir!\MergeClassFiles.bat" "!bat_archiveddir!"
	     call "!bat_exedir!\MergeClassFiles.bat" "!bat_archiveddir!"
%bat_return%


:CAMSMENU
	call :SAVECONFIG
	echo start CamsMenu.bat>>"!bat_logfile!"
	echo start CamsMenu.bat
	     start CamsMenu.bat
%bat_return%


:POSTMULTISCAN
	echo call PostMultiScanCalibration.bat "!bat_archiveddir!">>"!bat_logfile!"
	echo call PostMultiScanCalibration.bat "!bat_archiveddir!"
	     call PostMultiScanCalibration.bat "!bat_archiveddir!"
%bat_return%


:READCONFIG
!bat_echolog! call :READCONFIG %*
	set bat_configfile=!bat_exedir!\CamsMenu.bat.ini
	if defined bat_autonomous (
		set bat_configfile=!bat_exedir!\AutoCams.bat.ini
		!bat_echolog! 
	)
	
	rem echo [CAMSMENU]^>"!bat_configfile!"
	rem call readini "!bat_configfile!" "CAMSMENU" "bat_targetlocation"
	rem echo bat_targetlocation=!bat_targetlocation!^>^>"!bat_configfile!"
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_camera"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_camera"
		set bat_camera_config=!RetVal1!
	rem echo bat_captureddate=!bat_captureddate!^>^>"!bat_configfile!"
	rem echo bat_capturedfilesdir=!bat_capturedfilesdir!^>^>"!bat_configfile!"
	rem echo bat_archivedfilesdir=!bat_archivedfilesdir!^>^>"!bat_configfile!"
	rem echo bat_capturedcount=!bat_capturedcount!^>^>"!bat_configfile!"
	rem echo bat_archivedcount=!bat_archivedcount!^>^>"!bat_configfile!"
	rem echo bat_latestcal=!bat_latestcal!^>^>"!bat_configfile!"
	rem echo bat_submissionfilesdir=!bat_submissionfilesdir!^>^>"!bat_configfile!"
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftppassword"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftppassword"
		set bat_ftppassword=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpsite"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpsite"
		set bat_ftpsite=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpuser"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpuser"
		set bat_ftpuser=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpdir"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpdir"
		set bat_ftpdir=!RetVal1!
!bat_echolog! return-:READCONFIG [!bat_capturedfilesdir!]
%bat_return%


:SAVECONFIG
!bat_echolog! call :SAVECONFIG %*
	set bat_configfile=!bat_exedir!\CamsMenu.bat.ini
	if defined bat_autonomous (
		set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	)

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"

	set bat_capturedcount=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_captureddir!\*.bin"^|find /i /c ".bin"`) do (
		set bat_capturedcount=%%~a
	)
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	set bat_archivedcount=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\*.bin"^|find /i /c ".bin"`) do (
		set bat_archivedcount=%%~a
	)
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=>>"!bat_configfile!"
	echo bat_submissionfilesdir=>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
!bat_echolog! return-:SAVECONFIG [!bat_capturedfilesdir!]
%bat_return%



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b 0



:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp= %*
	
	set bat_echolog_temp=%bat_echolog_temp:~1,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=%*
	
	if /i "%*" equ "'" (
		echo.>>"!bat_logfile!"
		%bat_return%
	)
	
		set bat_echolog_temp= %bat_echolog_temp:~2,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%




:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     %~n0 can be run by double-clicking on the program from 
    echo     Windows or from a command line.
    echo.
    echo     Starting it from Windows, it will run it in interactive mode 
    echo     where it will prompt the user for the camera number and the 
    echo     duration of the capture in hours.  
    echo.
    echo     If the duration entered is zero, then the user is prompted to 
    echo     manually start and stop the capture process.  If the duration 
    echo     is greater than zero, the program automatically starts the 
    echo     capture and stops after the designated time has elapsed. 
    echo.
    echo     If you run it from a command shell or batch script, you 
    echo     can specify the camera number and duration as command-line 
    echo     arguments.  If the command-line arguments don't provide all 
    echo     the necessary parameters, the missing parameters will be 
    echo     prompted for.
    echo.
    echo     Usage: %~nx0 [SCANMODE] [cameranumber] [duration] ["targetdirectory"] [autonomous] [/?]
    echo.
    echo     Examples:
    echo         CaptureAndDetect
    echo                                          The user is prompted for 
    echo                                          camera number, duration, 
    echo                                          and base target dir.
    echo.
    echo         CaptureAndDetect 2 299                  The user is prompted for 
    echo                                          capture duration and base 
    echo                                          target dir.
    echo.
    echo         CaptureAndDetect 2 299 0.0              The user is prompted for 
    echo                                          for the base target dir and
    echo                                          prompted to start and stop. 
    echo.
    echo         CaptureAndDetect 2 299 9.5              The user is prompted for 
    echo                                          the base target dir. 
    echo.
    echo         CaptureAndDetect 2 299 9.5 "h:\2011"   The capture for camera 299
    echo                                          starts and runs for 9 hrs  
    echo                                          and 30 mins and saves the
    echo                                          data to a directory like:
    echo                      h:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05
    echo.
    echo     Note: Directory names should be surrounded by quotes.
    echo.
    echo     A folder is created for saving the FF files based on the date and 
    echo     universal time (UTC) at the start of the capture.  The higher level 
    echo     directory is always user specified and the \CAMs\CapturedFiles\ is 
    echo     appended along with the start date and time.  For example, a 
    echo     capture that starts on Aug 14, 2011, 5:11:05 UTC and the target 
    echo     directory specified was "C:", the target directory would be created 
    echo     as C:\CAMS\CapturedFiles\2011_08_14_05_11_05.  If the target dir
    echo     of "D:\2011" is specified, the target directory would be created as:
    echo     C:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05.  
    echo.
    echo     AUTONOMOUS mode:
    echo       You have the option to run capture in autonomous mode. In 
	echo       autonomous mode, it will complete the capture, perform a
	echo       automatic Meteor Cal Update, Apply the Cal to the detect
	echo       file, run the submission script, create a zip file, and 
	echo       (in the future, upload the zip file to the ftp server).
    echo.    
EXIT /b 9
    
goto :DONE


:DONE
	echo END OF %~nx0  ******  %date% %time%>>"!bat_logfile!"
	if /i "!bat_anonymous!" equ "anonymous" (
		AutoCams.bat
	) else (
		exit
	)
