  @echo off
	setlocal enableextensions enabledelayedexpansion


:SETUP
	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!


    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	set bat_return=goto :EOF

	set bat_logfile=%~0.log
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG
	!bat_echolog!
	!bat_echolog!
	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! [%date% %time%] %~0 %*
	!bat_echolog!


    call :READPARAMS
   
	set bat_CD_flag=%~1
	set bat_CAPTURE.cameralist=%~2
	set bat_duration=%~3
	set bat_targetlocation=%~4
	set bat_savetargetlocation=%~4

	set bat_autonomous=
	if /i "%~5" equ "autonomous" (
		set bat_autonomous=autonomous
	)
	if /i "%~5" equ "auto" (
		set bat_autonomous=autonomous
	)
	
	set bat_testmode=
    echo.%*|find /i "/testmode">nul:
    if %errorlevel% equ 0 (
    	set bat_testmode=testmode
    )
    
    call :SETCAPTUREEXE
	
goto :MAIN %*



:MAIN
!bat_echolog! goto :MAIN %*
	rem call :CURDATETIME %*
	call :PRECAPTURE %*
	call :LAUNCHCAPTURE %*
	if "!bat_returncode!" neq "0" (goto :MAIN_END)
	set bat_runautocams=
	call :GETCAPTUREDIR %*
	if "!bat_retval!" equ "failed" (
		goto :MAIN_END
	)

	if /i "!bat_CAPTURE.archive_flag!" equ "-1" (
		call :REPROCESSMULTI
		call :GETARCHIVEDDIR %*
		call :WAITFORMULTISCAN %*
		call :MERGECASE %*
	) else (
		call :GETARCHIVEDDIR %*
		call :WAITFORMULTISCAN %*
	)

	set bat_runautocams=!bat_retval!
	call :GETDETECTFILE %*
	call :WAITFORMULTISCAN %*
	call :COPYARCHIVED %*

	call :POSTCAPTURE %*
	if /i "!bat_retval!" neq "postcapture success" (goto :DONE)

	!bat_echolog! '    AutoCams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous
					   AutoCams.bat "!bat_capturedfilesdir!" "!bat_archivedfilesdir!" !bat_camera! autonomous

:MAIN_END
!bat_echolog! end-:MAIN
goto :DONE





:PRECAPTURE
%bat_echolog% call :PRECAPTURE %*
	rem [in]	
	rem [out]	bat_precaptureddir
	rem [out]	bat_precaptureddirarch

	rem Only do this if the [CAPTURE] simulation is set
	if /i "!bat_CAPTURE.simulation!" equ "true" (
		!bat_echolog! '    Simulating Capture and Detect by removing the test dirs...
		!bat_echolog! '    del /q "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
						   del /q "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
						   rd /q "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
		!bat_echolog! '    del /q "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"
						   del /q "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"
						   rd /q "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"
rem		set /p bat_choice=Check the ArchivedFiles and CapturedFiles dirs... 
	)

	rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
	rem ordered ascending by date. The last one will be the one BEFORE the next one
	rem created by the FTP_Capture... executable (for comparison later).

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	set bat_precaptureddir=
	!bat_echolog! '     for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for                     /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
							 set bat_precaptureddir=!bat_targetsearchspec!\%%~a
				)
			)
		)
	)

	if not defined bat_precaptureddir (set bat_precaptureddir= )


	rem Iterate through the list of !bat_targetlocation!\CAMS\ArchivedFiles directories, 
	rem ordered ascending by date. The last one will be the one BEFORE the next one
	rem created by the FTP_CaptureXxxDetect... executable (for comparison later).

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles
	set bat_precaptureddirarch=
	!bat_echolog! '     for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for                     /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
							 set bat_precaptureddirarch=!bat_targetsearchspec!\%%~a
				)
			)
		)
	)

	if not defined bat_precaptureddirarch (set bat_precaptureddirarch= )
		

:PRECAPTURE_END
!bat_echolog! return-:PRECAPTURE [bat_precaptureddir="!bat_precaptureddir!", bat_precaptureddirarch="!bat_precaptureddirarch!"] %*
!bat_return!






:LAUNCHCAPTURE
!bat_echolog! call :LAUNCHCAPTURE %*
	rem [in]	
	rem [out]	bat_returncode
	rem [out]	bat_entervideodevice
	rem [uses]	bat_CAPTURE.capture_mode
	
	set bat_returncode=1

	if /i "!bat_CAPTURE.capture_mode!" equ "capturetwoanddetect" (
		CALL :LAUNCH_DUAL_CAPTURE %*
		goto :LAUNCHCAPTURE2
	)

	!bat_echolog!
	!bat_echolog! '    Killing any existing FTP_CaptureTwoAndDetect.exe processes that might be running...
	!bat_echolog! '    [%date% %time%] - calling process -k !bat_captureexe!
	for /f "usebackq tokens=*" %%a in (`call process -k !bat_captureexe!`) do (
		!bat_echolog! '      %%a
	)

	rem Copies the EXE file to a name that matches the instance 
	if /i "!bat_CAPTURE.capture_mode!" NEQ "capturetwoanddetect" (
		rem copy "!bat_captureexesrc!" "!bat_captureexe!"
		call :COPYEXE
	)

	!bat_echolog!
	!bat_echolog! '    Starting !bat_captureexe!...
	!bat_echolog! '    [%date% %time%] "!bat_captureexe! start" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_duration! !bat_targetlocation!
	            title "[%date% %time%]  !bat_captureexe! start" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_duration! !bat_targetlocation!
rem goto :LAUNCHCAPTURE2
	!bat_echolog! '    set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_duration! !bat_targetlocation!
	                   set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_duration! !bat_targetlocation!

	rem Determine if an input file is needed to answer the input question in case
	rem there are multiple video inputs
	set bat_entervideodevice=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\entervideodevice*.inp" /a-d /b`) do (
		set bat_entervideodevice=%%a
	)

	rem Only do this if the [CAPTURE] simulation is set
	if /i "!bat_CAPTURE.simulation!" equ "true" (
		!bat_echolog! '    md "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
						   md "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
		!bat_echolog! '   copy /y "c:\d\2012_08_11_03_44_55" "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
		for /f "usebackq tokens=*" %%a in (`copy /y "c:\d\2012_08_11_03_44_55" "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"`) do (
			!bat_echolog! '      %%a
		)

		if /i "!bat_CAPTURE.archive_flag!" neq "-1" (
			!bat_echolog!
			!bat_echolog! '    Simulating Capture WITH Detect...
			!bat_echolog! '    md "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"
							   md "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"
			!bat_echolog! '    copy /y "c:\d\2012_08_11_archive\2012_08_11_08_30_39" "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"
			for /f "usebackq tokens=*" %%a in (`copy /y "c:\d\2012_08_11_archive\2012_08_11_08_30_39" "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"`) do (
				!bat_echolog! '      %%a
			)
		)
	)

	if not defined bat_entervideodevice (
		!bat_echolog! '    !bat_launchcommand!
		rem Only do this if the [CAPTURE] simulation is set
		if /i "!bat_CAPTURE.simulation!" neq "true" (
						   !bat_launchcommand!
							set bat_returncode=!errorlevel!
		)
	) else (
	     !bat_echolog! '    !bat_launchcommand!{"!bat_exedir!\!bat_entervideodevice!"
		rem Only do this if the [CAPTURE] simulation is set
		if /i "!bat_CAPTURE.simulation!" neq "true" (
	                        !bat_launchcommand!<"!bat_exedir!\!bat_entervideodevice!"
							set bat_returncode=!errorlevel!
	    )& rem simulation
	                        
	)& rem if not defined bat_entervideodevice
	
	if /i "!bat_returncode!" neq "0" (
		call "!bat_exedir!\ProcessCaptureReturnCode.bat"
		!bat_echolog! '    ERROR - !bat_recent_error_msg!
	)
	
	!bat_echolog! '    call "!bat_exedir!\ProcessCaptureReturnCode.bat"
	                   call "!bat_exedir!\ProcessCaptureReturnCode.bat"


:LAUNCHCAPTURE2
	!bat_echolog! ________________________________________________________________________
	!bat_echolog! ________________________________________________________________________
	!bat_echolog! ________________________________________________________________________
	!bat_echolog! [%date% %time%] END !bat_launchcommand!

	
:LAUNCHCAPTURE_END
!bat_echolog! return-:LAUNCHCAPTURE [bat_returncode=!bat_returncode!]
rem		set /p bat_choice=Check the ArchivedFiles and CapturedFiles dirs... 
pause
%bat_return%



:LAUNCH_DUAL_CAPTURE
	!bat_echolog! call :LAUNCH_DUAL_CAPTURE [%*]

	rem [in]	
	rem [out]	bat_returncode
	rem [out]	bat_entervideodevice
	rem [uses]	bat_CAPTURE.capture_mode

	!bat_echolog!
	!bat_echolog! '    Killing any existing FTP_CaptureTwoAndDetect.exe processes that might be running...
	!bat_echolog! '    [%date% %time%] - calling process -k !bat_captureexe!
	for /f "usebackq tokens=*" %%a in (`call process -k !bat_captureexe!`) do (
		!bat_echolog! '      %%a
	)


	!bat_echolog!
	!bat_echolog! '    Starting !bat_captureexe!...
	!bat_echolog! '    [%date% %time%] "!bat_captureexe! start" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_duration! !bat_targetlocation!
	            title "[%date% %time%]  !bat_captureexe! start" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_duration! !bat_targetlocation!

	!bat_echolog! '    set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_duration! !bat_targetlocation!
	                   set bat_launchcommand=call "!bat_exedir!\!bat_captureexe!" !bat_CD_flag! !bat_CAPTURE.cameralist! !bat_duration! !bat_targetlocation!

	rem Determine if an input file is needed to answer the input question in case
	rem there are multiple video inputs
	set bat_entervideodevice=
	if exist "!bat_exedir!\entervideodevice*.inp" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_exedir!\entervideodevice*.inp" /a-d /b`) do (
			set bat_entervideodevice=%%a
		)
	)


	if not defined bat_entervideodevice (
		!bat_echolog! '     Not using: [entervideodevice*.inp]
						    
		!bat_echolog! '    !bat_launchcommand!
		
		rem Only do this if the [CAPTURE] simulation is set
		if /i "!bat_CAPTURE.simulation!" equ "true" (
			!bat_echolog! '    md "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
							   md "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
			!bat_echolog! '    md "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"
							   md "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"

			!bat_echolog!
			!bat_echolog! '    Simulating capture...
			!bat_echolog! '    copy /y "c:\d\2012_08_11_03_44_55" "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"
			for /f "usebackq tokens=*" %%a in (`copy /y "c:\d\2012_08_11_03_44_55" "c:\d\CAMS\CapturedFiles\2012_08_11_03_44_55"`) do (
				!bat_echolog! '      %%a
			)
			!bat_echolog!
			!bat_echolog! '    Simulating detect...
			!bat_echolog! '    copy /y "c:\d\2012_08_11_archive\2012_08_11_08_30_39" "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"
			for /f "usebackq tokens=*" %%a in (`copy /y "c:\d\2012_08_11_archive\2012_08_11_08_30_39" "c:\d\CAMS\ArchivedFiles\2012_08_11_08_30_39"`) do (
				!bat_echolog! '      %%a
			)
		)& rem simulation

		rem Only do this if the [CAPTURE] simulation is NOT set
		if /i "!bat_CAPTURE.simulation!" neq "true" (
						   !bat_launchcommand!
		)

		set bat_returncode=!errorlevel!
	) else (
		!bat_echolog! '     Using: [!bat_entervideodevice!]

	     !bat_echolog! '    !bat_launchcommand!{"!bat_exedir!\!bat_entervideodevice!"
		if /i "!bat_CAPTURE.simulation!" neq "true" (
	                        !bat_launchcommand!<"!bat_exedir!\!bat_entervideodevice!"
		)& rem simulation
	                        
	     set bat_returncode=!errorlevel!
	)& rem if not defined bat_entervideodevice
	
	if /i "!bat_returncode!" neq "0" (
		!bat_echolog! '    call "!bat_exedir!\ProcessCaptureReturnCode.bat"
						   call "!bat_exedir!\ProcessCaptureReturnCode.bat"
	)

:LAUNCH_DUAL_CAPTURE_END
!bat_echolog! return-:LAUNCH_DUAL_CAPTURE_END [bat_returncode=!bat_returncode!]
!bat_return!



:GETCAPTUREDIR [in] %* 
	rem [out]	bat_retval
	rem [out]	bat_captureddir
	rem [out]	bat_captureddate
	rem [out]	bat_capturedbasedir
	rem [out]	

	!bat_echolog! call :GETCAPTUREDIR %*
	set bat_retval=failed
	rem This section is attempting to determine the directory name that 
	rem FTP_CaptureTwoAndDetect.exe created.  
	rem It looks at all the subdirs of the CaptureFiles dir in date order.  The last 
	rem one in the list should be the most recent FTP_CaptureAndDetect directory.

	rem Iterate through the list of !bat_targetlocation!\CAMS\CapturedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe program.  Careful, there is a chance that it didn't 
	rem create a directory at all and you'd be choosing the wrong dir. Compare with 
	rem bat_precaptureddir to protect against that. 

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	set bat_targetsearchdir=
	set bat_captureddir=
	set bat_captureddirname=
	set bat_capturedbasedir=
	set bat_captureddate=
	!bat_echolog! '    for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
		if /i "%%~nxa" neq "movies" (
			if /i "%%~nxa" neq "displayJPEGS" (
				if /i "%%~nxa" neq "gefdat" (
					rem Example: bat_captureddir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					set bat_captureddir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_captureddirname=2012_01_18_01_00_13
					set bat_captureddirname=%%~nxa

					rem Example: bat_targetsearchdir=C:\CAMS\CapturedFiles\2012_01_18_01_00_13
					set bat_targetsearchdir=!bat_targetsearchspec!\%%~a

					rem example: bat_capturedbasedir=C:\CAMS\CapturedFiles
					set bat_capturedbasedir=%%~dpa::
					set bat_capturedbasedir=!bat_capturedbasedir:\::=!
					set bat_capturedbasedir=!bat_capturedbasedir:::=!
				)
			)
		)
	)

	!bat_echolog! '    if not defined bat_captureddir ^(
	if not defined bat_captureddir (
		!bat_echolog!
		!bat_echolog! '    ERROR - Capture did not produce a new directory. Interpreting that as a
		!bat_echolog! '    capture failure or manual abort. 
		goto :GETCAPTUREDIR_END
	)
	
	!bat_echolog! '    if /i "!bat_captureddir!" equ "!bat_precaptureddir!" ...
	if                    /i "!bat_captureddir!" equ "!bat_precaptureddir!" (
		!bat_echolog!
		!bat_echolog! '    ERROR - Capture did not produce a new directory. Interpreting that as a
		!bat_echolog! '    capture failure. 

		set bat_targetsearchdir=
		set bat_captureddir=
		set bat_captureddirname=
		set bat_capturedbasedir=
		set bat_captureddate=

		goto :GETCAPTUREDIR_END
	) else (
		set bat_retval=!bat_captureddir!
		set bat_capturedfilesdir=!bat_captureddir!
		!bat_echolog!
		!bat_echolog! '    bat_captureddir=!bat_captureddir!
		!bat_echolog! '    bat_capturedfilesdir=!bat_capturedfilesdir!
		!bat_echolog! '    bat_captureddirname=!bat_captureddirname!
		!bat_echolog! '    bat_targetsearchdir=!bat_targetsearchdir!


		rem Example: bat_captureddate=2012_01_18
		set bat_captureddate=!bat_captureddirname:~0,10!
		set bat_captureddatetime=!bat_captureddirname:~0,19!

		set bat_cap>>"!bat_logfile!"
	)
	
:GETCAPTUREDIR_END
!bat_echolog! return-:GETCAPTUREDIR [!bat_retval!, bat_captureddir=!bat_captureddir!, bat_captureddate=!bat_captureddate!]
%bat_return%






:REPROCESSMULTI
	!bat_echolog! call :REPROCESSMULTI %*
	!bat_echolog!

	!bat_echolog! '    call "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"
	                   call "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"
	set bat_returncode=!errorlevel!
	
	start /w wait 15

:REPROCESSMULTI_END
!bat_echolog! return-REPROCESSMULTI [!bat_returncode!, !bat_capturedfilesdir!]
%bat_return%



:GETARCHIVEDDIR [out] bat_archiveddir
	!bat_echolog! call :GETARCHIVEDDIR %*

	rem This section is attempting to determine the directory name that FTP_CaptureAndDetect.exe
	rem created for ArchivedFiles.  

	rem This FOR loop will complete with the newest directory with the specified date
	rem as the prefix.  Even if there are multiple directories with the same date, the 
	rem newest one be contained in resulting value of bat_archiveddir.

	set bat_targetsearchspec=!bat_targetlocation!\CAMS\ArchivedFiles

	rem Iterate through the list of !bat_targetlocation!\CAMS\ArchivedFiles directories, 
	rem ordered ascending by date. The last one will be the one created by the 
	rem FTP_CaptureAndDetect.exe program.  CAREFUL, there is a chance that
	rem there is no matching ArchivedFiles dir. 

	set bat_targetsearchdir=
	set bat_archiveddir=
	set bat_archiveddirname=
	set bat_archivedbasedir=
	set bat_archiveddate=
	!bat_echolog! '    for /f "usebackq tokens=*" ..a in ^(`dir "!bat_targetsearchspec!" /ad /b /od`^) do...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_targetsearchspec!" /ad /b /od`) do (
	if /i "%%~nxa" neq "movies" (
		if /i "%%~nxa" neq "displayJPEGS" (
			if /i "%%~nxa" neq "gefdat" (
					set bat_temp=%%~nxa

					rem Example: bat_archiveddir=C:\CAMS\ArchivedFiles\2012_01_18_01_00_13
					set bat_archiveddir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_archiveddirname=2012_01_18_01_00_13
					set bat_archiveddirname=%%~nxa

					rem Example: bat_targetsearchdir=C:\CAMS\ArchivedFiles\2012_01_18_01_00_13
					set bat_targetsearchdir=!bat_targetsearchspec!\%%~nxa

					rem example: bat_archivedbasedir=C:\CAMS\ArchivedFiles
					set bat_archivedbasedir=!bat_targetsearchspec!
					
					set bat_archiveddate=!bat_temp:~0,10!
				)
			)
		)
	)

	!bat_echolog! '    if not defined bat_archiveddir ^(
	if                    not defined bat_archiveddir (
		if /i "!bat_CD_flag!" neq "-1" (
			!bat_echolog!
			!bat_echolog! '    WARNING - Capture did not produce a new ArchivedFiles directory.
			!bat_echolog! '            Interpreting that as a capture failure or manual abort. 
		)
	)

	!bat_echolog! '    if /i "!bat_archiveddir!" equ "!bat_precaptureddirarch!" ^(
	if                    /i "!bat_archiveddir!" equ "!bat_precaptureddirarch!" (
		if /i "!bat_archiveddate!" neq "!bat_captureddate!" (
			!bat_echolog!
			!bat_echolog! '    ERROR - Capture did not produce a new ArchivedFiles directory.
			!bat_echolog! '            Interpreting that as a capture failure or manual abort. 

			set bat_targetsearchdir=
			set bat_archiveddir=
			set bat_archiveddirname=
			set bat_archivedbasedir=
			set bat_archiveddate=
			goto :GETARCHIVEDDIR_END
		)
	)

	set bat_retval=!bat_archiveddir!
	rem Example: bat_archiveddate=2012_01_18
	set bat_archiveddate=!bat_archiveddirname:~0,10!
	set bat_archiveddatetime=!bat_archiveddirname:~0,19!
	set bat_archivedfilesdir=!bat_archiveddir!

	!bat_echolog!
	!bat_echolog! '    bat_targetsearchdir=!bat_targetsearchdir!
	!bat_echolog! '    bat_archiveddir=!bat_archiveddir!
	!bat_echolog! '    bat_archivedfilesdir=!bat_archivedfilesdir!
	!bat_echolog! '    bat_archiveddirname=!bat_archiveddirname!
	!bat_echolog! '    bat_archiveddate=!bat_archiveddate!
	!bat_echolog! '    bat_archiveddatetime=!bat_archiveddatetime!

	

:GETARCHIVEDDIR_END
!bat_echolog! return-:GETARCHIVEDDIR [bat_archiveddir=!bat_archiveddir!]
%bat_return%




:WAITFORMULTISCAN
	!bat_echolog! call :WAITFORMULTISCAN %*
	!bat_echolog! '    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`^) do ...
	for                    /f "usebackq tokens=*" %%a in  (`dir "!bat_archivedfilesdir!\FTPdetectinfo_case???.txt" /b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "!bat_archivedfilesdir!\%%~nxa"
		echo     call WaitForFile rw "!bat_archivedfilesdir!\%%~nxa"
		for /f "usebackq tokens=*" %%a in (`call WaitForFile rw "!bat_archivedfilesdir!\%%~nxa"`) do (
			!bat_echolog! '      %%a
		)
	)
	!bat_echolog!

:WAITFORMULTISCAN_END
!bat_echolog! return-:WAITFORMULTISCAN [!bat_archivedfilesdir!]
%bat_return%





:MERGECASE
!bat_echolog! call :MERGECASE [%*]
	if not defined bat_archivedfilesdir (
		!bat_echolog! '    ERROR - Not defined: bat_archivedfilesdir
		goto :MERGECASE_END
	)
	
	!bat_echolog! '    call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archivedfilesdir!"
	                   call "!bat_exedir!\MergeCaseFiles.bat" "!bat_archivedfilesdir!"
	set bat_returncode=!errorlevel!

	set bat_temp=
	set bat_detectfile=
	if exist ""!bat_archivedfilesdir!\FTPdetectinfo_0???*.txt"" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\FTPdetectinfo_0???*.txt" /b /a-d /od`) do (
			set bat_detectfile=!bat_archivedfilesdir!\%%a
		)
	)
	
	rem Get latest cal file
	set bat_latestcal=
	if defined bat_detectfile (
		for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_detectfile!"`) do (
			if not defined bat_latestcal ( set bat_latestcal=%%a )
		)
	)

:MERGECASE_END
	set bat_temp=
	!bat_echolog! return-:MERGECASE [bat_detectfile=!bat_detectfile!]
%bat_return%





:GETDETECTFILE
	!bat_echolog! call :GETDETECTFILE %*

	set bat_detectfile=
	rem Iterate through all the FTPdetectinfo files in the archivedfiles dir by date/time.
	rem Problem is, it may not have produced a new detect file... 
	rem
	rem CAUTION: You must remember that there are several kinds of detect files that
	rem          could exist:
	rem            FTPdetectinfo_02130216_2012_08_13.txt (from FTP_CaptureTwoAndDetect.exe)
	rem            FTPdetectinfo_02130216_2012_08_13_04_13_59.txt (from newer scripts)
	rem            FTPdetectinfo_0213_2012_08_13_04_13_59.txt (from newer scripts)
	rem            FTPdetectinfo_0213_2012_08_13.txt (from older scripts)
	rem            FTPdetectinfo.txt (from real old exe and scripts)
	if exist "!bat_archiveddir!\FTPdetectinfo*.txt" (
		for /f "usebackq tokens=*" %%a in (`dir "!bat_archiveddir!\FTPdetectinfo_0*.txt" /b /a-d /od`) do (
			set bat_temp=%%~nxa

			rem Skip if it's a conincidence file
			if /i "!bat_temp!" neq "FTPdetectinfoCoinc.txt" (

				rem Skip if it's from FTP_ApplyCal2detectinfo.exe
				if /i "!bat_temp:~-5" neq "C.txt" (
					set bat_detectfile=!bat_archiveddir!\%%~nxa
					set bat_detectfile3=%%~na
					set bat_detectfile4=%%~nxa
				)
			)
		)
	)

	if not defined bat_detectfile (
		!bat_echolog! '    ERROR - Unable to locate detect file.
		goto :GETDETECTFILE_END
	)

	if not exist "!bat_detectfile!" (
		!bat_echolog! '    ERROR - Unable to locate detect file.
		goto :GETDETECTFILE_END
	)
	
:GETDETECTFILE_END
!bat_echolog! return-:GETDETECTFILE [bat_detectfile=!bat_detectfile!]
%bat_return%




:WAITCAPTUREDETECT
echo :WAITCAPTUREDETECT %*
	rem if bat_detectilfe isnt defined, then we need to run MakeCaseListing
	
	if not defined bat_detectfile (
		call :STARTDETECT
		call :GETARCHIVEDIR
		call :GETDETECTFILE
	)

	if not exist "!bat_detectfile!" (
		!bat_echolog! '    ERROR - No detect file
		goto :WAITCAPTUREDETECT_END
	)
	
	echo     WaitForFile rw "!bat_detectfile!"
	for /f "usebackq tokens=*" %%a in (`WaitForFile rw "!bat_detectfile!"`) do (
		!bat_echolog! '      %%a
	)
	echo.
	echo     "!bat_detectfile!" is ready to use...
	echo.

:WAITCAPTUREDETECT_END
%bat_return%



:STARTDETECT
!bat_echolog! call :STARTDETECT [%*]
	!bat_echolog! '    call "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"
	                   call "!bat_exedir!\makeCaseListing.bat" "!bat_capturedfilesdir!"

:STARTDETECT_END [%*]
!bat_return!




	rem This is done because we use the "bat_CAPTURE.archive_flag" using
	rem the "move" option.  With the "move" option, when detect is complete,
	rem the .bin files are moved to the archivedfiles dir to save on
	rem I/O and CPU usage.  Therefore, in order to restore the capturedfiles
	rem dir so that it contains a complete list of all captured files 
	rem (in case detection needs to be re-run), the detected files are 
	rem copied back to the capturedfiles dir.
:COPYARCHIVED
!bat_echolog! call :COPYARCHIVED %*
	echo     copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"
	for /f "usebackq tokens=*" %%a in (`copy /y "!bat_archiveddir!\*.bin" "!bat_captureddir!"`) do (
		!bat_echolog! '      %%a
	)
	set bat_returncode=!errorlevel!
	
	set bat_retval=failed
	if !bat_returncode! equ 0 (
		set bat_retval=success
	)

:COPYARCHIVED_END
!bat_echolog! return-:COPYARCHIVED [!bat_retval!]
%bat_return%






	rem Get values to store into AutoCams.bat.ini
:POSTCAPTURE
!bat_echolog! call :POSTCAPTURE %*
	set bat_retval=postcapture success

	if not exist "!bat_detectfile!" (
		!bat_echolog! '    "!bat_logfile!"
		!bat_echolog!
		!bat_echolog! '    ERROR - detect file "!bat_detectfile!" not found...
		!bat_echolog!
		dir "!bat_archiveddir!\ftpdetect*.*" /s/b /a-d /od>>"!bat_logfile!"
		dir "!bat_archiveddir!\ftpdetect*.*" /s/b /a-d /od
		set bat_retval=postcapture failed
		goto :POSTCAPTURE_END
	)

	set bat_capturedcount=0
	if exist "!bat_captureddir!\*.bin" (
		!bat_echolog! '    for /f "usebackq tokens=*" %%b in ^(`dir "!bat_captureddir!\*.bin" /a-d /s/b^|find /i /c ".bin"`^) do ^(
		for                    /f "usebackq tokens=*" %%b in  (`dir "!bat_captureddir!\*.bin" /a-d /s/b^|find /i /c ".bin"`) do (
			set /a bat_capturedcount=%%~b
		)
	)
	!bat_echolog! '    [File count=!bat_capturedcount!]    !bat_captureddir!
	!bat_echolog!

	set bat_capturedfilesdir=!bat_captureddir!
	set bat_targetdrive=!bat_capturedfilesdir:~0,2!
	set bat_archivedfilesdir=!bat_archiveddir!

	call :READCONFIG
	call :SAVECONFIG

:POSTCAPTURE_END
!bat_echolog! return-:POSTCAPTURE [!bat_retval!, !bat_captureddir!]
!bat_return!














:READCONFIG
!bat_echolog! call :READCONFIG %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	if defined bat_autonomous (
		set bat_configfile=!bat_exedir!\AutoCams.bat.ini
		!bat_echolog! 
	)
	
	rem echo [CAMSMENU]^>"!bat_configfile!"
	rem call readini "!bat_configfile!" "CAMSMENU" "bat_targetlocation"
	rem echo bat_targetlocation=!bat_targetlocation!^>^>"!bat_configfile!"
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_camera"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_camera"
		set bat_camera_config=!RetVal1!
	rem echo bat_captureddate=!bat_captureddate!^>^>"!bat_configfile!"
	rem echo bat_capturedfilesdir=!bat_capturedfilesdir!^>^>"!bat_configfile!"
	rem echo bat_archivedfilesdir=!bat_archivedfilesdir!^>^>"!bat_configfile!"
	rem echo bat_capturedcount=!bat_capturedcount!^>^>"!bat_configfile!"
	rem echo bat_archivedcount=!bat_archivedcount!^>^>"!bat_configfile!"
	rem echo bat_latestcal=!bat_latestcal!^>^>"!bat_configfile!"
	rem echo bat_submissionfilesdir=!bat_submissionfilesdir!^>^>"!bat_configfile!"
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftppassword"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftppassword"
		set bat_ftppassword=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpsite"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpsite"
		set bat_ftpsite=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpuser"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpuser"
		set bat_ftpuser=!RetVal1!
		echo call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpdir"
		     call readini.bat "!bat_configfile!" "CAMSMENU" "bat_ftpdir"
		set bat_ftpdir=!RetVal1!
!bat_echolog! return-:READCONFIG [!bat_capturedfilesdir!]
%bat_return%


:SAVECONFIG
!bat_echolog! call :SAVECONFIG %*
	set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	if defined bat_autonomous (
		set bat_configfile=!bat_exedir!\AutoCams.bat.ini
	)

	echo [CAMSMENU]>"!bat_configfile!"
	echo bat_targetlocation=!bat_targetlocation!>>"!bat_configfile!"
	echo bat_camera=!bat_camera!>>"!bat_configfile!"
	echo bat_captureddate=!bat_captureddate!>>"!bat_configfile!"
	echo bat_capturedfilesdir=!bat_capturedfilesdir!>>"!bat_configfile!"
	echo bat_archivedfilesdir=!bat_archivedfilesdir!>>"!bat_configfile!"

	set bat_capturedcount=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_captureddir!\*.bin"^|find /i /c ".bin"`) do (
		set bat_capturedcount=%%~a
	)
	echo bat_capturedcount=!bat_capturedcount!>>"!bat_configfile!"
	set bat_archivedcount=
	for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\*.bin"^|find /i /c ".bin"`) do (
		set bat_archivedcount=%%~a
	)
	echo bat_archivedcount=!bat_archivedcount!>>"!bat_configfile!"
	echo bat_latestcal=>>"!bat_configfile!"
	echo bat_submissionfilesdir=>>"!bat_configfile!"
	echo bat_ftppassword=!bat_ftppassword!>>"!bat_configfile!"
	echo bat_ftpsite=!bat_ftpsite!>>"!bat_configfile!"
	echo bat_ftpuser=!bat_ftpuser!>>"!bat_configfile!"
	echo bat_ftpdir=!bat_ftpdir!>>"!bat_configfile!"
!bat_echolog! return-:SAVECONFIG [!bat_capturedfilesdir!]
%bat_return%



:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b 0





:SETCAPTUREEXE
	!bat_echolog! call :SETCAPTUREEXE %*
	rem [in]	
	rem [out]	bat_captureexesrc
	rem [out]	bat_captureexe
	rem	[out[	bat_capturebat
	rem [out]	bat_CD_flag

	if      /i "!bat_CAPTURE.capture_mode!" equ "capture" (
		set bat_captureexesrc=FTP_Capture.exe
		set bat_captureexe=FTP_Capture_!bat_camera!.exe
		set bat_capturebat=FTP_Capture.bat
		set bat_CD_flag=
		!bat_echolog! '    Capture mode in AutoCams.Params.ini is :
		!bat_echolog! '       "!bat_CAPTURE.capture_mode!" 
		!bat_echolog! '    so using !bat_captureexesrc!.
		goto :SETCAPTUREEXE_END
	)
	
	if /i "!bat_CAPTURE.capture_mode!" equ "captureanddetect" (
		set bat_captureexesrc=FTP_CaptureAndDetect.exe
		set bat_captureexe=FTP_CaptureAndDetect_!bat_camera!.exe
		set bat_capturebat=CaptureAndDetect.bat
		goto :SETCAPTUREEXE_END
	)
	
	if /i "!bat_CAPTURE.capture_mode!" equ "capturetwoanddetect" (
		set bat_captureexesrc=FTP_CaptureTwoAndDetect.exe
		set bat_captureexe=FTP_CaptureTwoAndDetect.exe
		set bat_capturebat=CaptureTwoAndDetect.bat
		goto :SETCAPTUREEXE_END
	)
	

:SETCAPTUREEXE_END
	!bat_echolog! return-:SETCAPTUREEXE [src=!bat_captureexesrc!, dest=!bat_captureexe!]
!bat_return!





:COPYEXE
	rem [uses]	bat_captureexesrc
	rem [uses]	bat_captureexe

	!bat_echolog! call :COPYEXE %*
	!bat_echolog! '    copy /y "!bat_exedir!\!bat_captureexesrc!" "!bat_exedir!\!bat_captureexe!"
	                   copy /y "!bat_exedir!\!bat_captureexesrc!" "!bat_exedir!\!bat_captureexe!"
:COPYEXE_END 
	!bat_echolog! return-:COPYEXE [!bat_captureexe!]
!bat_return!





	rem This reads the "AutoCams.Params.ini" file for 
	rem sections, keys, and values.  The keys and values
	rem are in the format of autonomouslevel=cal.  
	rem 
	rem If the environment variable is not a [section] then it
	rem is either a key or a comment.  
	rem 
	rem A comment is any line that starts with "//" or "rem ". 
	rem 
	rem If the key starts with "bat_", then the environment variable
	rem will bet set without the section prefix.  Otherwise, the
	rem environment variable will be set with the section 
	rem prefix.
	rem
	rem Examples:
	rem  [AUTOCAMS]
	rem  autonomouslevel=apply
	rem
	rem This would result in the following command being executed:
	rem set AUTOCAMS.autonomouslevel=apply
	rem
	rem  [CALIBRATION]
	rem  bat_calnstars=80
	rem
	rem This would result in the following command being executed (Note how
	rem the section name is not prefixed):
	rem set bat_calnstars=80
	rem
	rem The reason for the different treatment is to make the ini file
	rem compatible with some script variables that were in use before
	rem the AutoCams system was expanded to using this AutoCams.Params.ini 
	rem file. 
	rem
	rem Place this section of code into:
	rem		AutoCams.bat
	rem  	StageFromConfirmed.bat
	rem 	ValidateCal.bat
	rem     LaunchCapture.bat
	rem     CaptureAndDetect.bat
	rem     CaptureTwoAndDetect.bat
	rem
:READPARAMS
!bat_log! call "!bat_exedir!\ReadParams.bat"
	      CALL "!bat_exedir!\ReadParams.bat"
:READPARAMS_END
!bat_log! return-:READPARAMS [!bat_paramsfile!=!bat_retval!]
%bat_return%







:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp= %*
	
	set bat_echolog_temp=%bat_echolog_temp:~1,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=%*
	
	if /i "%*" equ "'" (
		echo.>>"!bat_logfile!"
		%bat_return%
	)
	
	set bat_echolog_temp= %bat_echolog_temp:~2,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%




:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     %~n0 can be run by double-clicking on the program from 
    echo     Windows or from a command line.
    echo.
    echo     Starting it from Windows, it will run it in interactive mode 
    echo     where it will prompt the user for the camera number and the 
    echo     duration of the capture in hours.  
    echo.
    echo     If the duration entered is zero, then the user is prompted to 
    echo     manually start and stop the capture process.  If the duration 
    echo     is greater than zero, the program automatically starts the 
    echo     capture and stops after the designated time has elapsed. 
    echo.
    echo     If you run it from a command shell or batch script, you 
    echo     can specify the camera number and duration as command-line 
    echo     arguments.  If the command-line arguments don't provide all 
    echo     the necessary parameters, the missing parameters will be 
    echo     prompted for.
    echo.
    echo     Usage: %~nx0 [SCANMODE] [cameranumber] [duration] ["targetdirectory"] [autonomous] [/?]
    echo.
    echo     Examples:
    echo         CaptureAndDetect
    echo                                          The user is prompted for 
    echo                                          camera number, duration, 
    echo                                          and base target dir.
    echo.
    echo         CaptureAndDetect 2 299                  The user is prompted for 
    echo                                          capture duration and base 
    echo                                          target dir.
    echo.
    echo         CaptureAndDetect 2 299 0.0              The user is prompted for 
    echo                                          for the base target dir and
    echo                                          prompted to start and stop. 
    echo.
    echo         CaptureAndDetect 2 299 9.5              The user is prompted for 
    echo                                          the base target dir. 
    echo.
    echo         CaptureAndDetect 2 299 9.5 "h:\2011"   The capture for camera 299
    echo                                          starts and runs for 9 hrs  
    echo                                          and 30 mins and saves the
    echo                                          data to a directory like:
    echo                      h:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05
    echo.
    echo     Note: Directory names should be surrounded by quotes.
    echo.
    echo     A folder is created for saving the FF files based on the date and 
    echo     universal time (UTC) at the start of the capture.  The higher level 
    echo     directory is always user specified and the \CAMs\CapturedFiles\ is 
    echo     appended along with the start date and time.  For example, a 
    echo     capture that starts on Aug 14, 2011, 5:11:05 UTC and the target 
    echo     directory specified was "C:", the target directory would be created 
    echo     as C:\CAMS\CapturedFiles\2011_08_14_05_11_05.  If the target dir
    echo     of "D:\2011" is specified, the target directory would be created as:
    echo     C:\2011\CAMS\CapturedFiles\2011_08_14_05_11_05.  
    echo.
    echo     AUTONOMOUS mode:
    echo       You have the option to run capture in autonomous mode. In 
	echo       autonomous mode, it will complete the capture, perform a
	echo       automatic Meteor Cal Update, Apply the Cal to the detect
	echo       file, run the submission script, create a zip file, and 
	echo       (in the future, upload the zip file to the ftp server).
    echo.    
EXIT /b 9
    
goto :DONE


:DONE
	!bat_echolog! END OF %~nx0  ******  %date% %time%
	if /i "!bat_anonymous!" equ "anonymous" (
		AutoCams.bat
	) else (
		exit
	)
