  @echo off
setlocal enableextensions enabledelayedexpansion


:SETUP
	set bat_logfile=%~0.log
	echo.
	echo %date% %time% %0 %*
	echo %date% %time% %0 %*>"!bat_logfile!"
	
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

    if "%~3" equ "" goto :HELP

    set bat_return=goto :EOF

	set bat_sunsettable=%~dp0twilight.csv.txt
	set bat_tempfile=%~0.junk.txt
	set bat_warningfile=%~0.warn.txt

	call :GETARGS %*
	call :TARGETLOCATION %*
	call :PARSEDATE %*
	call :GETSCHEDSTART %*
	call :PARSETIME %*
	call :NOTIFY %*
	call :ADJONDATE %*
	call :DAYOFWEEK %*
	call :GETSEARCHDIR %*
	call :GETSUNANGLE %*
	call :GETSTARTTIME %*
GOTO :MAIN


:MAIN
	call :CALCDURATION "!bat_ON!" "!bat_OFF!"
	call :REVIEW %*
	CALL :GETDELAY %*
	call :WAITDELAY %*
	call :CAPTURE %*
	call :MULTISCAN %*
	call :POSTMULTISCAN %*

	echo %0 %*
	echo %date% %time%>>"!bat_logfile!"
	type "!bat_logfile!"

	set bat_>>"!bat_logfile!"
	set ftp_>>"!bat_logfile!"

rem pause
goto :DONE


:GETARGS
	set bat_camera=%~1
	set bat_delaytemp=%~2
	set bat_targetlocation=%~dpnx3::
	set bat_targetlocation=!bat_targetlocation:\::=!
	set bat_targetlocation=!bat_targetlocation:::=!
%bat_return%
	

:TARGETLOCATION
	REM Ensures that if the last name of the specified directory
	rem contains "CAMS" or "CAMS\", then it removes that from
	rem the bat_targetlocation variable. 
	if /i "!bat_targetlocation:~-5!" equ "\CAMS" (
		set bat_targetlocation=!bat_targetlocation:~0,-5!
	) else (
		if /i "!bat_targetlocation:~-6!" equ "\CAMS\" (
			set bat_targetlocation=!bat_targetlocation:~0,-6!
		)
	)
	
	set bat_targetdrive=!bat_targetlocation:~0,2!

%bat_return%


:PARSEDATE
	set ftp_wmdy=%date%
:PARSEDATE2
	set ftp_year=!ftp_wmdy:~-4!
	set ftp_mo=!ftp_wmdy:~4,2!
	set ftp_mo2=!ftp_mo!
	if !ftp_mo! LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	set ftp_da=!ftp_wmdy:~7,2!
	set ftp_da2=!ftp_da!
	if !ftp_da! LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)
%bat_return%


:GETSCHEDSTART
	set bat_scheduledstarttime=ERROR
	for /f "usebackq tokens=1-3* skip=2 delims=," %%a in (`find /i "Delay will be from the earliest" "!bat_sunsettable!"%>nul:`) do (
		set bat_scheduledstarttime=%%a
	)
%bat_return%


:PARSETIME
	set ftp_hhmmssdd=%time%
	
	set ftp_hr=!ftp_hhmmssdd:~0,2!
	set ftp_hr=!ftp_hr: =!
	set ftp_hr=00!ftp_hr!
	set ftp_hr=!ftp_hr:~-2!

	set ftp_mi=%ftp_hhmmssdd:~3,2%
	set ftp_se=%ftp_hhmmssdd:~6,2%
	set ftp_hhmmssdd=!ftp_hr!:!ftp_mi!:!ftp_se!

	call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	set /a bat_midnightsecs=86400
%bat_return%


:NOTIFY
	echo.
	echo     This script is designed to be launched at the same time of the day
	echo     all year ^(!bat_scheduledstarttime!^).  Then it waits a different number of seconds 
	echo     before starting capture, based on the calculation of dusk, which is 
	echo     based on your LAT/LONG. Then it launches FTP_Capture.exe with the 
	echo     specified camera number, the calculated duration (dusk to dawn from 
	echo     the "!bat_sunsettable!" file), and the specified storage location. 
	echo.
	echo     If you are running this manually, check the "!bat_sunsettable!" file
	echo     for the dusk and dawn values and set the wall timer and duration 
	echo     according to the current launch time. CheckTwilight.bat is provided 
	echo     for this purpose. 
	echo.
%bat_return%

	
:ADJONDATE
	for /f "usebackq tokens=1-16 skip=2 delims=," %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"`) do (
		set bat_on=%%c
		set bat_calcedon=%%c
		set bat_off=%%b
	)
	
	if "!ftp_hhmmssdd!" lss "!bat_off!" (
		set bat_on=!ftp_hhmmssdd:~0,8!
		set /a bat_midnightsecs=0
		set /a ftp_jd-=1
		call :jdate2date !ftp_jd! ftp_year ftp_mo2 ftp_da2
		set ftp_wmdy=dow !ftp_mo2!/!ftp_da2!/!ftp_year!
		set ftp_year=!ftp_wmdy:~-4!
		set ftp_mo=!ftp_wmdy:~4,2!
		set ftp_mo2=!ftp_mo!
		if !ftp_mo! LSS 10 (
			set ftp_mo2=!ftp_mo:~-1!
		)
		set ftp_da=!ftp_wmdy:~7,2!
		set ftp_da2=!ftp_da!
		if !ftp_da! LSS 10 (
			set ftp_da2=!ftp_da:~-1!
		)
	)
	
	call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2
	call :CALCDELAY "!bat_on!" "!ftp_hhmmssdd!"
%bat_return%

:DAYOFWEEK
	call :date2jdate bat_JD !ftp_year! !ftp_mo2! !ftp_da2!
	call :jdate2date !bat_JD! bat_yyyy bat_mm bat_dd
	set /a bat_wdayn=((!bat_JD!*100)/7)-(!bat_JD!/7*100)
	if !bat_wdayn! equ 85 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 14 (
				set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 28 (
					set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 42 (
						set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 57 (
							set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 71 (
								set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)

%bat_return%

:GETSEARCHDIR
	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%
%bat_return%
	

:GETSUNANGLE
	for /f "usebackq tokens=1-5 delims=, skip=1" %%a in (`find /i "dawn off offset" "!bat_sunsettable!"`) do (
		set bat_sa_off=%%d
		set bat_sunangleoff=           %%d
		set bat_sunangleoff=!bat_sunangleoff:~-7!
	)

	for /f "usebackq tokens=1-5 delims=, skip=1" %%a in (`find /i "dusk on offset" "!bat_sunsettable!"`) do (
		set bat_sa_on=%%d
		set bat_sunangleon=            %%d
		set bat_sunangleon=!bat_sunangleon:~-7!
	)
%bat_return%


:GETSTARTTIME
	for /f "usebackq tokens=1-16 delims=," %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"^|find /i /v "!bat_sunsettable!"`) do (
		if "%%a" neq "----------" (
			set bat_duration=%%d
			set bat_delay=%%e
			set bat_date=%%a
			set bat_off=%%b
			rem set bat_on=%%c
			set bat_dst=%%f
			set bat_duskutc=%%g
			set bat_dusklocal=%%h
			set bat_dawnutc=%%i
		)
	)
%bat_return%



:REVIEW
	echo     find /i "Delay will be from the earliest" "!bat_sunsettable!"
	echo 	Task Scheduler Start Time=!bat_scheduledstarttime!
	echo.

	set bat_duration=0
	rem Determine the duration by looking up in the !bat_sunsettable! file

	echo            	         	         	    	   	   	Dusk   	Dusk     	Dawn						
	echo            	         	         	    	   	   	(UTC at	(LDT at   	(UTC at						
	echo            	Dawn OFF	Dusk ON  	Dur-	    	     	!bat_sa_on! below	!bat_sa_on! below   	!bat_sa_off! below						
	echo   Date    	!bat_sa_off! deg     	!bat_sa_on! deg    	ation	Delay  	DST	horizon	horizon   	horizon   	date    	sunrise	sunset  	Day #
	echo   ==========	======== 	=======  	=====	=====  	=	=======	==========	========  	========	=======	==========	=====
	for /f "usebackq tokens=1-16 delims=," %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"^|find /i /v "!bat_sunsettable!"`) do (
			echo   %%a    %%b        %%c        %%d   %%e    %%f       %%g %%h      %%i        %%j        %%k %%l      %%m
	)
	rem find /i "!bat_curm!/!bat_curd!/!bat_cury!" "sunsettable.txt"|find /i /v "!bat_sunsettable!"
	echo.
	echo   for /f "usebackq tokens=1-16 delims=," %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"`) do ...
	for /f "usebackq tokens=1-16 skip=2 delims=," %%a in (`find /i "!ftp_mo!/!ftp_da!/!ftp_year!" "!bat_sunsettable!"`) do (
	echo.
		if "%%a" neq "----------" (
			echo    Date=                %%a  - Date of these calculations ^(!bat_weekday!^)
			call :CALCDAYNUMBER %%m
			echo    Day number=          !bat_res3!         - Day of the year 
			echo    Task Sched Start     !bat_scheduledstarttime!    - Local time Windows Task Scheduler is supposed to launch this script
			echo    Current Time         !time:~0,8!    - Current local time
			echo.
			echo    Sunset Local=         %%l - Local sunset time
			echo    Camera ON Local       %%h - Local time of the first frames, Use this to set our wall timer.
			echo    Camera ON=           !bat_on!    - Local time Task Scheduler should start capture
			echo    Camera ON UTC         %%g    - UTC time ^(camera time^) of the first frame
			echo    Camera ON sun angle  !bat_sunangleon!     - degrees below horizon
			echo.
			echo    Camera OFF UTC       %%i    - UTC time ^(camera time^) of the last frame
			echo    Camera OFF Local=    %%b    - Local time capture should end in the morning
			echo    Sunrise Local=        %%k    - Local sunrise time ^(next morning^)
			echo    Camera OFF sun angle!bat_sunangleoff!      - degrees below horizon
			echo.
			echo    Duration=            !bat_dur!       - Number of hours to capture ^(24:00:00 - ON + OFF^)
			echo    Scheduled Delay=     %%es       - Number of seconds to delay from the scheduled start time ^(!bat_scheduledstartime!^)
			echo    Actual Delay=        !bat_delaycalc!s       - Number of seconds to delay from the scheduled start time ^(!bat_scheduledstartime!^)
			echo    DST=                 %%f           - 1 if this date uses DST.  0 if not
			echo                                       Note: Dawn is calculated for the next morning
			call :CALCREQDISK !bat_dur!
			echo.
			echo    Disk Space Available !bat_freeMB! MB
			echo    Disk Space Required= !bat_reqdisk! MB     - !bat_diskspacememo!
			echo.
				if !bat_estSizeMB! gtr !bat_freeMB! (
					echo call :GETWINDOWSVER
					call :GETWINDOWSVER
					
					set /a bat_sizediff=!bat_estSizeMB!-!bat_freeMB!
			
					ECHO ********* WARNING! ************>!bat_warningfile!
					echo    You only have !bat_freeMB! MB free on drive !bat_targetdrive!. This >>!bat_warningfile!
					echo    run will require !bat_estSizeMB! MB.  You will need to free up>>!bat_warningfile!
					echo    !bat_sizediff! MB ASAP or the capture will fail.>>!bat_warningfile!
					echo.>>!bat_warningfile!
					echo    Tips ^(for Windows version !bat_winver!^):>>!bat_warningfile!
					echo      a^) Try specifying a different drive for capture >>!bat_warningfile!
					echo      b^) Try emptying the recycle bin >>!bat_warningfile!
					if "bat_winver" lss "6.0" (
						echo           ^(rd /s !bat_targetdrive!\recycler^)>>!bat_warningfile!
					) else (
					    echo           ^(rd /s !bat_targetdrive!\$Recycle.Bin^)>>!bat_warningfile!
					)
					echo      c^) Use Disk Cleanup to free up temporary space and other areas.>>!bat_warningfile!
					echo      d^) Move "!bat_targetlocation!CAMS\SubmissionFiles" to an external hard drive.>>!bat_warningfile!
					echo      e^) Move "!bat_targetlocation!CAMS\CapturedFiles" to an external hard drive.>>!bat_warningfile!
					echo.
					type "!bat_warningfile!"
					start /max notepad "!bat_warningfile!"
				)

			set bat_duration=%%d
			set bat_delay=%%e
			set bat_date=%%a
			set bat_off=%%b
			rem set bat_on=%%c
			set bat_dst=%%f
			set bat_duskutc=%%g
			set bat_dusklocal=%%h
			set bat_dawnutc=%%j
		)
	)
			
%bat_return%


	rem start the execution of the meteor detection pass in background priority

	rem start /min sndrec32 /play /close %windir%\media\ding.wav

:GETDELAY
	rem set /a bat_waituntil=!bat_delay!
	rem set /a bat_startmin=!ftp_mi!+1
	set /a bat_delayhh=!bat_delaycalc!/3600
	set bat_delayhh=00!bat_delayhh:~-2!
	set bat_delayhh=!bat_delayhh:~-2!
	call :STRIPZEROS !bat_delayhh! bat_delay_h
	set /a bat_delaymm=(!bat_delaycalc!-(!bat_delay_h!*3600))/60
	rem set /a bat_delaymm=(!bat_delaycalc!-(!bat_delayhh!*3600))/60
	set bat_delaymm=00!bat_delaymm:~-2!
	set bat_delaymm=!bat_delaymm:~-2!
	call :STRIPZEROS !bat_delaymm! bat_delay_m
	set /a bat_delayss=(!bat_delaycalc!-(!bat_delay_h!*3600))-(!bat_delay_m!*60)
	set bat_delayss=00!bat_delayss:~-2!
	set bat_delayss=!bat_delayss:~-2!

	set bat_unique=ftp_capture_!ftp_year!!ftp_mo!!ftp_da!!ftp_hr!!bat_startmin!
%bat_return%


:WAITDELAY
	echo.
	Echo     Waiting !bat_delaycalc! seconds ^(delay of !bat_delayhh!:!bat_delaymm!:!bat_delayss!^) from the current time of 
	echo     !ftp_hhmmssdd! local time until !bat_date! !bat_dusklocal!.
	echo.
	echo     Then running: call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	echo.
	title %0- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	set bat_>>"!bat_logfile!"
	set ftp_>>"!bat_logfile!"

	echo start /w wait !bat_delaycalc!>>"!bat_logfile!"
	echo start /w wait !bat_delaycalc!
	set /a bat_tenth=(!bat_delaycalc!)/10
rem goto :WAITDELAY2
             title %0- ---------- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- X--------- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XX-------- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXX------- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXX------ Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXX----- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXX---- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXXX--- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXXXX-- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXXXXX- Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     start /w wait !bat_tenth!
             title %0- XXXXXXXXXX Waiting until !bat_dusklocal! for call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
:WAITDELAY2
%bat_return%

:CAPTURE
	echo %date% %time%
	call process -k ftp_capture.exe
	
	title "FTP_CAPTURE" !bat_camera! !bat_dur! !bat_targetlocation! %4
	set bat_targetsearchspec=!bat_targetlocation!\CAMS\CapturedFiles
	echo call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4>>"!bat_logfile!"
	echo call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4
	     call "ftp_capture.bat" !bat_camera! !bat_dur! !bat_targetlocation! %4

%bat_return%


:MULTISCAN
	echo for /f "usebackq tokens=*" %%a in ^(`dir "!bat_targetsearchspec!" /ad /s/b`^) do...>>!bat_logfile!"
	for /f "usebackq tokens=*" %%a in       (`dir "!bat_targetsearchspec!" /ad /s/b`) do (
		echo bat_targetsearchdir=%%~a>>"!bat_logfile!"
		set bat_targetsearchdir=%%~a
	)

	echo call makeCaseListing.bat "!bat_targetsearchdir!">>"!bat_logfile!"
	echo call makeCaseListing.bat "!bat_targetsearchdir!"
	     call makeCaseListing.bat "!bat_targetsearchdir!"
%bat_return%


:POSTMULTISCAN
	echo call PostMultiScanCalibration.bat "!bat_targetsearchdir!">>"!bat_logfile!"
	echo call PostMultiScanCalibration.bat "!bat_targetsearchdir!"
	     call PostMultiScanCalibration.bat "!bat_targetsearchdir!"
%bat_return%


rem	EXIT

goto :DONE


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b 0

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=!MM:~-2!
	set DD=!DD:~-2!
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b 0

:CALCDURATION
	call :PARSEOFFTIME "!bat_off!"
	call :PARSEONTIME "!bat_on!"
	
	rem set /a bat_temp=!bat_onsec!-!bat_offsec!
	
	rem                       bat_onh   bat_onm   bat_ons bat_offh  bat_offm  bat_offs
	rem                        %1        %2        %3        %4       %5         %6
	rem call :SUBTRACTONMINUSCUR !bat_th1! !bat_tm1! !bat_ts1! !bat_th4! !bat_tm4! !bat_ts4!
	
	set /a bat_durtotalsecs=(!bat_midnightsecs!-!bat_onsec!)+!bat_offsec!
	set /a                  (!bat_midnightsecs!-!bat_onsec!)+!bat_offsec!
	echo     Total duration=(!bat_midnightsecs!-!bat_onsec!)+!bat_offsec!=!bat_durtotalsecs! seconds
	set /a bat_temp=(!bat_durtotalsecs!*100)/3600
	set /a bat_temph=(!bat_durtotalsecs!)/3600
	set /a bat_tempm=!bat_temp:~-2!
	set bat_tempm=00!bat_tempm!
	set bat_tempm=!bat_tempm:~-2!
	set bat_dur=!bat_temph!.!bat_tempm!
	
	set /a bat_durh=!bat_durtotalsecs!/3600
	set /a bat_durm=(!bat_durtotalsecs!-(!bat_durh!*3600))/60
	set /a bat_durs=(!bat_durtotalsecs!-(!bat_durh!*3600))-(!bat_durm!*60)
	
	call :PADZERO bat_offh
	call :PADZERO bat_offewm
	call :PADZERO bat_offews
	call :PADZERO bat_durh
	call :PADZERO bat_durm
	call :PADZERO bat_durs

	echo        !bat_offh!:!bat_offm!:!bat_offs!	Camera OFF time (next morning)
	echo     -  !bat_ONh!:!bat_ONm!:!bat_ONs!	Current ON time
	echo     -----------------
	echo        !bat_durh!:!bat_durm!:!bat_durs!   !bat_msg! ^<---- duration h:mm:ss ^(!bat_dur! hours^)
	echo.
!bat_return!

:CALCDELAY
	rem Usage: call :CALCDELAY "!bat_on!" "!ftp_hhmmssdd!"
	call :PARSECURTIME "%~2"
	call :PARSEONTIME "%~1"
	
	set /a bat_temp=!bat_onsec!-!bat_cursec!
	
	rem                       bat_onh   bat_onm   bat_ons bat_curh  bat_curm  bat_curs
	rem                        %1        %2        %3        %4       %5         %6
	call :SUBTRACTONMINUSCUR !bat_th1! !bat_tm1! !bat_ts1! !bat_th3! !bat_tm3! !bat_ts3!
	
	set /a bat_delay=!bat_newh!*3600+!bat_newm!*60+!bat_news!
	set bat_delaycalc=!bat_delay!
	set bat_msg= 
	
	if !bat_delay! lss 0 (
		rem                       bat_curh  bat_curm  bat_curs bat_onh   bat_onm   bat_ons
		rem                        %1        %2        %3        %4       %5         %6
		call :SUBTRACTONMINUSCUR !bat_th3! !bat_tm3! !bat_ts3! !bat_th1! !bat_tm1! !bat_ts1!
		set /a bat_delay=0
		set /a bat_delaycalc=0
		set bat_on=!ftp_hhmmssdd!
		echo     Delay=!bat_delay! seconds
		set bat_msg=   IMMEDIATE (we're starting late)   
	) else (
		echo     Delay=!bat_delaycalc! seconds
	)
	
	
	call :PADZERO bat_ONh
	call :PADZERO bat_ONm
	call :PADZERO bat_ONs
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news
	
	call :DISPLAY
rem 	CALL :WAITDELAY !bat_delay!
!bat_return!

:PARSECURTIME
	set bat_curtime=%~1
	set bat_curh=!bat_curtime:~0,2!
	set bat_curm=!bat_curtime:~3,2!
	set bat_curs=!bat_curtime:~6,2!!bat_curtime:~-2!

	rem strip zeros
	for /f "tokens=* delims=0" %%m in ("!bat_curs!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_curs=0
	) else (
		set bat_curs=!bat_nz!
	)

	rem round up to the next second
	set /a bat_curs=!bat_curs!+50
	set /a bat_curs/=100
	call :PADZERO bat_curs
	
	call :STRIPZEROS !bat_curs! bat_ts1
	call :STRIPZEROS !bat_curm! bat_tm1
	call :STRIPZEROS !bat_curh! bat_th1
	
	set /a bat_cursec=!bat_th1!*3600+!bat_tm1!*60+!bat_ts1!	
!bat_return!


:PARSEONTIME
	set bat_ontime=%~1
	set bat_onh=!bat_ontime:~0,2!
	set bat_onm=!bat_ontime:~3,2!
	set bat_ons=!bat_ontime:~6,2!
	
	rem stripzeros
	call :STRIPZEROS !bat_ons! bat_ts3
	call :STRIPZEROS !bat_onm! bat_tm3
	call :STRIPZEROS !bat_onh! bat_th3
	
	set /a bat_onsec=!bat_th3!*3600+!bat_tm3!*60+!bat_ts3!	
!bat_return!

:PARSEOFFTIME
	set bat_offtime=%~1
	set bat_offh=!bat_offtime:~0,2!
	set bat_offm=!bat_offtime:~3,2!
	set bat_offs=!bat_offtime:~6,2!
	
	rem stripzeros
	call :STRIPZEROS !bat_offs! bat_ts4
	call :STRIPZEROS !bat_offm! bat_tm4
	call :STRIPZEROS !bat_offh! bat_th4
	
	set /a bat_offsec=!bat_th4!*3600+!bat_tm4!*60+!bat_ts4!	
	
!bat_return!


:PARSEOFFSET
	set /a bat_delay=%~1
	set /a bat_OFFh=!bat_delay!/3600
	set /a bat_OFFr=!bat_delay!-(!bat_OFFh!*3600)
	set /a bat_OFFm=!bat_OFFr!/60
	set /a bat_OFFs=!bat_OFFr!-(!bat_OFFm!*60)
!bat_return!

:SUBTRACTONMINUSCUR
	rem echo :SUBTRACTONMINUSCUR %1:%2:%3    %4:%5:%6
	set /a bat_remainder=0

	set /a bat_news=%6-%3
	if !bat_news! lss 0 (
		set /a bat_news=!bat_news!+60
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
	set /a bat_newm=%5-%2-!bat_borrow!
	if !bat_newm! lss 0 (
		set /a bat_newm=!bat_newm!+60
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
	set /a bat_newh=%4-%1-!bat_borrow!
	if !bat_newh! lss 0 (
		set /a bat_newh=!bat_newh!
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
!bat_return!

:DISPLAY
	echo        !bat_ONh!:!bat_ONm!:!bat_ONs!	Camera ON time (adjusted from !bat_calcedon!)
	rem echo +  !bat_OFFh!:!bat_OFFm!:!bat_OFFs!	Current Time
	echo     -  !bat_curh!:!bat_curm!:!bat_curs!	Current time
	echo     -----------------
	echo        !bat_newh!:!bat_newm!:!bat_news! LT  !bat_msg! ^<---- Waiting h:mm:ss
	echo.
!BAT_RETURN!

:ADDTIMEPLUSOFFSET
	set /a bat_remainder=0

	set bat_ts1=0&set bat_ts2=0
	call :STRIPZEROS !bat_curs! bat_ts1
	call :STRIPZEROS !bat_OFFs! bat_ts2

	set /a bat_news=!bat_ts1!+!bat_ts2!
	if !bat_news! gtr 59 (
		set /a bat_news=!bat_news!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :STRIPZEROS !bat_curm! bat_tm1
	call :STRIPZEROS !bat_OFFm! bat_tm2
	set /a bat_newm=!bat_tm1!+!bat_carry!+!bat_tm2!
	if !bat_newm! gtr 59 (
		set /a bat_newm=!bat_newm!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :STRIPZEROS !bat_curh! bat_th1
	call :STRIPZEROS !bat_OFFh! bat_th2
	set /a bat_newh=!bat_th1!+!bat_carry!+!bat_th2!
	if !bat_newh! gtr 23 (
		set /a bat_newh=!bat_newh!-24
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :PADZERO bat_OFFh
	call :PADZERO bat_OFFm
	call :PADZERO bat_OFFs
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news
!bat_return!

:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b

:WAITDELAY
	set /a bat_tenth=(!bat_delay!)/10
	echo start /w wait !bat_delay!
             title ----------
	     start /w wait !bat_tenth!
             title X---------
	     start /w wait !bat_tenth!
             title XX--------
	     start /w wait !bat_tenth!
             title XXX-------
	     start /w wait !bat_tenth!
             title XXXX------
	     start /w wait !bat_tenth!
             title XXXXX-----
	     start /w wait !bat_tenth!
             title XXXXXX----
	     start /w wait !bat_tenth!
             title XXXXXXX---
	     start /w wait !bat_tenth!
             title XXXXXXXX--
	     start /w wait !bat_tenth!
             title XXXXXXXXX-
	     start /w wait !bat_tenth!
             title XXXXXXXXXX
	rem      start /w wait 0
	echo %date% %time%
goto :DONE

:PADZERO
	set %1=00!%1!
	set %1=!%1:~-2!
goto :EOF


:CALCDAYNUMBER
	rem Usage: call :CALCDAYNUMBER day
	rem   where day is the day number from the sunsettable.txt file.  In that file,
	rem   the day number in in the file for the first date (01/01/2011) has a value
	rem   of zero.  It should be reported as day 1 and 12/31/2011 is 365 and
	rem   01/01/2012 is day 365, which should be reported as day 1 of year 2012. 
	rem   The only thing that should be an issue between different people using this
	rem   is the bat_offset number below (109600), which may need to be adjusted 
	rem   depending how how many days of offset from a daylight savings date
	rem   is used as the base date.  
	
	set /a bat_day=%1*100
	set /a bat_offset=109600
	set /a bat_year=36525
	
	set /a bat_divide=(((!bat_day!+!bat_offset!)*10000)/!bat_year!)
	set /a bat_int=((!bat_day!+!bat_offset!)/36525)
	set /a bat_mod=!bat_divide!-(!bat_int!*10000)
	set /a bat_res1=!bat_mod!*36525
	set /a bat_res2=!bat_res1!+100000
	set /a bat_res3=(!bat_res2!/1000000)+1
	set bat_res3=!bat_res3!   
	set bat_res3=!bat_res3:~0,3!
goto :EOF


:CALCREQDISK
	set bat_diskspacememo=OK
	call :CHECKDISKSPACE
	set /a bat_estCapFiles=!bat_durtotalseconds/8
	set /a bat_reqdisk=!bat_durtotalsecs!/8*1229/1024
	set /a bat_estSizeMB=!bat_reqdisk!
	set bat_freeMB=!bat_targetfreespace!
	
	set bat_sizediff=!bat_estSizeMB!-!bat_freeMB!

	if !bat_estSizeMB! gtr !bat_freeMB! (
		set bat_diskspacememo=********* DISK SPACE WARNING! ************
	)
goto :EOF




:CHECKDISKSPACE
	set bat_targetdrive=!bat_targetlocation:~0,2!
	
	rem Note: We have to do it this way because WMIC outputs unicode and
	rem FINDSTR is not compatible with unicode strings.
	rem echo wmic /node:localhost logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:csv>"!bat_tempfile!"
	wmic /node:localhost logicaldisk where "name='!bat_targetdrive!'" get Size,FreeSpace /format:csv>"!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-2* skip=1" %%a in (`type "!bat_tempfile!"^|findstr /r /c:","`) do (
		set bat_free=%%b
		set bat_size=%%c
		if "!bat_free!" neq "" (
			set bat_freeMB=!bat_free:~0,-6!
			set bat_targetfreespace=!bat_freeMB!
		)
	)
goto :EOF

	wmic logicaldisk where "name='!bat_targetdrive!'" get freespace /format:csv>"!bat_tempfile!"
	for /f "usebackq tokens=1-2 delims=," %%a in (`type "!bat_tempfile!"^|findstr /r /c:"%computername%"`) do (
		rem echo %%a, %%b
		set bat_targetfreespace=%%b
		set bat_freeMB=%%b
	)


:GETWINDOWSVER
	rem echo :GETWINDOWVER wmic os get version, caption, windowsdirectory /format:list^|findstr /r /c:"=" ... "!bat_tempfile!"
	wmic os get version, windowsdirectory /format:csv|findstr /r /c:",">"!bat_tempfile!"
	rem type "!bat_tempfile!"
	for /f "usebackq delims=, tokens=1-4*" %%a in (`type "!bat_tempfile!"`) do (
		if "%%b" gtr "!" (
			set bat_winver=%%b
		)
	)
goto :EOF


:CALCTIMEREM

goto :EOF


:HELP
    echo     %~nx0          &rem batch file name
    echo.
    echo     Usage: %~nx0 cameranumber duration "targetdirectory" [/?]
    echo.
    echo     This script runs as follows:
    echo        1) Looks up the dusk/dawn and other values from the 
    echo           !bat_sunsettable! file
    echo        2) Calculates the duration
    echo        3) Delays until the camera ON time
    echo.
    echo     %~n0 can be run by either of the following methods:
    echo       - Windows Task Scheduler
    echo       - Command-line
    echo.
    echo     Ideally, %~n0 was designed to be launched from Windows Task
    echo     Scheduler with all the parameters supplied as command-line
    echo     arguments.  The duration is only a dummy value that 
    echo     is no longer used (enter any number, such as 0).  Instead, 
    echo     the script was updated to calculate the duration value from 
    echo     the launch time and/or the !bat_sunsettable! file.  
    echo.
    echo     CheckSunset.bat was provided for you to preview and validate 
    echo     the calculated times and durations.  You will set your wall 
    echo     timer and the Windows Task Scheduler according to the 
    echo     CheckSunset.bat report. 
    echo.
    echo     It can't be launched by double-clicking on it from Windows
    echo     because the required arguements wouldn't be supplied.
    echo.
    echo     If you run it from a command shell or batch script, you must
    echo     specify the camera number, duration, and target location as 
    echo     command-line arguments.  If the command-line arguments don't 
    echo     provide all the necessary parameters, this help text will be 
    echo     displayed.
    echo.
    echo     If it is executed after the scheduled Camera ON time, then 
    echo     there will be no delay and FTP_Capture.bat will be launced
    echo     immediately and the duration will be calculated based on that
    echo     start time.
    echo.
    echo     Example (assume this is run at 17:00:00 local and the 
    echo     !bat_sunsettable! Camera ON/OFF times are ON=18:51:09, OFF=
    echo     06:45:40):
    echo.
    echo       %~n0 213 -1 "h:"          The camera capture is delayed for
    echo                                          1:51:09 hours until 
    echo                                          the Camera ON time, after
    echo                                          which, the FTP_Capture is
    echo                                          launched with the calculated
    echo                                          duration value (11.91 hours), 
    echo.
    echo     Example (assume this is run at 19:30:15 local and the 
    echo     !bat_sunsettable! Camera ON/OFF times are ON=18:51:09, OFF=
    echo     06:45:40):
    echo.
    echo       %~n0 213 -1 "h:"          The camera capture is not delayed, 
    echo                                          19:30:15 will be substituted 
    echo                                          as the new camera ON time 
    echo                                          and the FTP_Capture is
    echo                                          launched with the calculated
    echo                                          duration value (11.26 hours), 
    echo                                          which will calculate an 
    echo                                          accurate duration based on the
    echo                                          camera ON time and the camera OFF 
    echo                                          time.
    echo.
    echo     See the FTP_Capture.bat for more on the capture program.
EXIT /b 9
    
goto :DONE


:DONE
exit /b
