@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

goto :SETUP


:SETUP
	set bat_return=goto :EOF

	if "%~1" equ "" goto :HELP

	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!
	
	set bat_logfile=!bat_exedir!\MergeCaseFiles.bat.log
	set BAT_ECHOLOG=call :ECHOLOG
	set BAT_LOG=call :LOG

	!bat_echolog! ========================================================================
	!bat_echolog! [%date% %time%] %~0 %*
	!bat_echolog!

	set bat_archivedfilesdir=%~1
	set bat_targetdir=!bat_archivedfilesdir!
	set bat_targetdrive=!bat_targetdir:~0,2!
	if /i "!bat_targetdrive:~1,1!" neq ":" (
		!bat_echolog!
		!bat_echolog! '    ERROR - MergeCaseFiles.bat - Invalid path ["!bat_targetdir!"]
		goto :DONE
	)

goto :MAIN




:MAIN
	call :TARGETDIR %*
	if /i "!bat_retval!" equ "failed" (goto :MAIN_END)

	call :WAITFORMULTISCAN %*
	call :TEMPCONCAT %*
	call :GETMETEORCOUNT %*
	call :REBUILDHEADER %*
	call :CONCATFINAL %*
	call :PREVIEW %*
	call :VALIDATE01B %*

:MAIN_END
goto :DONE




:TARGETDIR
	!bat_echolog! call :TARGETDIR %* [!bat_camera!, !bat_detectfile!]
	
	set bat_retval=failed

	rem The bat_outputfile is the temp file the appears as a header
	rem to ftpdetectinfo*.txt files.  The bat_outputfile contains the
	rem proper Meteor Count = value
	
	set bat_outputfile=%bat_targetdir%\meteorcount.txt
	
	!bat_echolog! '    for /f "usebackq tokens=*" %%a in ('!bat_targetdir!') do (
	for                    /f "usebackq tokens=*" %%a in ('!bat_targetdir!') do (
		set bat_archdirname=%%~nxa
		set bat_dirdate=!bat_archdirname:~0,10!
	)
	
	set bat_captureddate=!bat_dirdate!
	set bat_curryyyy=!bat_dirdate:~0,4!
	set bat_currmm=!bat_dirdate:~5,2!
	set bat_currdd=!bat_dirdate:~8,2!
	set bat_currdate=!bat_dirdate:~0,10!
	set bat_caldate=!bat_curryyyy!!bat_currmm!!bat_currdd!

	echo bat_targetdir=!bat_targetdir!
	echo bat_targetdrive=!bat_targetdrive!
	echo bat_outputfile=!bat_outputfile!
	echo bat_exedir=!bat_exedir!
	echo bat_dirdate=!bat_dirdate!
	echo bat_currdate=!bat_currdate!

	if /i "!bat_targetdir!" equ "" (
		echo.
		echo The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		echo Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		echo.
		set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)
	
	if not defined bat_detectfile (
		set bat_detectfile=FTPdetectinfo_Case???.txt
		if exist "!bat_archivedfilesdir!\!bat_detectfile!" (
			for /f "usebackq tokens=*" %%a in (`dir "!bat_archivedfilesdir!\!bat_detectfile!" /a-d /b /o-n`) do (
				set bat_detectfile=%%~nxa
			)

			if not defined bat_camera (
				!bat_echolog! '    for /f "usebackq tokens=* delims=: skip=1" ..a in ^(`find /i ".bin" "!bat_archivedfilesdir!\!bat_detectfile!"`^) do ^(
				for                    /f "usebackq tokens=* delims=: skip=1" %%a in  (`find /i ".bin" "!bat_archivedfilesdir!\!bat_detectfile!"`) do (
					set bat_temp=%%~na
					set bat_camera=!bat_temp:~2,3!
				)
			)
		) else (
			set bat_detectfile=FTPdetectinfo.txt
			if not exist "!bat_archivedfilesdir!\!bat_detectfile!" (
				!bat_echolog! '    ERROR - Missing detect file from "!bat_archivedfilesdir!"
				goto :TARGETDIR_END
			)
		)
	)

	
	
	set bat_retval=success

:TARGETDIR_END
!bat_echolog! return-:TARGETDIR [!bat_retval!, !bat_camera!, !bat_detectfile!]
%bat_return%




:WAITFORMULTISCAN
	!bat_echolog! call :WAITFORMULTISCAN %*
	!bat_echolog! '    for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /b /a-d`^) do ...
	for                    /f "usebackq tokens=*" %%a in  (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "%bat_targetdir%\%%~nxa"
		echo     call WaitForFile rw "%bat_targetdir%\%%~nxa"
		         call WaitForFile rw "%bat_targetdir%\%%~nxa"
	)
	!bat_echolog!

:WAITFORMULTISCAN_END
!bat_echolog! return-:WAITFORMULTISCAN %*
%bat_return%




:TEMPCONCAT
	!bat_echolog! call :TEMPCONCAT %*
	rem temporary concat to fix the meteor count
	rem This section concats without the header

	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	!bat_echolog! '    for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /b /a-d`^) do ...
	for                    /f "usebackq tokens=*" %%a in  (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%bat_targetdir%\%%~a"
		) else (
			set bat_string=!bat_string!+"%bat_targetdir%\%%~a"
		)
	)
	
	set bat_detectfile=FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt
	echo     copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"
	         copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo_0!bat_camera!_!bat_captureddate!.txt"

:TEMPCONCAT_END
!bat_echolog! return-:TEMPCONCAT [!bat_string!, %bat_targetdir%\!bat_detectfile!]
%bat_return%






	rem Save the meteor count into bat_count	
:GETMETEORCOUNT
	echo :GETMETEORCOUNT
	for /f "usebackq tokens=1-4" %%a in (`find /i /c ".bin" "%bat_targetdir%\!bat_detectfile!"`) do (
		set bat_count=%%c
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!
:GETMETEORCOUNT
!bat_echolog! return-:GETMETEORCOUNT [!bat_count!]
%bat_return%





	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
echo :REBUILDHEADER
	set /a bat_linecount=0
	echo     for /f "usebackq tokens=*" %%a in ^(`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			echo Meteor Count = !bat_count!>"%bat_outputfile%"
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_targetdrive!!bat_FFfolder:~15,255!
				echo !bat_FFfolder!>>"%bat_outputfile%"
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_targetdrive!!bat_CALfolder:~15,255!
					echo !bat_CALfolder!>>"%bat_outputfile%"
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					echo %%a>>"%bat_outputfile%"
				)
			)
		)
	)
:REBUILDHEADER_END
!bat_echolog! return-:REBUILDHEADER [Meteor Count = !bat_count!, "!bat_outputfile!"]
%bat_return%




:CONCATFINAL
	echo     copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\!bat_detectfile!"
	         copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\!bat_detectfile!"


	del "!bat_outputfile!"
	echo.
	if not exist "!bat_targetdir!\!bat_detectfile!" (
:CONCATPROMPT
		echo Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		echo file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		echo the following command:
		echo    %~0 %*
		set bat_choice=
		set /p bat_choice=Enter [R]etry Merge, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE
:CONCATFINAL_END
!bat_echolog! return-:CONCATFINAL ["!bat_targetdir!\!bat_detectfile!"]
%bat_return%



:PREVIEW
	echo.
	echo     Date/Time           Size           File name
	echo     ------------------- -------------  ----------------------------------------------
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdir!\!bat_detectfile!" /s/b /a-d`) do (
		set bat_filesize=             %%~za
		set bat_filesize=!bat_filesize:~-13!
		set bat_filedate=%%~ta
		set bat_filename=%%a
		echo     !bat_filedate! !bat_filesize!  !bat_filename!
	)
	echo.

	echo    Excerpt from "!bat_targetdir!\!bat_detectfile!", please review the
	echo    information obtained from the "!bat_targetdir!\!bat_detectfile!" file: 
	echo       - Meteor Count   [should be !bat_count!]
	echo       - FF folder      [should be "!bat_targetdir!"]
	echo       - CAL folder     [should match the drive and dir where your Cal files are stored]
	echo       - Cal file       [May not be correct, if not, Don't skip the Apply process]
	echo.
	echo    Please wait while opening and displaying the first 14 lines from 
	echo    the "!bat_targetdir!\!bat_detectfile!" file...
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_targetdir!\!bat_detectfile!"`) do (
		set /a bat_counter+=1
		if !bat_counter! LSS 15 (
			echo         %%a
		) else (
			if !bat_counter! equ 15 (
				echo.
				echo     Please wait while skipping the rest of the file...
			)
		)
	)

:CONCATDISPLAY
:PREVIEW_END
%bat_return%


:VALIDATE01B
	echo.
	echo.
	echo    The Cal file's date/time might be from a different date, depending on
	echo    where you are in the process or how many times you have gone through the
	echo    process.  The Cal file's date/time is showing the date/time of a recent
	echo    calibration, which may be a previous day.  
	echo.
%bat_return%



:ECHOLOG
	rem Echo to the console and to the bat_logfile
	set bat_echolog_temp=
	set bat_echolog_temp=%*
	
	if not defined bat_echolog_temp (
		echo.>>"!bat_logfile!"
		echo.
		%bat_return%
	)

	set bat_echolog_temp= %*
	
	set bat_echolog_temp=%bat_echolog_temp:~1,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
	echo %bat_echolog_temp%
%bat_return%


:LOG
	rem Echo only to the bat_logfile.
	set bat_echolog_temp=%*
	
	if /i "%*" equ "'" (
		echo.>>"!bat_logfile!"
		%bat_return%
	)
	
		set bat_echolog_temp= %bat_echolog_temp:~2,3000%

	echo %bat_echolog_temp%>>"!bat_logfile!"
%bat_return%





:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     Output:
	echo        "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22\FTPdetectinfo_0ccc_2011_10_21.txt"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. Typically, this directory is the 
	echo     ArchivedFiles subdir.
	echo.
	echo     The script was designed to perform the following tasks:
	echo       1) Merge the multiple file created by MakeCaseListing.bat,
	echo          such as FTPdetectinfo_CaseHeader.txt plus the multiple 
	echo          FTPdetecinfo_Case_001,002... files into a single
	echo          FTPdetectinfo.txt file.
	echo.
	echo       2) Count the number of events in the merged file and
	echo          patch the "Meteor Count = 000000" value with the
	echo          correct value
exit /b



:DONE

