//####################################################################
// FTP_MeteorCal_AutoUpdate is setup to process all the FF files in a
//   night's collection folder to get the updated calibration files for
//   that night. It saves new calibration files for each camera number
//   stored in the FF folder if the minimum star count that the user
//   specifies is acheived. To optimize the O-C residuals, the program
//   will cull star outliers until the desired O-C is reached or the
//   star count drops below the minimum for the given FF file in cal.
//   If both the min star count and desired O-C is met, then the code
//   will stop calibrating the current camera number and move on to the
//   next camera number in the FF folder (to avoid running through the
//   entire FF file set of a given camera once the required accuracy
//   is obtained).
//
// An "AutoCalUpdate.log" file is created in the FF folder used for
//   calibration containing a listing the files processed and
//   resulting accuracy and product names generated. It also informs
//   the user if the cal did not succeed for a given camera and
//   that the user MAY wish to perform a manual cal with FTP_MeteorCal.
//
//
// FTP_MeteorCal_AutoUpdate can be run from a batch file
//
//     FTP_MeteorCal_AutoUpdate.exe  nstars_min  desired_OC  Cal_Directory  FF_Directory
//
// FTP_MeteorCal_AutoUpdate.exe                         User prompted for minimum star count, desired O-C(arcmin), Cal, and FF file directories
// FTP_MeteorCal_AutoUpdate.exe  60                     User prompted for desired O-C(arcmin), Cal, and FF file directories
// FTP_MeteorCal_AutoUpdate.exe  60  1.0                User prompted for Cal, and FF file directories
// FTP_MeteorCal_AutoUpdate.exe  60  1.0  C:\CAMS\Cal   User prompted for FF file directory
// FTP_MeteorCal_AutoUpdate.exe  60  1.0  C:\CAMS\Cal  C:\CAMS\CapturedFiles\2012_01_19_03_42_17
//                                                       No user prompts
//
//###################################################################



//####################################################################
//
// FTP_MeteroCal can now be run from a batch file
//
//    FTP_MeteorCal.exe  CameraNumber  Cal_Directory  FFfile_FullPathFilename
//
// FTP_MeteorCal.exe                       User prompted for camera number, cal directory and navigate to FF file
// FTP_MeteorCal.exe  100                  User prompted for cal directory and navigate to FF file
// FTP_MeteorCal.exe  100  C:\CAMS\Cal     User to navigate to FF file
// FTP_MeteorCal.exe  100  C:\CAMS\Cal  C:\CAMS\CapturedFiles\2012_01_19_03_42_17\FF100_...
//                                         No user prompts except for calibration procedure
//####################################################################




//####################################################################
//
// FTP_MeteorCal_Update Can now be run from a batch file
//
//     FTP_MeteorCal_Update.exe  Cal_Directory  FF_Directory
//
// FTP_MeteorCal_Update.exe                         User prompted for Cal and FF file directories
// FTP_MeteorCal_Update.exe  C:\CAMS\Cal            User prompted for FF file directory
// FTP_MeteorCal_Update.exe  C:\CAMS\Cal  C:\CAMS\CapturedFiles\2012_01_19_03_42_17
//                                                  No user prompts
//
//###################################################################




//####################################################################
//
// FTP_Confirmation can now be run from a batch file
//
//    FTP_Confirmation.exe  FTPdetectinfo_FullPathFilename
//
// FTP_Confirmation.exe                User prompted to navigate to FTPdetectifo_* file
// FTP_Confirmation.exe  C:\CAMS\CapturedFiles\FTPdetectinfo_0100_2010_...txt
//                                     No user prompts except for confirmation responses
//
//####################################################################



//####################################################################
//
// FTP_ApplyCal2Detectinfo can now be run from a batch file
//
//    FTP_ApplyCal2Detectinfo.exe  FTPdetectinfo_FullPathFilename
//
// FTP_ApplyCal2Detectinfo.exe         User prompted to navigate to FTPdetectifo_* file
// FTP_ApplyCal2Detectinfo.exe  C:\CAMS\CapturedFiles\FTPdetectinfo_0100_2010_...txt
//                                     No user prompts unless cal folder not found
//
//####################################################################
