@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


:SETUP
	if "%~1" equ "" goto :HELP
	::if "%~2" equ "" goto :HELP

:TARGETDIR
	set bat_targetdir=%~1
	set bat_targetdrive=!bat_targetdir:~0,2!

	set bat_outputfile=%bat_targetdir%\meteorcount.txt
	set bat_exedir=%cd%
	
	set bat_dirdate=!bat_targetdir:~0,10!
	set bat_curryyyy=!date:~-4!
	set bat_currmm=!date:~4,2!
	set bat_currdd=!date:~7,2!
	set bat_currdate=!date:~-10!

	echo bat_targetdir=!bat_targetdir!
	echo bat_targetdrive=!bat_targetdrive!
	echo bat_outputfile=!bat_outputfile!
	echo bat_exedir=!bat_exedir!
	echo bat_dirdate=!bat_dirdate!
	echo bat_currdate=!bat_currdate!

	if /i "!bat_targetdir!" equ "" (
		echo.
		echo The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		echo Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		echo.
		set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)

:MAIN
	echo ========================================================================
	echo %~0 %*
	echo.

:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "%%a"
		echo     call WaitForFile rw "%%a"
		     call WaitForFile rw "%%a"
	)
	echo.
	


	rem temporary concat to fix the meteor count
	rem This section concats without the header
:TEMPCONCAT
	ECHO :TEMPCONCAT %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%%~a"
		) else (
			set bat_string=!bat_string!+"%%~a"
		)
	)
	echo     copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"
	         copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT
	for /f "usebackq tokens=1-4" %%a in (`find /i /c ".bin" "%bat_targetdir%\FTPdetectinfo.txt"`) do (
		set bat_count=%%c
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!


	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
	set /a bat_linecount=0
	echo for /f "usebackq tokens=*" %%a in ^(`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			echo Meteor Count = !bat_count!>"%bat_outputfile%"
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_targetdrive!!bat_FFfolder:~15,255!
				echo !bat_FFfolder!>>"%bat_outputfile%"
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_targetdrive!!bat_CALfolder:~15,255!
					echo !bat_CALfolder!>>"%bat_outputfile%"
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					echo %%a>>"%bat_outputfile%"
				)
			)
		)
	)
:CONCATFINAL
	echo copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"
	     copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"

	del "!bat_outputfile!"
	echo.
	if not exist "!bat_targetdir!\FTPdetectinfo.txt" (
:CONCATPROMPT
		echo Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		echo file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		echo the following command
		echo    %~0 %*
		set bat_choice=
		set /p bat_choice=Enter [R]estart, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE

	echo.
	echo     Date/Time           Size           File name
	echo     ------------------- -------------  ----------------------------------------------
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdir!\FTPdetectinfo.txt" /s/b /a-d`) do (
		set bat_filesize=             %%~za
		set bat_filesize=!bat_filesize:~-13!
		set bat_filedate=%%~ta
		set bat_filename=%%a
		echo     !bat_filedate! !bat_filesize!  !bat_filename!
	)
	echo.

	echo     Excerpt from "!bat_targetdir!\FTPdetectinfo.txt", please review the following: 
	echo     - Meteor Count   [should be !bat_count!]
	echo     - FF folder      [should be "!bat_targetdir!"]
	echo     - CAL folder     [should be where the cal file is]
	echo     - Cal file       [should match the date/time of file chosen in meteor cal update]
	echo.
	echo    Please wait while opening the file...
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_targetdir!\FTPdetectinfo.txt"`) do (
		set /a bat_counter+=1
		if !bat_counter! LSS 15 (
			echo         %%a
		) else (
			if !bat_counter! equ 15 (
				echo.
				echo     Please wait while skipping the rest of the file...
			)
		)
	)

:CONCATDISPLAY


:VALIDATE01B
	echo.
	echo.
	set bat_choice=
	set /p bat_choice=Is there an FTPdetectinfo.txt file and do the date/time and size seem right Y/N? 
	if /i "!bat_choice!" equ "y" goto :VALIDATE02
	if /i "!bat_choice!" equ "n" goto :DONE
goto :VALIDATE01B


:VALIDATE02
:METEORCALBEGIN

	echo.
	echo "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"
	echo    FF  folder = !bat_FFfolder!\
	echo    CAL folder = !bat_CALfolder!\
	echo.
	echo Listing all CAL files with date of "!bat_currdate!"
	dir "!bat_CALfolder!\CAL*.txt" /od|find /i "!bat_currdate!"
	echo.
	echo Ensure that the FF and CAL folders are correct..
	set bat_choice=
	set /p bat_choice=     Run Meteor Cal [U]pdate, Meteor [C]al, [S]kip calibration, or [Q]uit? 
	if /i "!bat_choice!" equ "u" goto :CALUPDATE
	if /i "!bat_choice!" equ "c" goto :METEORCAL
	if /i "!bat_choice!" equ "s" goto :APPLYBEGIN
	if /i "!bat_choice!" equ "q" goto :DONE
	goto :METEORCALBEGIN


:CALUPDATE
	echo call echo.^|"!bat_exedir!\FTP_MeteorCal_Update.exe"
	     call echo.|"!bat_exedir!\FTP_MeteorCal_Update.exe"
	echo.
goto :METEORCAL02


:METEORCAL
	echo     call echo.^|"!bat_exedir!\FTP_MeteorCal.exe"
			 call echo.|"!bat_exedir!\FTP_MeteorCal.exe"
	echo.
goto :METEORCAL02


:METEORCAL02
	echo.
	echo Listing all CAL files with date of "!bat_currdate!"
	dir "!bat_CALfolder!\CAL*.txt" /od|find /i "!bat_currdate!"
	echo.
	set bat_choice=
	set /p bat_choice=     Do you wish to re-run the meteor cal [U]pdate, run meteor [C]al, [N]ext the cal, or [Q]uit? 
	if /i "!bat_choice!" equ "u" goto :VALIDATE02
	if /i "!bat_choice!" equ "c" goto :METEORCAL
	if /i "!bat_choice!" equ "n" goto :APPLYBEGIN
	if /i "!bat_choice!" equ "q" goto :DONE
goto :METEORCAL02


rem *************************************************************
rem ***** This should be made into a standalone batch file ******
rem *************************************************************
:APPLY1
:APPLYBEGIN
	echo.
	echo     This step runs FTP_ApplyCal2Detectinfo
	set bat_choice=
	set /p bat_choice=   [A]pply cal, [S]kip, or [Q]uit : 
	if /i "!bat_choice!" equ "s" goto :APPLY4
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" neq "a" goto :APPLYBEGIN

	echo call echo.^|FTP_ApplyCal2Detectinfo
	     call echo.|FTP_ApplyCal2Detectinfo

	echo.
	echo   Scroll the window back up and examine the lines right after
	echo.
	echo    Processing detect 1 of !bat_count!
	echo.
	echo   It should have applied your latest calibration file with the
	echo   matching date/time in the listed cal filename.
	echo.
	set bat_choice=
	set /p bat_choice=   If this is correct, enter [C]ontinue, [R]eapply, or [Q]uit : 
	if /i "!bat_choice!" equ "c" goto :APPLYEND
	if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
	if /i "!bat_choice!" equ "q" goto :DONE

:APPLYEND	

	echo     move /y "!bat_targetdir!\FTPdetectinfoC.txt" "!bat_targetdir!\FTPdetectinfo.txt"
	         move /y "!bat_targetdir!\FTPdetectinfoC.txt" "!bat_targetdir!\FTPdetectinfo.txt"

:APPLY4

	if exist "!bat_targetdir!\FTPdetectinfoC.txt" (
		echo     ERROR - The {apply} file wasn't able to be moved to the detect file
		echo     "!bat_targetdir!\FTPdetectinfoC.txt"
		set bat_choice=
		set /p bat_choice=  [C]ontinue, [R]etry, or [Q]uit?  
		if /i "!bat_choice!" equ "c" goto :DONE
		if /i "!bat_choice!" equ "r" goto :APPLYBEGIN
		if /i "!bat_choice!" equ "q" goto :DONE
		goto :APPLY4
	)


:CONFIRM
	echo.
	set bat_choice=
	set /p bat_choice=Are you ready for FTP_Confirmation or [Y/Q]? 
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" equ "y" goto :CONFIRM2
	goto :CONFIRM

:CONFIRM2
	echo call FTP_Confirmation
	     call FTP_Confirmation
	

:SUBMIT
	echo.
	set bat_choice=
	set /p bat_choice=     Ready for submission2 "!bat_targetdir!" ?  Y/N 
	if /i "!bat_choice!" equ "n" goto :DONE
	if /i "!bat_choice!" neq "y" goto :SUBMIT

	call "!bat_exedir!\submission2.bat" "!bat_targetdir!"
	echo.
	echo.
goto :DONE


:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. 
	echo.
	echo     This script performs or initiates many of the tasks that
	echo     need to be done daily after the ftp_reprocess phase is
	echo     complete.  It assumes that the ftp_reprocess phase was
	echo     completed using the "makeCaseListing.bat" script, which
	echo     produces different outcome than the standard ftp_reprocess
	echo     output.  
exit /b



:DONE
set bat_

