@echo off
setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


:SETUP
	if "%~1" equ "" goto :HELP

:TARGETDIR
	set bat_targetdir=%~1
	set bat_targetdrive=!bat_targetdir:~0,2!
	set bat_archivedfilesdir=!bat_targetdir!

	set bat_outputfile=%bat_targetdir%\meteorcount.txt
	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	set bat_exedrive=!bat_exedir:~0,2!
	
	set bat_dirdate=!bat_targetdir:~0,10!
	set bat_curryyyy=!date:~-4!
	set bat_currmm=!date:~4,2!
	set bat_currdd=!date:~7,2!
	set bat_currdate=!date:~-10!

	echo bat_targetdir=!bat_targetdir!
	echo bat_targetdrive=!bat_targetdrive!
	echo bat_outputfile=!bat_outputfile!
	echo bat_exedir=!bat_exedir!
	echo bat_dirdate=!bat_dirdate!
	echo bat_currdate=!bat_currdate!

	if /i "!bat_targetdir!" equ "" (
		echo.
		echo The bat_targetdir env var should be set to "^<drive:^>\CAMS\ArchivedFiles\^<date/time^>" format.
		echo Right now, it is set to [bat_targetdir="%bat_targetdir%"].
		echo.
		set /P bat_targetdir=Manually enter the bat_targetdir value now or [Q]uit: 
		if /i "!bat_targetdir!" equ "q" goto :DONE
		goto :TARGETDIR
	)

:MAIN
	echo ========================================================================
	echo %~0 %*
	echo.
	
	call :MERGECASE %*
	call :GETDETECTINFO
	
:VALIDATE01B
	echo.
	echo.
	set bat_choice=
	set /p bat_choice=[C]ontinue or [A]bort? 
	if /i "!bat_choice!" equ "a" goto :DONE
	if /i "!bat_choice!" neq "c" goto :VALIDATE01B

	call :METEORCALBEGIN
	if /i "!bat_choice!" equ "n" goto :APPLYBEGINX
	if /i "!bat_choice!" equ "s" goto :APPLYBEGINX
	if /i "!bat_choice!" equ "q" goto :DONE

	call :APPLYBEGINX
echo dddddddddddd
:APPLYREPEATX
	set /p bat_choice=[C]ontinue, or [Q]uit? 
	if /i "!bat_choice!" equ "q" goto :DONE
	if /i "!bat_choice!" neq "c" goto :APPLYREPEATX


	call :CONFIRM
	if /i "!bat_choice!" equ "q" goto :DONE
	
	call :SUBMIT
	
goto :DONE


:MERGECASE
	call MergeCaseFiles.bat "!bat_archivedfilesdir!"

	rem Get latest cal file
	set bat_latestcal=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_latestcal ( set bat_latestcal=%%a )
	)
goto :EOF


:WAITFORMULTISCAN
	echo :WAITFORMULTISCAN %*
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		echo     Waiting for FTP_Reprocess to release the file: "%%a"
		echo     call WaitForFile rw "%%a"
		         call WaitForFile rw "%%a"
	)
	echo.
	


	rem temporary concat to fix the meteor count
	rem This section concats without the header
:TEMPCONCAT
	ECHO :TEMPCONCAT %*
	set bat_string= &	rem The result will be "001"+"002"+"003"...

	set /a bat_linecount=0
	echo for /f "usebackq tokens=*" %%a in ^(`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "%bat_targetdir%\FTPdetectinfo_case???.txt" /s/b /a-d`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_string="%%~a"
		) else (
			set bat_string=!bat_string!+"%%~a"
		)
	)
	echo     copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"
	         copy /y /b !bat_string! "%bat_targetdir%\FTPdetectinfo.txt"




	rem Save the meteor count into bat_count	
:GETMETEORCOUNT
	for /f "usebackq tokens=1-4" %%a in (`find /i /c ".bin" "%bat_targetdir%\FTPdetectinfo.txt"`) do (
		set bat_count=%%c
	)

	set bat_count=000000!bat_count!
	set bat_count=!bat_count:~-6!


	rem Read the FTPdetectinfo_CaseHeader.txt and Save the first 11 lines, replacing
	rem the first line with a good Meteor Count = value
:REBUILDHEADER
	set /a bat_linecount=0
	echo for /f "usebackq tokens=*" %%a in ^(`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			echo Meteor Count = !bat_count!>"%bat_outputfile%"
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_targetdrive!!bat_FFfolder:~15,255!
				echo !bat_FFfolder!>>"%bat_outputfile%"
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_targetdrive!!bat_CALfolder:~15,255!
					echo !bat_CALfolder!>>"%bat_outputfile%"
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					echo %%a>>"%bat_outputfile%"
				)
			)
		)
	)
:CONCATFINAL
	echo copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"
	     copy /y /b "!bat_outputfile!"+!bat_string! "!bat_targetdir!\FTPdetectinfo.txt"

	del "!bat_outputfile!"
	echo.
	if not exist "!bat_targetdir!\FTPdetectinfo.txt" (
:CONCATPROMPT
		echo Merging the case files seems to have failed and there is not an FTPdetectinfo.txt
		echo file in the "!bat_targetdir!" directory.  Please resolve and then re-run
		echo the following command
		echo    %~0 %*
		set bat_choice=
		set /p bat_choice=Enter [R]estart, [C]ontinue, or [Q]uit ^(or [E]xplorer to launch Windows Explorer in this directory^): 
		if /i "!bat_choice!" equ "q" goto :DONE
		if /i "!bat_choice!" equ "c" goto :CONCATCONTINUE
		if /i "!bat_choice!" equ "r" goto :MAIN
		if /i "!bat_choice!" equ "e" (
			start Explorer /e,"!bat_targetdir!"
		)
		goto :CONCATPROMPT
	)

:CONCATCONTINUE

	echo.
	echo     Date/Time           Size           File name
	echo     ------------------- -------------  ----------------------------------------------
	for /f "usebackq tokens=*" %%a in (`dir "!bat_targetdir!\FTPdetectinfo.txt" /s/b /a-d`) do (
		set bat_filesize=             %%~za
		set bat_filesize=!bat_filesize:~-13!
		set bat_filedate=%%~ta
		set bat_filename=%%a
		echo     !bat_filedate! !bat_filesize!  !bat_filename!
	)
	echo.

	echo     Excerpt from "!bat_targetdir!\FTPdetectinfo.txt", please review the following: 
	echo     - Meteor Count   [should be !bat_count!]
	echo     - FF folder      [should be "!bat_targetdir!"]
	echo     - CAL folder     [should be where the cal file is]
	echo     - Cal file       [should match the date/time of file chosen in meteor cal update]
	echo.
	echo    Please wait while opening the file...
	set /a bat_counter=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_targetdir!\FTPdetectinfo.txt"`) do (
		set /a bat_counter+=1
		if !bat_counter! LSS 15 (
			echo         %%a
		) else (
			if !bat_counter! equ 15 (
				echo.
				echo     Please wait while skipping the rest of the file...
			)
		)
	)

:CONCATDISPLAY
goto :EOF

:METEORCALBEGIN
	echo.
	echo "%bat_targetdir%\FTPdetectinfo_CaseHeader.txt"
	echo    FF  folder = !bat_FFfolder!\
	echo    CAL folder = !bat_CALfolder!\
	echo.
	echo Listing all CAL files with date of "!bat_currdate!"
	dir "!bat_CALfolder!\CAL*.txt" /od|find /i "!bat_currdate!"
	echo.
	set bat_calfilename=
	for /f "usebackq tokens=* skip=2" %%a in (`find /i ".txt" "!bat_archivedfilesdir!\FTPdetectinfo.txt"`) do (
		if not defined bat_calfilename ( set bat_calfilename=%%a)
	)
	echo Cal file information from the Cal file used in the current 
	echo FTPdetectinfo.txt file (Probably not current):
	call GetCalfileInfo.bat "!bat_calfilename!"
	echo.
	echo Ensure that the FF and CAL folders are correct..
	set bat_choice=
	set /p bat_choice=     Run Meteor Cal [U]pdate, Meteor [C]al, [S]kip calibration, or [Q]uit? 
	if /i "!bat_choice!" equ "u" call :CALUPDATE& goto METEORCAL02
	if /i "!bat_choice!" equ "c" call :METEORCAL& goto METEORCAL02
	if /i "!bat_choice!" equ "s" goto :EOF
	if /i "!bat_choice!" equ "q" goto :EOF
	goto :METEORCALBEGIN


:CALUPDATE
	cd /d "!bat_exedir!"
	echo call "!bat_exedir!\FTP_MeteorCal_Update.exe"
	     call !bat_exedir!\FTP_MeteorCal_Update.exe"
	cd /d "!bat_exedir!"
	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	pause
	echo.
goto :METEORCAL02


:METEORCAL
	cd /d "!bat_exedir!"
	echo     call echo.^|"!bat_exedir!\FTP_MeteorCal.exe"
			 call echo.|"!bat_exedir!\FTP_MeteorCal.exe"
	cd /d "!bat_exedir!"
	echo.
	echo Be sure to write down the date/time of the FF file used for calibration.
	pause
	echo.
goto :METEORCAL02


:METEORCAL02
	echo.
	echo Listing all CAL files with date of "!bat_currdate!"
	dir "!bat_CALfolder!\CAL*.txt" /od|find /i "!bat_currdate!"
	echo.
	echo     for /f "usebackq tokens=*" %%a in ^(`dir "!bat_CALfolder!\CAL*.txt" /s/b /od`^) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_CALfolder!\CAL*.txt" /s/b /od`) do (
		set bat_tempdate=%%~ta
		set bat_tempdate=!bat_tempdate:~-0,10!
		if /i "!bat_tempdate!" equ "!bat_currdate!" (
			set bat_calfilename=%%a
		)
	)
	call GetCalfileInfo.bat "!bat_calfilename!"
	echo.
	set bat_choice=
	set /p bat_choice=     Do you wish to re-run the meteor cal [U]pdate, run meteor [C]al, [N]ext step, or [Q]uit? 
	if /i "!bat_choice!" equ "u" goto :CALUPDATE
	if /i "!bat_choice!" equ "c" goto :METEORCAL
	if /i "!bat_choice!" equ "n" goto :EOF
	if /i "!bat_choice!" equ "q" goto :EOF
goto :METEORCAL02


rem *************************************************************
rem ***** This should be made into a standalone batch file ******
rem *************************************************************
:APPLYBEGINX
	cd /d "!bat_exedir!"
	echo call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	     call "!bat_exedir!\ApplyCal.bat" "!bat_archivedfilesdir!"
	cd /d "!bat_exedir!"
goto :APPLYREPEATX
echo goto :EOF
goto :EOF




:CONFIRM
	echo.
	set bat_choice=
	set /p bat_choice=Are you ready for FTP_Confirmation or [Y/Q]? 
	if /i "!bat_choice!" equ "q" goto :EOF
	if /i "!bat_choice!" equ "y" goto :CONFIRM2
	goto :CONFIRM

:CONFIRM2
	echo call FTP_Confirmation
	     call FTP_Confirmation
goto :EOF


:SUBMIT
	echo.
	set bat_choice=
	set /p bat_choice=     Ready for submission2 "!bat_targetdir!" ?  Y/N 
	if /i "!bat_choice!" equ "n" goto :EOF
	if /i "!bat_choice!" neq "y" goto :SUBMIT

	call "!bat_exedir!\submission2.bat" "!bat_targetdir!"
	echo.
	echo.
goto :EOF




:GETDETECTINFO
	set /a bat_linecount=0
	rem echo for /f "usebackq tokens=*" %%a in ^(`type "!bat_archivedfilesdir!\FTPdetectinfo_CaseHeader.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "!bat_archivedfilesdir!\FTPdetectinfo_CaseHeader.txt"`) do (
		set /a bat_linecount+=1
		if "!bat_linecount!" equ "1" (
			set bat_count=%%a
			set bat_count=!bat_count:~15,6!
		) else (
			if !bat_linecount! equ 5 (
				set bat_FFfolder=%%a
				set bat_FFfolder=FF  folder = !bat_targetdrive!!bat_FFfolder:~15,255!
				set bat_FFfolder=!bat_FFfolder:~13,255!::
				set bat_FFfolder=!bat_FFfolder:\::=!
			) else (
				if !bat_linecount! equ 6 (
					set bat_CALfolder=%%a
					set bat_CALfolder=CAL folder = !bat_targetdrive!!bat_CALfolder:~15,255!
					set bat_CALfolder=!bat_CALfolder:~13,255!::
					set bat_CALfolder=!bat_CALfolder:\::=!
				) else (
					if !bat_linecount! equ 13 (
						set bat_fffilename=%%a
					) else (
						if !bat_linecount! equ 14 (
							set bat_calfilename=%%a
						) else (
							rem echo %%a
						)
					)
				)
			)
		)
	)
goto :EOF





:HELP
	echo %~0      Batch Script
	echo.
	echo     Usage %~0 ^<target directory^>
	echo.
	echo     Example: 
	echo        %~0 "C:\CAMS\ArchivedFiles\2011_10_21_01_58_22"
	echo.
	echo     The target directory must be a fully qualified name
	echo     with the drive letter. 
	echo.
	echo     This script performs or initiates many of the tasks that
	echo     need to be done daily after the ftp_reprocess phase is
	echo     complete.  It assumes that the ftp_reprocess phase was
	echo     completed using the "makeCaseListing.bat" script, which
	echo     produces different outcome than the standard ftp_reprocess
	echo     output.  
exit /b



:DONE
set bat_

