@echo off
setlocal enabledelayedexpansion enableextensions

:SETUP
        echo.%*|find /i "/?">nul:
        if %errorlevel% equ 0 goto :HELP
        echo.%*|find /i "/h">nul:
        if %errorlevel% equ 0 goto :HELP
        echo.%*|find /i "/help">nul:
        if %errorlevel% equ 0 goto :HELP

	set bat_starcountthreshold=50
	set bat_starcountthreshold0=000!bat_starcountthreshold!
	set bat_starcountthreshold0=!bat_starcountthreshold0:~-3!
	set bat_delcommand=%~1
	shift
	shift
	set bat_suffixargs=%1 %2 %3 %4 %5 %6 %7 %8 %9


:MAIN

	rem for /f "usebackq tokens=*" %%a in (`dir ".\cal\CAL???_*.txt" /s/b /a-d^|sort`) ...".\CAL213_20110919_032425_272.txt"
	for /f "usebackq tokens=*" %%a in (`dir ".\cal\CAL???_*.txt" /s/b /a-d^|sort`) do (
		set /a bat_count=0
		set /a bat_foundstar=0
		for /f "usebackq tokens=1-9" %%b in (`type "%%a"^|find /i "Mean O-C ="`) do (
			set bat_calfile=%%~a
			set bat_meanoc=%%e
			set bat_meanoctest=!bat_meanoc:~0,2!
			rem count stars
			for /f "usebackq tokens=1-6" %%k in (`type "!bat_calfile!"`) do (
				call :GETRA "%%k %%l %%m %%n" "%%p"
				call :GETDEC "%%k %%l %%m %%n" "%%p"
				call :GETALT "%%k %%l %%m %%n" "%%p"
				call :GETAZ "%%k %%l %%m %%n" "%%p"
				set bat_starcount3=000%%k
				set bat_starcount3=!bat_starcount3:~-3!
				set bat_starcount2=%%k
			)


			echo %%a, RA=!bat_temp6! DEC=!bat_DEC! ALT=!bat_ALT! AZ=!bat_AZ!	%%b %%c %%d %%e %%f %%g %%h [Cal stars=!bat_starcount2!]

			if "!bat_starcount3!" lss "!bat_starcountthreshold0!" (
				echo        Calibration stars !bat_starcount2! less than !bat_starcountthreshold!.  Mean O-C =%%e    %%a
			)
			
			if "!bat_meanoctest!" neq "0." (
				echo        %%e    %%a
				if "!bat_delcommand!" neq "" (
					echo        !bat_delcommand! "!bat_calfile!" !bat_suffixargs!
					            !bat_delcommand! "!bat_calfile!" !bat_suffixargs!
					echo.
					rem pause
				)
			)
		)
	)
exit /b


	rem Translate the RA from decimal format [337.182] to hour format
	rem [22.3788].  
:GETRA
	if /i "%~1" neq "Cal center RA (deg)" (
		goto :GETRA3
	)
	
:GETRA2
rem echo :GETRA "%~1" "%~2"
rem 	echo for /f "delims=. tokens=1,2" %%x in ("%~2") do...
	for /f "delims=. tokens=1,2" %%x in ("%~2") do (
rem		echo %%x, %%y
		set bat_retval=%%x
		call :STRIPZEROS bat_retval
		set /a bat_tempL=!bat_retval!*10000
		set bat_retval=%%y
		call :STRIPZEROS bat_retval
		set /a bat_tempR=!bat_retval!*10
	)
	set /a bat_temp1=(!bat_tempL!)/15
	set /a bat_temp2=(!bat_tempR!+5)/15
	set /a bat_temp3=!bat_temp1!+!bat_temp2!
	
:GETRALEN
	set bat_temp5=!bat_temp3!
	set /a bat_len=0
	for /l %%z in (0,1,10) do (
		rem echo if "!bat_temp5:~%%z,1!" neq ""...
		if "!bat_temp5:~%%z,1!" neq "" (
			rem echo "!bat_temp5:~%%z, 1!"
			set /a bat_len+=1
		) else (
			rem
		)
	)

	if !bat_len! lss 5 (
		set bat_temp6=000000000!bat_temp3!
		set bat_temp6=00.!bat_temp6:~-4!
	) else (
		set /a bat_len2=!bat_len!-4
		call :GETRA4 bat_temp6 !bat_temp3! !bat_len2!
	)

:GETRA3
goto :EOF

:GETRA4
rem echo %*
	set bat_tempra=00!bat_temp3:~0,%~3!
	set bat_temp6=!bat_tempra:~-2!.!bat_temp3:~-4!
goto :EOF


	rem 
:GETDEC
	if /i "%~1" neq "Cal center Dec (deg)" (
		goto :GETDEC3
	)
	
	set bat_DEC=%~2
	
:GETDEC3
goto :EOF


:GETALT
	if /i "%~1" neq "Cal center Elev (deg)" (
		goto :GETALT3
	)
	
	set bat_ALT=%~2
	
:GETALT3
goto :EOF


:GETAZ
	if /i "%~1" neq "Cal center Azim (deg)" (
		goto :GETAZ3
	)
	
	set bat_AZ=%~2
	
:GETAZ3
goto :EOF

	rem strip leading zeros from a number to avoid the Invalid number
	rem error. 
:STRIPZEROS %1
rem echo :STRIPZEROS %1 !%1!
	for /f "tokens=* delims=0" %%Z in ("!%~1!") do (set %~1=%%Z)
	if not defined %~1 set %~1=0
rem echo bat_retval=!bat_retval!
goto :EOF




:HELP
	echo     Usage: %0 [delete command [suffix args]]
	echo.
	echo     This routine iterates through all the files matching this filespec:
	echo        `dir ".\CAL???_*.txt" /s/b /a-d^|sort`
	echo.
	echo     Then, it lists the filename and the Mean O-C number. If the optional
	echo     delete command is used, it will run that delete command. 
	echo.
	echo     CAUTION!  This script can permanently delete some potentially
	echo               unreparable files.
	echo.
	echo     Where 'delete command' is optional and would usually be something
	echo                            like:
	echo                               del /q
	echo.
	echo           'suffix args'    are arguments that would be applied after
	echo                            the others.  
	echo     Example:
	echo        %0 del /q
	echo           would use:   del filename /q
	echo.
	echo        %0 "del /q"
	echo           would use    del /q filename    
	echo        (Note: the quotes are removed from args, but not the filespec)
	echo.


exit /b