@echo off
setlocal ENABLEEXTENSIONS ENABLEDELAYEDEXPANSION

:MAIN
	REM Adjust the Cisco VPN routes.

	set command=%1
	rem set vpn="C:\Program Files\Cisco Systems\VPN Client\vpnclient.exe"
	 set vpn="c:\Program Files (x86)\Cisco\Cisco AnyConnect Secure Mobility Client\vpnui.exe"
	set find="%windir%\system32\find.exe"
	set dumas=192.168.123.45

	if "%command%"=="start" goto :start
	if "%command%"=="stop" goto :stop
	if "%command%"=="info" goto :info
	if "%command%"=="dump" goto :dump
	if "%command%"=="" goto :toggle

	echo.
	echo Usage: cvpn.bat command
	echo.
	echo Where command is one of:
	echo.
	echo     start   start the Cisco VPN with LJSE.
	echo     stop    stop the VPN.
	echo     info    print some networking info.
	echo.
goto :end

:toggle
	REM Check the state of connection and toggle it.
	%vpn% stat | findstr "Time connected:" > nul
	if not errorlevel 1 (
	  echo Connection will be terminated...
	  goto :stop
	) else (
	  echo Connecting...
	  goto :start
	)
goto :end

:start
	%vpn% connect foo nocertpwd

	route delete 0.0.0.0       mask 0.0.0.0 %dumas%
	route delete 192.168.11.0 mask 255.255.255.0 %dumas%

	rem route add    172.34.0.0    mask 255.255.0.0 %dumas%

goto :end

:info
	%vpn% stat
goto :end

:info
	%vpn% dump
	ipconfig
	echo.
	echo.
	echo.
	route print
goto :end

:stop
	%vpn% disconnect
goto :end

:end