@echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
	set bat_curdate=%date:~-10%
	if "%~1" neq "" (
		set bat_curdate=%~1
	)

	set bat_curdate=!bat_curdate:~-10!
	
	echo.%bat_curdate%|find /i "/">nul:
	if %errorlevel% equ 0 (
		echo for /f "delims=/ tokens=1-3" %%a in ^("!bat_curdate!"^) do ...
		for /f "delims=/ tokens=1-3" %%a in ("!bat_curdate!") do (
			echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	) else (
		echo for /f "delims=_ tokens=1-3" %%a in ^("!bat_curdate!"^) do ...
		for /f "delims=_ tokens=1-3" %%a in ("!bat_curdate!") do (
			echo %%a/%%b/%%c
			set bat_curm=0%%a
			set bat_curm=!bat_curm:~-2!
			set bat_curd=0%%b
			set bat_curd=!bat_curd:~-2!
			set bat_cury=20%%c
			set bat_cury=!bat_cury:~-4!
			set bat_year=!bat_cury:~-4!
		)
	)

	call :date2jdate bat_JD !bat_cury! !bat_curm! !bat_curd!
	call :jdate2date !bat_JD! bat_yyyy bat_mm bat_dd

	rem         "(%a) % 7"          "(((!bat_JD!*100)/7)-(!bat_JD!/7*100)+1)*7/100"
	set /a bat_wdayn="(!bat_JD!) %% 7"
set bat_
	if !bat_wdayn! equ 6 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 0 (
			set bat_weekday=Monday
		) else (
			if !bat_wdayn! equ 1 (
				set bat_weekday=Tuesday
			) else (
				if !bat_wdayn! equ 2 (
					set bat_weekday=Wednesday
				) else (
					if !bat_wdayn! equ 3 (
						set bat_weekday=Thursday
					) else (
						if !bat_wdayn! equ 4 (
							set bat_weekday=Friday
						) else (
							if !bat_wdayn! equ 5 (
								set bat_weekday=Saturday
							)
						)
					)
				)
			)
		)
	)
	echo !bat_curdate!, !bat_yyyy!/!bat_mm!/!bat_dd!, JD=!bat_jd!, !bat_wdayn!, !bat_weekday!
rem set bat_
goto :EOF

	set bat_yyyy=%~1
	set bat_mm=%~2
	set bat_dd=%~3
	call :jdate2date !bat_jd! bat_yyyy bat_mm bat_dd
	call :date2jdate bat_jd !bat_yyyy! !bat_mm! !bat_dd!
	echo !bat_jd!
:MAIN

goto :DONE

set /a bat_num=%1

set /a bat_t1=((!bat_num!*1000)/7)
set /a bat_t2=(!bat_num!/7*1000)

set /a bat_t3=(!bat_t1!)-(!bat_t2)

set /a bat_wdayn=((!bat_num!*1000)/7)-(!bat_num!/7*1000)

if !bat_wdayn! equ 0 (
	set bat_weekday=Saturday
) else (
	if !bat_wdayn! equ 142 (
		set bat_weekday=Sunday
	) else (
		if !bat_wdayn! equ 
	)
)

goto :DONE

:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b


:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b



:DONE

