@echo off
setlocal enabledelayedexpansion enableextensions


rem Needs to add:
rem - ability to read the section under the dashes and throw out
rem   the section if the number of lines doesn't match the 'count'
rem   field on the third line.  For example, in the following text,
rem   the line that starts with "0213 0001 0004", the "0004" is the
rem   'count' field.  Each subsequent line has to have 56 characters.
rem
rem   	-------------------------------------------------------
rem 	FF213_20110815_043145_819_0006400.bin 
rem 	CAL213_20110815_040055_929.txt
rem 	0213 0001 0004 0029.97 062.7 015.0 -09.8 -03.5 0015.9 -039.9
rem 	0144.0 0388.5 0181.7 322.61 053.92 048.28 050.86 000127
rem 	0144.5 0388.9 0181.0 322.53 053.91 048.30 050.91 000048
rem 	0145.0 0392.0 0176.3 322.28 053.78 048.50 051.06 000140
rem 	0145.5 0387.4 0175.0 322.05 053.98 048.18 051.19 000174
rem
rem for /f "usebackq tokens=3*" %a in (`find /c  ".bin" "ArchivedFiles\2011_10_12_02_00_15\FTPdetectinfo.txt"`) do ...

:SETUP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

    set bat_options=/c&	rem for count only
    echo.%*|find /i "/v">nul:
    if %errorlevel% equ 0 (
        set bat_options=/i
        set bat_verbose=true
        set tokens=tokens=* skip=2
    ) else (
    	set bat_options=/i /c
    	set bat_verbose=false
    	set tokens=tokens=3
    )

    set bat_path=%cd%\
:LOOP
    if "%~1" equ "" goto :MAIN

    if /i "/v" equ "%~1" (
		shift
		goto :LOOP
    ) else (
        set bat_path=%~1\
        shift
    )
    goto :LOOP

:MAIN
	if exist "!bat_path!FTPdetectinfo.txt" (
		set /a bat_countdashes=0
		set /a bat_filecount=0

		if /i "!bat_verbose!" equ "false" (
   rem echo for /f "usebackq %tokens%" %%a in ^(`find !bat_options!  ".bin" "!bat_path!FTPdetectinfo.txt"`^) ...
		)
		for /f "usebackq %tokens%" %%a in  (`find !bat_options!  ".bin" "!bat_path!FTPdetectinfo.txt"`) do (
			if "%%a" neq "" (
				set /a bat_countdashes=%%a
				title !bat_countdashes!
				
				if /i "!bat_verbose!" equ "true" (
					set /a bat_filecount+=1
					title Meteor Count = !bat_filecount!  "!bat_path!FTPdetectinfo.txt" 
					echo %%a
				)
			)
		)

		if "!bat_verbose!" neq "true" (
			set bat_countdashes=000000!bat_countdashes!
			set bat_countdashes=!bat_countdashes:~-6!
			echo Meteor Count = !bat_countdashes!
		) else (
			set bat_countdashes=000000!bat_filecount!
			set bat_countdashes=!bat_countdashes:~-6!
		)
		
		title Meteor Count = !bat_countdashes!  "!bat_path!FTPdetectinfo.txt" 
	) else (
		echo File not found - "!bat_path!FTPdetectinfo.txt"
	)

goto :DONE


:HELP
	echo %~0
	echo.
	echo Usage: %~0 [path] [/v] [/?]
	echo.
	echo   where: /v     - means verbose mode and it lists all the files
	echo                   When this mode is used, the count is only displayed
	echo                   in the title bar and it is not output to the console.
	echo                   This is so that you can redirect the outupt to a file.
	echo          path   - is an optional path.  If it is provided, the
	echo                   specified path is used as the source direoctory.
	echo                   If it is omitted, the current directory is used.
	echo.
	echo   The meteor count in both modes is displayed in the title bar. 
	echo   
goto :DONE

:DONE
