 echo off
setlocal enableextensions enabledelayedexpansion

	rem Usage: %0 "ON time" "Current time"
	rem
:SETUP
	set bat_return=goto :EOF
	@echo.
	echo Usage: %0 time seconds
	@echo %0 %*
	echo.
	echo.
goto :MAIN

:MAIN
	call :PARSECURTIME "%~2"
	call :PARSEONTIME "%~1"
	
	set /a bat_temp=!bat_onsec!-!bat_cursec!
	
	rem                       bat_onh   bat_onm   bat_ons bat_curh  bat_curm  bat_curs
	rem                        %1        %2        %3        %4       %5         %6
	call :SUBTRACTONMINUSCUR !bat_th1! !bat_tm1! !bat_ts1! !bat_th3! !bat_tm3! !bat_ts3!
	
	set /a bat_delay=!bat_newh!*3600+!bat_newm!*60+!bat_news!
	echo Delay=!bat_delay! seconds
	set bat_msg= 
	
	if !bat_delay! lss 0 (
		rem                       bat_curh  bat_curm  bat_curs bat_onh   bat_onm   bat_ons
		rem                        %1        %2        %3        %4       %5         %6
		call :SUBTRACTONMINUSCUR !bat_th3! !bat_tm3! !bat_ts3! !bat_th1! !bat_tm1! !bat_ts1!
		set /a bat_delay=0
		echo Delay=!bat_delay! seconds
		set bat_msg=   IMMEDIATE (we're starting late)   
	)
	
	
	call :PADZERO bat_ONh
	call :PADZERO bat_ONm
	call :PADZERO bat_ONs
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news
	
	call :DISPLAY
	CALL :WAITDELAY !bat_delay!
!bat_return!

:PARSECURTIME
	set bat_curtime=%~1
	set bat_curh=!bat_curtime:~0,2!
	set bat_curm=!bat_curtime:~3,2!
	set bat_curs=!bat_curtime:~6,2!!bat_curtime:~-2!

	for /f "tokens=* delims=0" %%m in ("!bat_curs!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_curs=0
	) else (
		set bat_curs=!bat_nz!
	)

	rem round up to the next second
	set /a bat_curs=!bat_curs!+50
	set /a bat_curs/=100
	call :PADZERO bat_curs
	
	call :STRIPZEROS !bat_curs! bat_ts1
	call :STRIPZEROS !bat_curm! bat_tm1
	call :STRIPZEROS !bat_curh! bat_th1
	
	set /a bat_cursec=!bat_th1!*3600+!bat_tm1!*60+!bat_ts1!	
!bat_return!


:PARSEONTIME
	set bat_ontime=%~1
	set bat_onh=!bat_ontime:~0,2!
	set bat_onm=!bat_ontime:~3,2!
	set bat_ons=!bat_ontime:~6,2!
	
	rem stripzeros
	call :STRIPZEROS !bat_ons! bat_ts3
	call :STRIPZEROS !bat_onm! bat_tm3
	call :STRIPZEROS !bat_onh! bat_th3
	
	set /a bat_onsec=!bat_th3!*3600+!bat_tm3!*60+!bat_ts3!	
!bat_return!

:PARSEOFFSET
	set /a bat_delay=%~1
	set /a bat_OFFh=!bat_delay!/3600
	set /a bat_OFFr=!bat_delay!-(!bat_OFFh!*3600)
	set /a bat_OFFm=!bat_OFFr!/60
	set /a bat_OFFs=!bat_OFFr!-(!bat_OFFm!*60)
!bat_return!

:SUBTRACTONMINUSCUR
	echo :SUBTRACTONMINUSCUR %1:%2:%3    %4:%5:%6
	set /a bat_remainder=0

	set /a bat_news=%6-%3
	if !bat_news! lss 0 (
		set /a bat_news=!bat_news!+60
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
	set /a bat_newm=%5-%2-!bat_borrow!
	if !bat_newm! lss 0 (
		set /a bat_newm=!bat_newm!+60
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
	set /a bat_newh=%4-%1-!bat_borrow!
	if !bat_newh! lss 0 (
		set /a bat_newh=!bat_newh!
		set /a bat_borrow=1
	) else (
		set /a bat_borrow=0
	)
	
!bat_return!

:DISPLAY
	echo    !bat_ONh!:!bat_ONm!:!bat_ONs!	Camera ON time
	rem echo +  !bat_OFFh!:!bat_OFFm!:!bat_OFFs!	Current Time
	echo -  !bat_curh!:!bat_curm!:!bat_curs!	Current time
	echo -----------------
	echo    !bat_newh!:!bat_newm!:!bat_news! LT  !bat_msg! ^<---- Waiting h:mm:ss
	echo.
!BAT_RETURN!

:ADDTIMEPLUSOFFSET
	set /a bat_remainder=0

	set bat_ts1=0&set bat_ts2=0
	call :STRIPZEROS !bat_curs! bat_ts1
	call :STRIPZEROS !bat_OFFs! bat_ts2

	set /a bat_news=!bat_ts1!+!bat_ts2!
	if !bat_news! gtr 59 (
		set /a bat_news=!bat_news!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :STRIPZEROS !bat_curm! bat_tm1
	call :STRIPZEROS !bat_OFFm! bat_tm2
	set /a bat_newm=!bat_tm1!+!bat_carry!+!bat_tm2!
	if !bat_newm! gtr 59 (
		set /a bat_newm=!bat_newm!-60
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :STRIPZEROS !bat_curh! bat_th1
	call :STRIPZEROS !bat_OFFh! bat_th2
	set /a bat_newh=!bat_th1!+!bat_carry!+!bat_th2!
	if !bat_newh! gtr 23 (
		set /a bat_newh=!bat_newh!-24
		set /a bat_carry=1
	) else (
		set /a bat_carry=0
	)

	call :PADZERO bat_OFFh
	call :PADZERO bat_OFFm
	call :PADZERO bat_OFFs
	call :PADZERO bat_newh
	call :PADZERO bat_newm
	call :PADZERO bat_news
!bat_return!

:STRIPZEROS %in_val1% out_var1  -- converts in_val1 and sets out_var1 to the new value
	rem     -- in_val1    [in]  - zero leading number
	rem     -- out_var1   [out] - variable name to set the output value to

	setlocal ENABLEDELAYEDEXPANSION enableextensions

	set bat_inval1=%~1

	for /f "tokens=* delims=0" %%m in ("!bat_inval1!") do (set bat_nz=%%m)
	if not defined bat_nz (
		set bat_outvar1=0
	) else (
		set bat_outvar1=!bat_nz!
	)
	( ENDLOCAL & REM RETURN VALUES
		if "%~2" neq "" (set %~2=%bat_outvar1%) else echo.%bat_outvar1%
	)
EXIT /b

:WAITDELAY
	set /a bat_tenth=(!bat_delay!)/10
	echo start /w wait !bat_delay!
             title ----------
	     start /w wait !bat_tenth!
             title X---------
	     start /w wait !bat_tenth!
             title XX--------
	     start /w wait !bat_tenth!
             title XXX-------
	     start /w wait !bat_tenth!
             title XXXX------
	     start /w wait !bat_tenth!
             title XXXXX-----
	     start /w wait !bat_tenth!
             title XXXXXX----
	     start /w wait !bat_tenth!
             title XXXXXXX---
	     start /w wait !bat_tenth!
             title XXXXXXXX--
	     start /w wait !bat_tenth!
             title XXXXXXXXX-
	     start /w wait !bat_tenth!
             title XXXXXXXXXX
	rem      start /w wait 0
	echo %date% %time%
goto :DONE

:PADZERO
	set %1=00!%1!
	set %1=!%1:~-2!
goto :EOF


:DONE

