
 @echo off

:SETUP
	setlocal enableextensions enabledelayedexpansion

:MAIN

	cls
	echo Archived  Confirmed  Archived              Confirmed              Ratio  Comments
	echo ------    ------     -------------------   -------------------    -----  --------------------------

	if not exist "archivedfiles" goto :ERR1
	if not exist "confirmedfiles" goto :ERR2

	rem Loop through all the ".\ArchivedFiles\*\FTPdetectinfo*.txt" files
	for /f "usebackq tokens=*" %%a in (`dir "ArchivedFiles\FTPdetectinfo*.txt" /a-d /s/b^|sort`) do (
		set bat_msg= 

		rem Loop to extract the Meteor Count = value
		for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i /n "Meteor Count" "%%a"`) do (
			set bat_temp=%%d
			set bat_count1=!bat_temp:~-6!
			if "!bat_count1!" equ "000000" (
				set bat_msg=; needs FTP_Reprocess
			)
		)

		set bat_temp=%%a
		set bat_path2=%%~dpa&			rem Remove everything but the filename ("\FTPdetectinfo.txt")
		set bat_path=!bat_path2:~0,-1!

		for /f "usebackq tokens=*" %%e in ('!bat_path!') do (
			set bat_path=%%~dpe
			set bat_date=%%~nxe
		)

		rem set bat_dirname=!bat_path:~0,-1!&			rem Extract just the directory name (e.g. "2011_08_22_05_17_09")
		set bat_dirname=!bat_date!&			rem Extract just the directory name (e.g. "2011_08_22_05_17_09")

		set bat_found=0&	rem Use this to determine if matching dir is found in ConfirmedFiles or not


		rem Loop to list all the FTPdetectinfo.txt files in the ConfirmedFiles directory. 
		rem Inside the loop, it will search for the bat_dirname in the resulting list.
		if not exist "ConfirmedFiles\!bat_dirname!" (
			set bat_dirname2=                   
			set bat_msg=!bat_msg!; not confirmed
			set bat_count2=000000
			rem Loops to remove leading zeros
			for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
			for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)
	
			if not defined bat_count1nz set bat_count1nz=0
			if not defined bat_count2nz set bat_count2nz=0
	
			rem logic to avoid divide by zero
			if "!bat_count2!" neq "000000" (
				rem set bat_count
				rem echo set /a bat_ratio=!bat_count1nz!/!!bat_count2nz!
				set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
			) else (
				set /a bat_ratio=0
			)

			echo !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!
		)

		if exist "ConfirmedFiles\!bat_dirname!\ftpdetectinfo*.txt" (
			for /f "usebackq tokens=*" %%b in (`dir "ConfirmedFiles\!bat_dirname!\ftpdetectinfo*.txt" /s/b /a-d /on^|find /i "!bat_dirname!"`) do (

				rem To speed things up, skip if already found.
				if "!bat_found!" equ "0" (
					for /f "tokens=*" %%x in ("%%~b") do (
						set bat_temp=%%x
						set bat_path2=%%~dpx::&	rem Extract the path including removing the trailing backslash"\"
						set bat_path2=!bat_path2:\::=!
						set bat_path2=!bat_path2:::=!
						for /f "tokens=*" %%y in ("!bat_path2!") do (
							set bat_dirname2=%%~nxy
						)
					)
	
					if "!bat_dirname!" equ "!bat_dirname2!" (
						set bat_found=1
						for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i /n "Meteor Count" "%%b"`) do (
							set bat_temp=%%d
							set bat_count2=!bat_temp:~-6!
						)

:STRIPZEROS
						rem Loops to remove leading zeros
						for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
						for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)
		
						if not defined bat_count1nz set bat_count1nz=0
						if not defined bat_count2nz set bat_count2nz=0
		
						rem logic to avoid divide by zero
						if "!bat_count2!" neq "000000" (
							rem set bat_count
							rem echo set /a bat_ratio=!bat_count1nz!/!!bat_count2nz!
							set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
							set /a bat_totalconfirmed+=!bat_count2nz!
							rem echo !bat_totalconfirmed!
				) else (
							set /a bat_ratio=0
						)
	
						set bat_ratio=   !bat_ratio!
						set bat_ratio=!bat_ratio:~-3!

						rem echo !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!
						set bat_output=!bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1 !bat_msg!

						set bat_comments=!bat_path2!\comments.txt
						set bat_commentspace=                                                                         
	
						rem append the text in comments.txt to bat_msg
						if exist "!bat_comments!" (
							for /f "usebackq tokens=*" %%f in (`type "!bat_comments!"`) do (
								rem set bat_msg=; %%f
								if "!bat_msg!" equ " " (
									set bat_msg=; %%f
									set bat_output=!bat_output!!bat_msg!
									echo !bat_output!
								) else (
									rem echo !bat_output!
									echo !bat_commentspace!%%f
								)
							)
							rem echo.
						) else (
							echo !bat_output!
							set bat_comments=
						)
					)
				)
			)
			if "!bat_found!" equ 0 (
				echo "%%a" not yet confirmed.
			)
		) else (
			rem
echo Not found -"ConfirmedFiles\!bat_dirname!\ftpdetectinfo*.txt"
		)
	)&	rem end for /f ... %%a
	echo.
	echo Total Confirmed=!bat_totalconfirmed!
exit /b 0

:ERR1
	echo The directory, "%cd%\ArchivedFiles", does not exist. 
	exit /b 1

:ERR2
	echo The directory, "%cd%\ConfirmedFiles", does not exist. 
	exit /b 2
