
@echo off

:SETUP
	setlocal enableextensions enabledelayedexpansion

	set /a bat_totalconfirmed=0
	set bat_exedir=%~0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	
	set bat_submissiondir=!bat_exedir!\SubmissionFiles
	
	if /i "%~1" neq "" (
		set bat_targetdir=%~1\
	)

:MAIN

	cls
	echo "%cd%\SubmissionFiles\ftpdetectinfo_scanned.txt"
	echo.
	echo CAM Archived  Confirmed  Archived              Confirmed              Ratio  Comments
	echo --- ------    ------     -------------------   -------------------    -----  ------------------------

	if not exist "archivedfiles" goto :ERR1
	if not exist "confirmedfiles" goto :ERR2

	rem Loop through all the ".\SubmissionFiles\FTPdetectinfo.txt" files
	rem echo for /f "usebackq tokens=*" %%a in ^(`dir "SubmissionFiles\!bat_targetdir!ftpdetectinfo_scanned.txt" /s/b /a-d^|sort /r`^) do ^(
	for /f "usebackq tokens=*" %%a in (`dir "SubmissionFiles\!bat_targetdir!ftpdetectinfo_scanned.txt" /s/b /a-d^|sort /r`) do (
		set bat_msg= 

		set bat_temp=%%~a
rem echo %%a
		set bat_filename=%%~nxa
		set bat_path=%%~dpa&			rem get the path ("x:\cams\SubmissionFiles\[date]\cam\EmailFiles
		
		set bat_emaildir=!bat_path!::
		set bat_emaildir=!bat_emaildir:\::=!
		set bat_emaildir=!bat_emaildir:::=!
		
		set bat_filesize=%%~za

		rem Loop to extract the Meteor Count = value
		rem echo for /f "usebackq tokens=1,2 delims=\=" %%c in ^(`find /i /n "Meteor Count" "%%a"`^) do ^(
		for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i /n "Meteor Count" "%%a"`) do (
			set bat_temp=%%d
			set bat_count1=!bat_temp:~-6!
			if "!bat_count1!" equ "000000" (
				if "!bat_filesize!" GTR "480" (
					set bat_msg=; needs FTP_Reprocess
				)
			)
		)

		rem Loop to extract the Camera
		for /f "usebackq tokens=*" %%c in (`dir "!bat_emaildir!" /s/b /ad`) do (
			set bat_temp=%%~nxc
			set bat_camera=!bat_temp:~4,3!
		)

		call :GETDIRNAMES "!bat_emaildir!"

		set bat_found=0&	rem Use this to determine if matching dir is found in ConfirmedFiles or not


		rem Loop to list all the FTPdetectinfo.txt files in the ConfirmedFiles directory. 
		rem Inside the loop, it will search for the bat_dirname in the resulting list.
		if not exist "!bat_emaildir!\FTPdetectinfo_confirmed.txt" (
			set bat_dirname2=                   
			set bat_msg=!bat_msg!; not confirmed
			set bat_count2=000000

			rem Loops to remove leading zeros
			for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
			for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)
	
			if not defined bat_count1nz set bat_count1nz=0
			if not defined bat_count2nz set bat_count2nz=0
	
			rem logic to avoid divide by zero
			if "!bat_count2!" neq "000000" (
				rem set bat_count
				rem echo set /a bat_ratio=!bat_count1nz!/!!bat_count2nz!
				set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
			) else (
				set /a bat_ratio=0
			)
			
		) else (
			for /f "usebackq tokens=*" %%b in (`dir "!bat_path!\ftpdetectinfo_confirmed.txt" /s/b`) do (
				rem To speed things up, skip if already found.
				if "!bat_found!" equ "0" (
					set bat_temp=%%b
					rem set bat_path2=%%~dpb!&	rem Extract everything but the filename ("\FTPdetectinfo.txt")
					set bat_path2=!bat_emaildir!
					rem set bat_path2=!bat_path2:\EmailFiles\=!
					rem set bat_dirname2=!bat_path2:~-19!&	rem Extract just the directory name (e.g. "2011_08_22_05_17_09")

					if "!bat_dirname!" equ "!bat_dirname2!" (
						set bat_found=1
						for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i /n "meteor count" "%%b"`) do (
							set bat_temp=%%d
							set bat_count2=!bat_temp:~-6!
						)

:STRIPZEROS
						rem Loops to remove leading zeros
						for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
						for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)

						if not defined bat_count1nz set bat_count1nz=0
						if not defined bat_count2nz set bat_count2nz=0

						rem logic to avoid divide by zero
						if "!bat_count2!" neq "000000" (
							rem set bat_count
							rem echo set /a bat_ratio=!bat_count1nz!/!bat_count2nz!
							set /a bat_ratio=!bat_count1nz!^/!bat_count2nz!
							set /a bat_totalconfirmed+=!bat_count2nz!
							rem echo !bat_totalconfirmed!
						) else (
							set /a bat_ratio=0
						)

						set bat_ratio=   !bat_ratio!
						set bat_ratio=!bat_ratio:~-3!

						set bat_output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1 !bat_msg!

						set bat_comments=!bat_emaildir!\comments.txt
						set bat_commentspace=                                                                               
	
						rem append the text in comments.txt to bat_msg
						if exist "!bat_comments!" (
							for /f "usebackq tokens=*" %%f in (`type "!bat_comments!"`) do (
								rem set bat_msg=; %%f
								if "!bat_msg!" equ " " (
									set bat_msg=; %%f
									set bat_output=!bat_output!!bat_msg!
									echo !bat_output!
								) else (
									rem echo !bat_output!
									echo !bat_commentspace!%%f
								)
							)
							rem echo.
						) else (
							echo !bat_output!
							set bat_comments=
						)

					)
				)
			)&	rem end for /f ... %%b
		)
		
		
		set bat_comments=!bat_path2!\EmailFiles\comments.txt

		rem append the text in comments.txt to bat_msg
		if exist "!bat_comments!" (
			for /f "usebackq tokens=*" %%f in (`type "!bat_comments!"`) do (
				set bat_msg=!bat_msg!; %%f
			)
		)
		
		if "!bat_found!" equ 0 (
			echo "%%a" not yet confirmed.
		) else (
			rem
		)
	)&	rem end for /f ... %%a
	echo Total Confirmed=!bat_totalconfirmed!
exit /b 0


	rem 
:GETDIRNAMES
	rem [in]bat_emaildir 
	rem [out]bat_captureddir 
	rem [out]bat_archiveddir 
	rem [out]bat_confirmeddir
	rem [out]bat_dirname
	
	
	set bat_GDN_temp=%~1&	rem path (e.g. "H:\CAMS\SubmissionFiles\2011_10_21\213\EmailFiles")
	
	rem Determine if dir format is...
	rem Either: "H:\CAMS\SubmissionFiles\2011_10_21\213\ArchivedFiles\2011_10_21_hh_mm_ss"
	rem     or: "H:\CAMS\SubmissionFiles\2011_10_21_hh_mm_ss\ArchivedFiles\20112011_10_21_hh_mm_ss
	
	call :LASTFROMPATH "!bat_GDN_temp!"
	set bat_pathdate=!bat_retval2!

	rem get camera
	call :LASTFROMPATH "!bat_pathdate!"
	if "!bat_retval:~4,1!" equ "_" (
		set bat_vers=1&		rem "H:\CAMS\SubmissionFiles\2011_10_21_hh_mm_ss\EmailFiles"
		set bat_datedir=!bat_retval!
		set bat_datedir2=!bat_retval!
		
		rem get captured
		set bat_captureddir=!bat_retval2!\!bat_datedir!\CapturedFiles
		set bat_archiveddir=!bat_retval2!\!bat_datedir!\ArchivedFiles
		set bat_confirmeddir=!bat_retval2!\!bat_datedir!\ConfirmedFiles
		set bat_path2=!bat_retval2!\!bat_datedir!
		
	)  else (
		set vers=2
		set bat_cam=!bat_retval!
		
		rem get captured
		set bat_captureddir=!bat_retval2!\!bat_cam!\CapturedFiles
		set bat_archiveddir=!bat_retval2!\!bat_cam!\ArchivedFiles
		set bat_confirmeddir=!bat_retval2!\!bat_cam!\ConfirmedFiles
		set bat_path2=!bat_retval2!\!bat_cam!
		
	)
	
	
	rem get dirname
	for /f "usebackq tokens=*" %%X in (`dir "!bat_archiveddir!" /b /o-n`) do (
		set bat_dirname=%%X
		set bat_dirname2=%%X
	)

rem exit /b
goto :EOF

	rem extracts the last path segment
:LASTFROMPATH [in]path [out]bat_retval
rem echo ...%~1...
	set bat_junk=%~1::
	set bat_junk=!bat_junk:\::=!
	set bat_junk=!bat_junk:::=!
rem echo bat_junk=!bat_junk!
	for /f "usebackq tokens=*" %%X in ('!bat_junk!') do (
rem 		echo #######%%X$$$$$$$$$
rem 		echo #######!bat_junk!$$$$$$$$$
		set bat_retval=%%~nX
		set bat_retval2=%%~dpX::
		set bat_retval2=!bat_retval2:\::=!
		set bat_retval2=!bat_retval2:::=!
	)
rem echo :LASTFROMPATH %1, !bat_retval2!, !bat_retval!
rem set bat_
rem pause
goto :EOF

:ERR1
	echo The directory, "%cd%\ArchivedFiles", does not exist. 
	exit /b 1

:ERR2
	echo The directory, "%cd%\ConfirmedFiles", does not exist. 
	exit /b 2
