@echo off

:SETUP
	setlocal enableextensions enabledelayedexpansion

	set bat_exedir=%~dp0::
	set bat_exedir=!bat_exedir:\::=!
	set bat_exedir=!bat_exedir:::=!
	
	set bat_submissiondir=!bat_exedir!\SubmissionFiles

	set bat_targetdir=
	if /i "%~1" neq "" (
		set bat_targetdir=%~1\
	)

	echo.
	echo ==============================================================================
	echo [%date% %time%] %~nx0 %* [submissiondir=!bat_submissiondir!] [targetdir=!bat_targetdir!]
	echo.
	
	set bat_tempfile=!bat_exedir!\meteorcount.submission.txt
	set bat_tempfile2=!bat_exedir!\meteorcount.submission2.txt
	
	set bat_commentspace=                                                                               

goto :MAIN
	

:MAIN
	set /a bat_totalconfirmed=0
	
	echo.
	echo CAM Archived  Confirmed  Archived              Confirmed              Ratio  Comments
	echo --- ------    ------     -------------------   -------------------    -----  ------------------------

	call :LOOP "ftpdetectinfo_scanned-???.txt"
	call :LOOP "ftpdetectinfo.txt"
	echo Total Confirmed=!bat_totalconfirmed!
exit /b 0


:LOOP
	set bat_detectfilespec=%~1

	set bat_targetpath=!bat_submissiondir!\!bat_targetdir!
	
	rem echo dir "!bat_targetpath!!bat_detectfilespec!" /s
	dir "!bat_targetpath!!bat_detectfilespec!" /s 2>nul:1>nul:
	if !errorlevel! neq 0 (
		goto :LOOP_END
	)
	
	rem Loop through all the ".\SubmissionFiles\!bat_detectfilespec!" files
	rem echo 1    for /f "usebackq tokens=*" %%y in ^(`dir "!bat_targetpath!\!bat_detectfilespec!" /s/b /a-d^|sort /r^|find /i "EmailFiles"`^) do ...
	for           /f "usebackq tokens=*" %%y in  (`dir "!bat_targetpath!\!bat_detectfilespec!" /s/b /a-d^|sort /r^|find /i "EmailFiles"`) do (
	    set bat_sourcedetectfull=
	    set bat_camera=
		rem Ensure that it isn't FTPdetectinfo_CaseHeader.txt, or
		rem FTPdetectinfo_Case001.txt, FTPdetectinfo_scanned_???_header.txt
	    echo.%%~y|find /i "_Case">nul:
	    if !errorlevel! equ 0 (
	    	rem Do not process if it is *_CaseHeader or *_Case00x
	    ) else (
	    	echo.%%~y|find /i "_header">nul:
	    	if !errorlevel! equ 0 (
	    		rem Do not process if it is *_CaseHeader or *_header
	    	) else (
				set bat_sourcedetectfull=%%y&rem	Example: "C:\CAMS\SubmissionFiles\2012)05)19\213\EmailFiles\FTPdetectinfo_scanned-213.txt"


				rem echo 2    for /f "usebackq tokens=*" %%a in ^(`dir "!bat_sourcedetectfull!" /a-d /s/b^|sort /r`^) do ^(
				for           /f "usebackq tokens=*" %%a in  (`dir "!bat_sourcedetectfull!" /a-d /s/b^|sort /r`) do (
					set bat_msg= 
					set bat_camera=
					set bat_count1=000000
					set bat_count2=000000
					set bat_dirname=          
					set bat_dirname2=                   
					set bat_ratio=0:1 
					set bat_output=

					set bat_temp=%%~a

					set bat_fullpath=%%~a
					set bat_filename=%%~nxa
					set bat_path2=%%~dpa&			rem Remove everything but the filename ("\FTPdetectinfo*.txt")
					set bat_path=!bat_path2:~0,-1!
					call :PARSEDIR "!bat_path!"

					set bat_emaildir=!bat_path!::
					set bat_emaildir=!bat_emaildir:\::=!
					set bat_emaildir=!bat_emaildir:::=!

					if /i "!bat_dirname!" equ "EmailFiles" (
						set bat_filesize=%%~za

						call :LASTFROMPATH "!bat_path!"
						call :LASTFROMPATH "!bat_retval2!"
						set bat_camera=!bat_retval!
						set bat_cam=!bat_camera!
						call :LASTFROMPATH "!bat_retval2!"
						set bat_captureddate=!bat_retval!
						set bat_dirname=!bat_captureddate!
						set bat_dirname2=!bat_captureddate!

							rem bat_count1 is the returned count
						call :GETCOUNT "%%~a"
						set bat_count1=!bat_GC_count!


						if "!bat_count1!" equ "000000" (
							set output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!
						) else (
							call :CONFIRMED
							call :COMMENTS
						)& rem if "!bat_count1!" equ "000000"
					)& rem if /i "!bat_dirname!" neq "EmailFiles"

				)
		    )
		)
	)
:LOOP_END
goto :EOF







:CONFIRMED
				set bat_found=0&	rem Use this to determine if matching dir is found in ConfirmedFiles or not
				set bat_output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!            !bat_dirname2!             !bat_ratio!  !bat_msg!



				set bat_detectfileconf=FTPdetectinfo_confirmed-!bat_camera!.txt
				if not exist "!bat_emaildir!\!bat_detectfileconf!" (
					set bat_detectfileconf=FTPdetectinfo_confirmed.txt
					if not exist "!bat_emaildir!\!bat_detectfileconf!" (
						set bat_detectfileconf=
					)
				)
				
				if not defined bat_detectfileconf (
					echo !bat_output!
					goto :CONFIRM_END
				)

				rem Loop to list all the FTPdetectinfo.txt files in the ConfirmedFiles directory. 
				rem Inside the loop, it will search for the bat_dirname in the resulting list.
				if not exist "!bat_emaildir!\!bat_detectfileconf!" (
					set bat_dirname2=                    
					set bat_msg=!bat_msg!; not confirmed
					set bat_count2=000000

					rem Loops to remove leading zeros
					for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
					for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)

					if not defined bat_count1nz set bat_count1nz=0
					if not defined bat_count2nz set bat_count2nz=0

					rem logic to avoid divide by zero
					if "!bat_count2!" neq "000000" (
						set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
					) else (
						set /a bat_ratio=0
					)
					set bat_output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!          !bat_dirname2!    !bat_ratio!:1  !bat_msg!
					echo !bat_output!
				) else (
					rem echo 4   for /f "usebackq tokens=*" %%b in ^(`dir "!bat_path!\!bat_detectfileconf!" /s/b`^) do ^(
					for /f "usebackq tokens=*" %%b in (`dir "!bat_path!\!bat_detectfileconf!" /s/b`) do (
						rem To speed things up, skip if already found.
						if "!bat_found!" equ "0" (
							for /f "tokens=*" %%x in ("%%~b") do (
								set bat_temp=%%x
								set bat_detectconf=!bat_temp!
							)& rem for /f "tokens=*" %%x in


							call :GETCOUNT "!bat_path!\!bat_detectfileconf!"
							set bat_count2=!bat_GC_count!

							
		:STRIPZEROS
								rem Loops to remove leading zeros
							for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
							for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)

							if not defined bat_count1nz set bat_count1nz=0
							if not defined bat_count2nz set bat_count2nz=0
						
							rem logic to avoid divide by zero
							if "!bat_count2!" neq "000000" (
								set /a bat_ratio=!bat_count1nz!^/!bat_count2nz!
								set /a bat_totalconfirmed+=!bat_count2nz!
							) else (
								set /a bat_ratio=0
							)& rem if "!bat_count2!" neq "000000"

							set bat_ratio=   !bat_ratio!
							set bat_ratio=!bat_ratio:~-3!

							if /i "!bat_msg!" equ " " (
								call :GETFIRSTCOMMENT
								set bat_msg=!bat_commentfirst!
							)

							set bat_output=!bat_camera! !bat_count1!    !bat_count2!     !bat_dirname!            !bat_dirname2!           !bat_ratio!:1    !bat_msg!
							echo !bat_output!
							
							call :GETCOMMENTS

						)& rem if "!bat_found!" equ "0"
					)&	rem end for /f "usebackq tokens=*" %%b in 
				)& rem if not exist "!bat_emaildir!\!bat_detectfileconf!"

				if "!bat_found!" equ 0 (
					echo "%%a" not yet confirmed.
				) else (
					rem
				)
	    	)& rem for /f "usebackq tokens=*" %%a in
	    )& rem if !errorlevel! neq 0

:CONFIRM_END
goto :EOF


:COMMENTS
	rem if not defined bat_detectfileconf (only do comments)
:COMMENTS_END
goto :EOF


	rem 
:GETDIRNAMES
	rem [in]bat_emaildir 
	rem [out]bat_captureddir 
	rem [out]bat_archiveddir 
	rem [out]bat_confirmeddir
	rem [out]bat_dirname
	rem [out]bat_dirname2
	
	
	set bat_GDN_temp=%~1&	rem path (e.g. "H:\CAMS\SubmissionFiles\2011_10_21\213\EmailFiles")
	
	rem Determine if dir format is...
	rem Either: CAMS\SubmissionFiles\2011_10_21\213\EmailFiles"
	rem     or: something else
	
	call :LASTFROMPATH "!bat_GDN_temp!"
	set bat_pathdate=!bat_retval2!

	rem get camera
	call :LASTFROMPATH "!bat_pathdate!"
	if "!bat_retval:~4,1!" equ "_" (
		set bat_vers=1&		rem "H:\CAMS\SubmissionFiles\2011_10_21_hh_mm_ss\EmailFiles"
		set bat_datedir=!bat_retval!
		set bat_datedir2=!bat_retval!
		
		rem get captured
		set bat_captureddir=!bat_retval2!\!bat_datedir!\CapturedFiles
		set bat_archiveddir=!bat_retval2!\!bat_datedir!\ArchivedFiles
		set bat_confirmeddir=!bat_retval2!\!bat_datedir!\ConfirmedFiles
		set bat_path2=!bat_retval2!\!bat_datedir!
		
	)  else (
		set vers=2
		set bat_cam=!bat_retval!
		
		rem get captured
		set bat_captureddir=!bat_retval2!\!bat_cam!\CapturedFiles
		set bat_archiveddir=!bat_retval2!\!bat_cam!\ArchivedFiles
		set bat_confirmeddir=!bat_retval2!\!bat_cam!\ConfirmedFiles
		set bat_path2=!bat_retval2!\!bat_cam!
		
	)
	
	
	rem get dirname                    '
	set bat_dirname=                   
	set bat_dirname2=                   
	if exist "!bat_archiveddir!" (
		for /f "usebackq tokens=*" %%X in (`dir "!bat_archiveddir!" /b /o-n`) do (
			set bat_dirname=%%X
			set bat_dirname2=%%X
		)
	)
	

rem exit /b
goto :EOF



	rem extracts the last path segment
:LASTFROMPATH [in]path [out]bat_retval
rem echo ...%~1...
	set bat_junk=%~1::
	set bat_junk=!bat_junk:\::=!
	set bat_junk=!bat_junk:::=!
rem echo bat_junk=!bat_junk!
	for /f "usebackq tokens=*" %%X in ('!bat_junk!') do (
rem 		echo #######%%X$$$$$$$$$
rem 		echo #######!bat_junk!$$$$$$$$$
		set bat_retval=%%~nX
		set bat_retval2=%%~dpX::
		set bat_retval2=!bat_retval2:\::=!
		set bat_retval2=!bat_retval2:::=!
	)
rem echo :LASTFROMPATH %1, !bat_retval2!, !bat_retval!
goto :EOF


:GETFFFOLDER
	for /f "usebackq tokens=1-2 delims==" %%d in (`find /i "FF  folder" "!bat_path!!bat_filename!"`) do (
		set bat_fffolder=%%~e
		set bat_ffdate=!bat_fffolder:~-20!
		set bat_ffdate=!bat_ffdate:~0,10!
	)
goto :EOF




:ERR1
	echo The directory, "%cd%\ArchivedFiles", does not exist. 
	exit /b 1

:ERR2
	echo The directory, "%cd%\ConfirmedFiles", does not exist. 
	exit /b 2


:PARSEDIR [in] bat_path=D:\CAMS\ArchivedFiles\2012_02_07_02_43_36
	set bat_dirname=%~nx1
:PARSEDIR_END
goto :EOF







:GETCOUNT [in] path\detectfile [out] bat_count1
rem echo call :GETCOUNT %*
	set bat_GC_detectfile=%~1
	
	rem Loop to extract the Meteor Count = value
	for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i "Meteor Count" "!bat_GC_detectfile!"`) do (
		set bat_temp=%%d
		set bat_GC_count=!bat_temp:~-6!
		if "!bat_GC_count!" equ "000000" (
			if "!bat_filesize!" GTR "480" (
				set bat_msg=; needs FTP_Reprocess
			)
		)
	)
:GETCOUNT_END
rem echo return-:GETCOUNT [!bat_GC_count!]
goto :EOF



:GETFIRSTCOMMENT
	set bat_commentsfile=comments_!bat_camera!.txt
	set bat_commentfirst=
	if not exist "!bat_emaildir!\!bat_commentsfile!" (
		set bat_commentsfile=comments.txt
		if not exist "!bat_emaildir!\!bat_commentsfile!" (
			goto :GETFIRSTCOMMENT_END
		)
	)
	
	set /a bat_commentline=0
	rem echo 2   for /f "usebackq tokens=*" %%f in ^(`type "!bat_emaildir!\!bat_commentsfile!"^) do ^(
	for /f "usebackq tokens=*" %%f in (`type "!bat_emaildir!\!bat_commentsfile!"`) do (
		set /a bat_commentline+=1
		if "!bat_commentline!" equ "1" (
			set bat_commentfirst=; %%f
		) else (
			rem
		)
	)
:GETFIRSTCOMMENT_END
rem echo :GETFIRSTCOMMENT_END
goto :EOF


:GETCOMMENTS
	set bat_commentsfile=comments_!bat_camera!.txt
	if not exist "!bat_emaildir!\!bat_commentsfile!" (
		set bat_commentsfile=comments.txt
		if not exist "!bat_emaildir!\!bat_commentsfile!" (
			goto :GETCOMMENTS_END
		)
	)
	
	set /a bat_commentline=0
	rem echo 3    for /f "usebackq tokens=*" %%f in ^(`type "!bat_emaildir!\!bat_commentsfile!"^) do ^(
	for /f "usebackq tokens=*" %%f in (`type "!bat_emaildir!\!bat_commentsfile!"`) do (
		set /a bat_commentline+=1
		if "!bat_commentline!" NEQ "1" (
			echo !bat_commentspace!%%f
		) else (
			rem
		)
	)
:GETCOMMENTS_END
rem echo :GETCOMMENTS_END
goto :EOF


rem another option is this:
	findstr "CAL..._*" "C:\d\CAMS\SubmissionFiles\2012_05_23\213\EmailFiles\FTPdetectinfo_scanned-213.txt"

returns:
	CAL213_2012_05_23_055017_435.TXT
	CAL213_2012_05_23_055017_435.TXT
	CAL213_2012_05_23_055017_435.TXT

:HELP
	echo [%date% %time%] %~nx0 %* [submissiondir=!bat_submissiondir!] [targetdir=!bat_targetdir!]
	Usage 

exit /b 9

:DONE
