
@echo off

:SETUP
	setlocal enableextensions enabledelayedexpansion

:MAIN

	cls
	echo Archived  Confirmed  Archived              Confirmed              Ratio
	echo ------    ------     -------------------   -------------------    -----

	if not exist "archivedfiles" goto :ERR1
	if not exist "confirmedfiles" goto :ERR2

	rem Loop through all the ".\SubmissionFiles\FTPdetectinfo.txt" files
	for /f "usebackq tokens=*" %%a in (`dir "SubmissionFiles\ftpdetectinfo_scanned.txt" /s/b`) do (

		set bat_msg= 

		rem Loop to extract the Meteor Count = value
		for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i /n "meteor count" "%%a"`) do (
			set bat_temp=%%d
			set bat_count1=!bat_temp:~-6!
			if "!bat_count1!" equ "000000" (
				set bat_msg=; needs FTP_Reprocess
			)
		)

		set bat_temp=%%a

		set bat_filename=%%~nxa
		set bat_path=%%~dpa&			rem get the path ("x:\cams\SubmissionFiles\[date/time]\EmailFiles
		set bat_pathlefta=!bat_path:\EmailFiles\=!

		set bat_dirname=!bat_pathlefta:~-19!&	rem Extract just the directory name (e.g. "2011_08_22_05_17_09")

		set bat_found=0&	rem Use this to determine if matching dir is found in ConfirmedFiles or not


		rem Loop to list all the FTPdetectinfo.txt files in the ConfirmedFiles directory. 
		rem Inside the loop, it will search for the bat_dirname in the resulting list.
		if not exist "SubmissionFiles\!bat_dirname!\EmailFiles\FTPdetectinfo_confirmed.txt" (
			set bat_dirname2=                   
			set bat_msg=!bat_msg!; not confirmed
			set bat_count2=000000

			rem Loops to remove leading zeros
			for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
			for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)
	
			if not defined bat_count1nz set bat_count1nz=0
			if not defined bat_count2nz set bat_count2nz=0
	
			rem logic to avoid divide by zero
			if "!bat_count2!" neq "000000" (
				rem set bat_count
				rem echo set /a bat_ratio=!bat_count1nz!/!!bat_count2nz!
				set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
			) else (
				set /a bat_ratio=0
			)
			echo !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!
		)

		for /f "usebackq tokens=*" %%b in (`dir "SubmissionFiles\ftpdetectinfo_confirmed.txt" /s/b`) do (
			rem To speed things up, skip if already found.
			if "!bat_found!" equ "0" (
				set bat_temp=%%b
				set bat_path2=%%~dpb!&	rem Extract everything but the filename ("\FTPdetectinfo.txt")
				set bat_path2=!bat_path2:\EmailFiles\=!
				set bat_dirname2=!bat_path2:~-19!&	rem Extract just the directory name (e.g. "2011_08_22_05_17_09")
	
				if "!bat_dirname!" equ "!bat_dirname2!" (
					set bat_found=1
					for /f "usebackq tokens=1,2 delims=\=" %%c in (`find /i /n "meteor count" "%%b"`) do (
						set bat_temp=%%d
						set bat_count2=!bat_temp:~-6!
					)

:STRIPZEROS
					rem Loops to remove leading zeros
					for /f "tokens=* delims=0" %%m in ("!bat_count1!") do (set bat_count1nz=%%m)
					for /f "tokens=* delims=0" %%m in ("!bat_count2!") do (set bat_count2nz=%%m)
	
					if not defined bat_count1nz set bat_count1nz=0
					if not defined bat_count2nz set bat_count2nz=0
	
					rem logic to avoid divide by zero
					if "!bat_count2!" neq "000000" (
						rem set bat_count
						rem echo set /a bat_ratio=!bat_count1nz!/!!bat_count2nz!
						set /a bat_ratio=!bat_count1nz!^/!!bat_count2nz!
					) else (
						set /a bat_ratio=0
					)
					echo !bat_count1!    !bat_count2!     !bat_dirname!   !bat_dirname2!    !bat_ratio!:1  !bat_msg!
				)
			)
		)
		if "!bat_found!" equ 0 (
			echo "%%a" not yet confirmed.
		)
	)
exit /b 0

:ERR1
	echo The directory, "%cd%\ArchivedFiles", does not exist. 
	exit /b 1

:ERR2
	echo The directory, "%cd%\ConfirmedFiles", does not exist. 
	exit /b 2
