rem @echo off
setlocal enabledelayedexpansion enableextensions

rem RENAME THIS FILE TO move.archived.bat and store it in the C:\CAMS directory.
rem
rem This script can be run stand-alone (before reprocessing) or called from within
rem the ftp_reprocess.bat script.

:SETUP
	setlocal enableextensions enabledelayedexpansion

    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP


	set move_targetlocation=%cd%
	set move_targetdrive=%cd:~0,2%
	set move_

:MAIN
	rem start the execution of the detection pass in background priority

	echo %date% %time%>move.archived.log

	rem move /Y c:\cams\archivedfiles .\ArchivedFiles

	call :CHECK
	if !errorlevel! neq 0 goto :DONE

	for /f "usebackq tokens=*" %%a in (`dir "c:\cams\archivedfiles" /s/b /ad /on`) do (
		echo %%a
		set move_srcdirfull=%%a
		set move_dirname=%%~nxa
		set move_targetdirfull=".\ArchivedFiles\!move_dirname!"

		echo md ".\ArchivedFiles\!move_dirname!"
		     md ".\ArchivedFiles\!move_dirname!"

		echo move /Y "%%a\*.*" ".\ArchivedFiles\!move_dirname!"
		    move /Y "%%a\*.*" ".\ArchivedFiles\!move_dirname!"

		ECHO RD /s /q "%%a"
		     RD /s /q "%%a"

	)
:MAIN2
	for /f "usebackq tokens=*" %%a in (`type "!move_targetdirfull!\ftpdetectinfo.txt"`) do (
		set move_inputline=%%a
		set move_outputline=!move_inputline:C:=%move_targetdrive%!
		if "!move_inputline!" neq "!move_outputline!" (
			echo !move_inputline!
			echo !move_outputline!
			echo.
			echo.
		)

		title !move_outputline!
		echo !move_outputline!>>".\ArchivedFiles\!move_dirname!\FTPdetectinfo.test.txt"

	)
	copy /Y ".\ArchivedFiles\!move_dirname!\FTPdetectinfo.test.txt" ".\ArchivedFiles\!move_dirname!\FTPdetectinfo.txt"
	del /q ".\ArchivedFiles\!move_dirname!\FTPdetectinfo.test.txt"

exit/b 0

:CHECK
	rem check if the source directories exist.
	if not exist "c:\cams" goto :HELP
	if not exist "c:\cams\archivedfiles" goto :HELP
	dir "c:\cams\ArchivedFiles" /s/b>junk.txt
	for /f "tokens=*" %%x in ("junk.txt") do (
		if "%%~zx" equ "0" (
			exit /b 0
		) 
	)
exit /b 1


	set ftp_wmdy=%date%

	set ftp_hhmmssdd=%time%

	set ftp_year=%ftp_wmdy:~-4%
	set ftp_mo=%ftp_wmdy:~4,2%
	set ftp_mo2=%ftp_mo%
	if %ftp_mo% LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	set ftp_da=%ftp_wmdy:~7,2%
	set ftp_da2=%ftp_da%
	if %ftp_da% LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

	set ftp_hr=%ftp_hhmmssdd:~0,2%
	set ftp_mi=%ftp_hhmmssdd:~3,2%
	set ftp_se=%ftp_hhmmssdd:~6,5%

	call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	rem set /a ftp_jd=%ftp_jd%-1
	call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2

	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%


	for /f "usebackq tokens=*" %%a in (`dir ".\CapturedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_captureddir=%%~nxa
	)

	set ftp_

	for /f "usebackq tokens=*" %%a in (`dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_archiveddir=%%~nxa
	)

	set ftp_

	if defined ftp_archiveddir (
		dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad>"ftp_reprocess.log"
		dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad
		goto :ERR1
	)

:SRCHDRIVEC
	for /f "usebackq tokens=*" %%a in (`dir "c:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_archiveddir=%%~nxa
	)

	set ftp_

	if defined ftp_archiveddir (
		dir "C:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad>"ftp_reprocess.log"
		dir "C:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad
		goto :ERR1
	)

:CONTINUE


	@echo start "FTP_Reprocess" /low ".\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%">>ftp_reprocess.log
	echo start "FTP_Reprocess" /low ".\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%"
goto :DONE

:ERR1
	@echo.
	@echo.
	@echo "%cd%\ArchivedFiles\%ftp_archiveddir%" already exists. Do you want to
	@echo continue to overwrite the existing files? [Y/N] Y
	@goto :CONTINUE
	@set /p retval=continue to overwrite the existing files? [Y/N] 
	@if /i "%retval%" equ "y" goto :CONTINUE
goto :DONE


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b

:HELP
	@echo off
	echo.
	echo %0
	echo.
	echo This script can be called either stand-alone or from within
	echo ftp_reprocess.bat script.  The purpose of the script is to
	echo move the FTPdetectinfo.txt file from C:\CAMS\ArchivedFiles...
	echo directory to the local .\ArchivedFiles\... directory.
	echo.
	echo It moves the c:\cams\ArchivedFiles\... directory to the
	echo local .\ArchivedFiles\... directory.  Then it patches the 
	echo FTPdetectinfo.txt file so that the drive letters for FF and CAL
	echo are correct. 
	echo.
	echo
exit /b 9


:DONE
