 @echo off
setlocal enableextensions enabledelayedexpansion


:SETUP
	if "%~1" equ "" goto :HELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP

	echo.%*|find /i "/v"
	if %errorlevel% equ 0 (set bat_verbose=true) else (set bat_verbose=false)
	echo.%*|find /i "/ok"
	if %errorlevel% equ 0 (set bat_OK=true) else (set bat_OK=false)


:MAIN
	set bat_stars=*****************************************************************
	set /a bat_prevsecs=0
	set /a bat_skippedtotal=0
	set /a bat_filecount=0
	
	for /f "usebackq tokens=*" %%a in (`dir "%~1\*.bin" /b`) do (
		set bat_file=%%a
		set bat_skipped_lastfile=%%nxa
		set /a bat_filecount+=1
		if !bat_filecount! equ 1 (
			set bat_skipped_firstfile=!bat_file!
		)
		
		set bat_hh=!bat_file:~15,2!
		set bat_mm=!bat_file:~17,2!
		set bat_ss=!bat_file:~19,2!
		set bat_ssms=!bat_file:~22,3!

		rem strip leading zeros
		set /a "bat_h=100!bat_hh! %% 100"
		set /a "bat_m=100!bat_mm! %% 100"
		set /a "bat_s=100!bat_ss! %% 100"
		set bat_sms=!bat_s!!bat_ssms!
		
		set /a bat_secs=bat_h*3600+bat_m*60+bat_s
		set bat_secs2=!bat_secs!!bat_ssms!
		set bat_secs3=!bat_secs!.!bat_ssms!
		set bat_current=!bat_hh!!bat_mm!!bat_ss!!bat_ssms!
		
		set /a bat_delta=bat_secs2-bat_prevsecs
		
		if !bat_delta! LSS 8541 (
			set bat_delta=8541
		)
		set /a bat_skipcount"=(bat_delta-8541) / 33"
		if !bat_skipcount! gtr 4096 (
			set /a bat_skipcount=0
		)
		set bat_msg=  
		
		if "!bat_skipcount!" gtr "0" (
			set bat_msg=skipped !bat_skipcount!
		)
		
		set bat_deltad=        !bat_delta:~0,-3!.!bat_delta:~-3!
		set bat_deltad=!bat_deltad:~-7!
		
		set bat_secs2d=        !bat_secs2:~0,-3!.!bat_secs2:~-3!
		set bat_secs2d=!bat_secs2d:~-12!
		
		set bat_prevsecsd=        !bat_prevsecs:~0,-3!.!bat_prevsecs:~-3!
		set bat_prevsecsd=!bat_prevsecsd:~-12!
		
		if "!bat_skipcount!" gEQ "1" (
			call :SETSTARS !bat_skipcount!
			if !bat_verbose! equ true (
				echo !bat_file!    !bat_secs2d!  !bat_deltad!	!bat_msg!
			)
		) else (
			if !bat_OK! equ true (
				echo !bat_file!    !bat_secs2d!  !bat_deltad!	!bat_msg!
			)
		)


		if not defined bat_startingtime (
			set /a bat_startingtime=bat_secs2
		)
		
		set /a bat_endingtime=bat_secs2
		
		set /a bat_skippedtotal+=bat_skipcount
		set bat_prevsecs=!bat_secs2!
		
		set /a "bat_rem=bat_filecount %% 20"
		if !bat_rem! equ 0 (
			title File count: !bat_filecount!  Skipped count: !bat_skippedtotal!
		)
	)

	set /a bat_totalsecs=bat_endingtime-bat_startingtime
	set /a bat_totalmin=bat_totalsecs/60
	set /a bat_totalhrs=bat_totalsecs/3600
	set /a bat_avgskipped=bat_skippedtotal*1000/!bat_totalmin:~0,-3!
	echo.
	echo %~1
	echo First File: !bat_skipped_firstfile!  Last File: !bat_file!
	echo Total time: !bat_totalsecs:~0,-3!.!bat_totalsecs:~-3! secs   or  !bat_totalmin:~0,-3!.!bat_totalmin:~-3! minutes   or   !bat_totalhrs:~0,-3!.!bat_totalhrs:~-3! hours
	echo Total Files: !bat_filecount!
	echo Total skipped: !bat_skippedtotal!   Avg dropped frames per min:   !bat_avgskipped:~0,-3!.!bat_avgskipped:~-3!
	set /a bat_totalframes="!bat_filecount! * 256"
	set /a bat_framespersec=!bat_totalframes!*1000 / (!bat_totalsecs!/1000)
        echo Total frames: !bat_totalframes!    Avg Frames per sec: !bat_framespersec:~0,-3!.!bat_framespersec:~-3!

echo.
exit /b

:SETSTARS bat_skipcount
	set bat_msg=!bat_msg!		!bat_stars:~0,%1!
goto :EOF

:HELP
	echo.
	echo %~n0
	echo.
	echo Usage: %~n0  directory   [/v] [/ok]
	echo.
	echo Displays the dropped frames from the specified capture session (directory)
	echo.
	echo    where /v    means verbose mode, which lists the files that have skipped frames
	echo          /ok   means to list the files that don't have skipped frames
	echo.
exit /b
