 @echo off
setlocal enableextensions enabledelayedexpansion


:SETUP
	if "%~1" equ "" goto :HELP
    echo.%*|find /i "/?">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/h">nul:
    if %errorlevel% equ 0 goto :HELP
    echo.%*|find /i "/help">nul:
    if %errorlevel% equ 0 goto :HELP
    
    set bat_exedir=%~dp0::
    set bat_exedir=!bat_exedir:\::=!
    set bat_exedir=!bat_exedir:::=!
    
    set bat_caldir=!bat_exedir!\Cal

	set bat_verbose=
	set bat_OK=

	echo.%*|find /i "/v"
	if %errorlevel% equ 0 (set bat_verbose=true) else (set bat_verbose=false)
	echo.%*|find /i "/ok"
	if %errorlevel% equ 0 (set bat_OK=true) else (set bat_OK=false)


:MAIN
	echo ===========================================================================
	echo [%date% %time%]   "%~dpnx0" %*
	echo.

	set bat_stars=*****************************************************************
	set /a bat_prevsecs=0
	set /a bat_skippedtotal=0
	set /a bat_filecount=0
	
	for /f "usebackq tokens=*" %%a in (`dir "%~1\*.bin" /b`) do (
		set bat_file=%%a
		set bat_camera=!bat_file:~2,3!
		set bat_skipped_lastfile=%%nxa

		set /a bat_filecount+=1
		if !bat_filecount! equ 1 (
			set bat_skipped_firstfile=!bat_file!
			
			call :GETFPS !bat_camera!
			echo Seconds for 256 frames per FF file at !bat_camera_framerate:~0,-2!.!bat_camera_framerate:~-2! fps = [!bat_fps:~0,-3!.!bat_fps:~-3! secs]
			echo    ^(anything slower than that implies skipped frames^)
			echo.
			if !bat_verbose! equ true (
				echo File Name                                Day secs    FF sec	Message
				echo -------------------------------------    ---------   ------	-------------------------------------------
			)
		)
		
		rem Get timestamp
		set bat_hh=!bat_file:~15,2!
		set bat_mm=!bat_file:~17,2!
		set bat_ss=!bat_file:~19,2!
		set bat_ssms=!bat_file:~22,3!

		rem strip leading zeros
		set /a "bat_h=100!bat_hh! %% 100"
		set /a "bat_m=100!bat_mm! %% 100"
		set /a "bat_s=100!bat_ss! %% 100"
		set bat_sms=!bat_s!!bat_ssms!
		
		set /a "bat_secs=bat_h*3600+bat_m*60+bat_s"
		set bat_secs2=!bat_secs!!bat_ssms!
		set bat_secs3=!bat_secs!.!bat_ssms!
		set bat_current=!bat_hh!!bat_mm!!bat_ss!!bat_ssms!
		
		if "!bat_prevsecs!" equ "0" (
			set bat_prevsecs=!bat_secs2!
		)

		set /a "bat_delta=bat_secs2-bat_prevsecs"
		if !bat_delta! LSS !bat_fps! (
			set bat_delta=!bat_fps!
		)
		rem set /a bat_skipcount"=(bat_delta-!bat_fps!) / 33"
		set /a bat_skipcount"=(bat_delta-!bat_fps!)*!bat_camera_framerate!/100000"
rem echo                              bat_delta=!bat_delta! = !bat_secs2! - !bat_prevsecs!   bat_skipcount=!bat_skipcount!
rem 		if !bat_skipcount! gtr 4096 (
rem 			set /a bat_skipcount=0
rem 		)
		set bat_msg=  
		
		if "!bat_skipcount!" gtr "0" (
			set bat_msg=skipped !bat_skipcount!
		)
		
		set bat_deltad=        !bat_delta:~0,-3!.!bat_delta:~-3!
		set bat_deltad=!bat_deltad:~-7!
		
		set bat_secs2d=        !bat_secs2:~0,-3!.!bat_secs2:~-3!
		set bat_secs2d=!bat_secs2d:~-12!
		
		set bat_prevsecsd=        !bat_prevsecs:~0,-3!.!bat_prevsecs:~-3!
		set bat_prevsecsd=!bat_prevsecsd:~-12!
		
		if "!bat_skipcount!" gEQ "1" (
			if "!bat_skipcount!" EQU "1" (
				set bat_skipcount=1
				set bat_skipcount2=1
			) else (
					set /a "bat_skipcount2=bat_skipcount*10/12+5"
					set bat_skipcount2=!bat_skipcount2:~0,-1!
					
					if !bat_skipcount2! lss 3 (
						set /a bat_skipcount2=2
					)
			)

			call :SETSTARS !bat_skipcount2!
			if !bat_verbose! equ true (
				echo !bat_file! !bat_secs2d!  !bat_deltad!	!bat_msg!
			)
		) else (
			if !bat_OK! equ true (
				echo !bat_file! !bat_secs2d!  !bat_deltad!	!bat_msg!
			)
		)


		if not defined bat_startingtime (
			set /a bat_startingtime=bat_secs2
		)
		
		set /a bat_endingtime=bat_secs2
		
		set /a bat_skippedtotal+=bat_skipcount
		set bat_prevsecs=!bat_secs2!
		
		set /a "bat_rem=bat_filecount %% 200"
		if !bat_rem! equ 0 (
			title File count: !bat_filecount!  Skipped count: !bat_skippedtotal!
		)
	)

	set /a bat_totalsecs=bat_endingtime-bat_startingtime
	set /a bat_totalmin=bat_totalsecs/60
	set /a bat_totalhrs=bat_totalsecs/3600
	set /a bat_avgskipped=bat_skippedtotal*1000/!bat_totalmin:~0,-3!

	if !bat_filecount! equ 0 (
		set bat_avgskippedperfile=0.0
	) else (
		set /a "bat_avgskippedperfile=bat_skippedtotal*1000/bat_filecount"
		set bat_avgskippedperfile=!bat_avgskippedperfile:~0,-3!.!bat_avgskippedperfile:~-3!
		if !bat_skippedtotal! GTR 214748364 (
			set bat_avgskippedperfile=!bat_avgskippedperfile! overflow: too many skipped frames
		)
	)

	echo.
	echo     %~1
	echo     Frames per FF file:       256 video frames
	echo     Frame rate:               !bat_camera_framerate:~0,-2!.!bat_camera_framerate:~-2! frames per second
	echo     Proper time for FF file:  !bat_fps:~0,-3!.!bat_fps:~-3! seconds
	echo.
	echo     First File: !bat_skipped_firstfile!  Last File: !bat_file!
	echo     Total time: !bat_totalsecs:~0,-3!.!bat_totalsecs:~-3! secs   or  !bat_totalmin:~0,-3!.!bat_totalmin:~-3! minutes   or   !bat_totalhrs:~0,-3!.!bat_totalhrs:~-3! hours
	echo     Total Files: !bat_filecount!
	echo     Total skipped: !bat_skippedtotal!   Avg dropped frames per FF file: !bat_avgskippedperfile!   Avg dropped frames per min:   !bat_avgskipped:~0,-3!.!bat_avgskipped:~-3!
	set /a bat_totalframes="!bat_filecount! * 256"
	set /a bat_framespersec=!bat_totalframes!*1000 / (!bat_totalsecs!/1000)
	echo     Total frames: !bat_totalframes!   Avg Captured Frames per sec:   !bat_framespersec:~0,-3!.!bat_framespersec:~-3!

echo.
exit /b


:GETFPS [in] bat_camera [out] bat_fps
	call :GETCAMERAENTRY !bat_camera!
	call :READCAMERAFILE "!bat_camerafile!"
	set /a "bat_fps=256000000/!bat_camera_framerate!+5"
	set bat_fps=!bat_fps:~0,-1!
:goto :EOF


:GETCAMERAENTRY [in] bat_camera [out] bat_camerafile
	set bat_retval=
	set bat_lat=
	set bat_long=
	set bat_height=
	set bat_camerafile=
	set bat_sitecode=
	set bat_sitename=

	for /f "usebackq tokens=1-7 skip=2" %%b in (`find /i "!bat_camera!   " "!bat_caldir!\CameraSites-!bat_camera!.txt"`) do (
		set bat_lat=%%c
		set bat_long=%%d
		set bat_height=%%e
		set bat_camerafile=!bat_caldir!\%%f
		set bat_sitecode=%%g
		set bat_sitename=%%h
	)
	set bat_retval=!bat_camerafile!
:goto :EOF


:READCAMERAFILE [in] bat_camerafile [out] bat_camera_framerate
	set bat_retval=
	set bat_camera_framerate=

	for /f "usebackq tokens=1-7 skip=2" %%c in (`find /i "frame rate" "!bat_camerafile!"`) do (
		set bat_camera_framerate=%%g
	)
	
	for /f "usebackq tokens=1,2 delims=." %%c in ('!bat_camera_framerate!') do (
		set bat_left=%%c
		set bat_right=%%d
	)

	set bat_camera_framerate=!bat_left!!bat_right!
	set bat_retval=!bat_camera_framerate!
goto :EOF


:SETSTARS [in] bat_skipcount2
	set bat_temp=!bat_stars:~0,%1!
	if !bat_skipcount! GEQ 256 (
		set bat_temp=!bat_temp! ^(!bat_skipcount!^)
	)
	set bat_msg=!bat_msg!	!bat_temp!
goto :EOF




:HELP
	echo.
	echo %~n0
	echo.
	echo Usage: %~n0  directory   [/v] [/ok]
	echo.
	echo Displays the dropped frames from the specified capture session (directory)
	echo.
	echo    where /v    means verbose mode, which lists the files that have skipped frames
	echo          /ok   means to list the files that don't have skipped frames
	echo.
exit /b
