 @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem


echo %~nx0

:CHECKHELP
echo :CHECKHELP %*
    	echo.%*|find /i "/?">nul:
    	if %errorlevel% equ 0 goto :HELP
    	echo.%*|find /i "/h">nul:
    	if %errorlevel% equ 0 goto :HELP
    	echo.%*|find /i "/help">nul:
    	if %errorlevel% equ 0 goto :HELP
	echo.
goto :SETUP

	Flowchart:
		- Obtain the processed ".\ConfirmedFiles\<dirname>"
		- Create the target ".\SubmissionFiles\<dirname>" directory tree:
		  - EmailFiles
		  - BinFiles
		  - AviFiles
		- Copy the ".\ArchivedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_scanned.txt"
		- Copy the ".\ConfirmedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_confirmed.txt"
		- Copy the ".\ArchivedFiles\<dirname>\CameraTimeOffsets.txt" file 

		- Move the ".\ConfirmedFiles\<dirname>\*.bin" files to 
		  the ".\SubmissionFiles\<dirname>\BinFiles" directory.
		- Read the ".\SubmissionFiles\<dirname>\ftpdetectinfo.txt" file and 
		  get the following:
			- Meteor Count     from line number 1
			- FF  folder       from line number 5
			- CAL folder       from line number 6
			- calibration file from line number 14
			- camera number    from calibration file
	==============================================================		
	New changes 09/08/2011:
		x Add a " [date/time]\EmailFiles\Cal-[camera]" directory and place the calibration files there.  (I obtain the calibration filename by actually reading the ftpdetectinfo.txt file and then copying the filename from the Cal directory). 
		
		x Copy the ".\Cal\[calfile date/time] to "[date/time]\EmailFiles\Cal-[camera]" but don't change the filename.
		
		x Copy the ".\Cal\CameraSites.txt" file to "[date/time]\EmailFiles\Cal-[camera]" and rename it to "CameraSites-[camera].txt"
		
		x Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[camera]-[meteor count].txt" with the header stripped from it.
		
		x Copy the ".\ArchivedFiles\[date/time]\FTPdetectinfo.txt" file to "[date/time]\EmailFiles\FTPdetectinfo_scanned-[camera]-[meteor count].txt" with the header stripped from it.
		
		x I think that I will also add a file with a name to reflect the meteor count "archived=[count], confirmed=[count].txt" to make it easier to see
		
		- Copy the comments.txt file

	New changes 09/21/2011:
		(1) Change thesae changes are to make it easier to restore the files to the 
		x:\CAMS basedir where they can be reprocessed by placing the files in a 
		subdir tree structure under .\SubmissionFiles\[date] that matches the source
		tree structure.
		
		(2) Copy the FF213_20110815_050001_207_0034816.bin type file that was the one used
		for calibration into the ".\SubmissionFiles\[date]\EmailFiles\Cal-213" directory.
		
		(3) 
		
	Note: All the examples will use the following sample names based on 08/15/2011 data:
	   C:\CAMS\ArchivedFiles\2011_08_15_04_28_20
	   C:\CAMS\ArchivedFiles\2011_08_15_04_28_20\*.txt (ftpdetectinfo.txt, etc.)
	   C:\CAMS\CapturedFiles\2011_08_15_04_28_20
	   C:\CAMS\CapturedFiles\2011_08_15_04_28_20\FF213_20110815_050006_172_0057344.bin (calibration file)
	   C:\CAMS\ConfirmedFiles\2011_08_15_04_28_20

	rem    
	
	
:SETUP
	set return=goto :EOF
	
	set bat_startlocation=%cd%&					rem C:\CAMS
	set bat_startdrive=%cd:~0,2%&				rem C:
	
	if /i "!bat_startlocation:~-5!" neq "\CAMS" (
		echo     ERROR: You must start from x:\CAMS directory. 
		exit /b 1
	)
	
	call :PARSEARGS %~1 %~dp1 %~nx1
	
	set bat_caldir=!bat_startlocation!\Cal
	set bat_logfile=!bat_startdrive!\cams\%~0.log
	
	if not exist "!bat_mainspec!\!bat_getdirname!" (
		echo     ERROR: specified source dir doesn't exist:^("!bat_mainspec!\!bat_getdirname!"^)
		exit /b 1
	) else (
		echo     bat_mainspec=!bat_mainspec!
	)

	goto :MAIN
	
:PARSEARGS
echo :PARSEARGS %1, %~dp1, %~nx1
	set bat_getdirname=%~nx1
	set bat_mainspec=!bat_startlocation!\ConfirmedFiles
	set bat_arg1=%~1
	set bat_mainfilter=^|find /i "!bat_getdirname!"
	
	if "!bat_arg1!" neq "" (
		if ":" equ "!bat_arg1:~1,1!" (
			echo     Format: x:\CAMS\ConfirmedFiles\date/time
			rem format is: x:\CAMS\ConfigFiles\2011_08_15_00_00_00
			set bat_startdrive=!bat_arg1:~0,2!
			set bat_startlocation=!bat_startdrive!\CAMS
			set bat_mainspec=!bat_startlocation!\ConfirmedFiles
			set bat_mainfilter=^|find /i "!bat_getdirname!"
		) else (
			rem look for 2011_08_15_00_00_00
			echo     Scanning like this: %~1^|find /i /c "ConfirmedFiles\"
			echo     %~1|find /i /c "ConfirmedFiles\"
			echo     !errorlevel!
			if !errorlevel! equ 0 (
				echo     Format: ConfirmedFiles\!bat_getdirname!
				set bat_mainspec=!bat_startlocation!\ConfirmedFiles
				set bat_mainfilter=^|find /i "!bat_getdirname!"
			) else (
				echo     Format: 2011_08_15_00_00_00
				set bat_mainspec=!bat_startlocation!\ConfirmedFiles
				set bat_mainfilter=|find /i /c "!bat_getdirname!"
			)
		)
	)
	
%return%


:MAIN
	echo :MAIN
	rem start the execution of the detection pass in background priority

	echo %date% %time%>"%bat_logfile%"
	set bat_>>"%bat_logfile%"
	call :GETDIRNAMES
	echo waiting 2 seconds...
	start /w wait 2
goto :DONE




:GETDIRNAMES
	echo :GETDIRNAMES [%*]
	rem Loop to iterate through all directory names under the ..\ConfirmedFiles structure.
	echo     for /f "usebackq tokens=*" %%a in (`dir "!bat_mainspec!" /s/b /ad /on !bat_mainfilter! 2^>nul`) do ...
	for /f "usebackq tokens=*" %%a in (`dir "!bat_mainspec!" /s/b /ad /on !bat_mainfilter! 2^>nul`) do (
		echo     %%~a
		echo.

		set bat_confirmeddirfull=%%a&		rem C:\CAMS\ConfirmedFiles\2011_08_15_04_28_20
		set bat_dirname=%%~nxa&				rem 2011_08_15_04_28_20
		set bat_dirdate=!bat_dirname:~0,10!

		call :GETCAMERAFROMDETECT "!bat_confirmeddirfull!"

		rem Note: The date/time in the CapturedFiles directory will be different
		rem       than the date/time in the ConfirmedFiles directory.  This is 
		rem       because the date/time of the CapturedFiles directory is 
		rem       the date/time when the directory was created, which is
		rem       several seconds before the end of the first 8 second video
		rem       section.  The date/time of the ConfirmedFiles and ArchivedFiles
		rem       directory is the date/time of the first file in the CapturedFiles
		rem       directory.
		set bat_yyyymmdd=!bat_dirname:~0,10!&	rem 2011_08_15
		set bat_captureddir=%bat_startlocation%\CapturedFiles\!bat_yyyymmdd!&	rem C:\CAMS\CapturedFiles\2011_08_15

		set bat_submissiondir=%bat_startlocation%\SubmissionFiles\!bat_dirdate!\!bat_camera!&	rem C:\CAMS\SubmissionFiles\213\2011_08_15
		set bat_archiveddirfull=%bat_startlocation%\ArchivedFiles\!bat_dirname!&	rem C:\CAMS\ArchivedFiles\2011_08_15_04_28_20
		set bat_emailfilesdir=!bat_submissiondir!\EmailFiles&						rem C:\CAMS\SuibmissionFiles\2011_08_15_04_28_20\EmailFiles
		
		set bat_submitarchived=!bat_submissiondir!\ArchivedFiles\!bat_dirname!&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\ArchivedFiles\2011_08_15_04_28_20
		set bat_submitconfirmed=!bat_submissiondir!\ConfirmedFiles\!bat_dirname!&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\AConfirmedFiles\2011_08_15_04_28_20
		set bat_submitcal=!bat_submissiondir!\Cal&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\Cal
		set bat_submitcapturedbase=!bat_submissiondir!\CapturedFiles&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\CapturedFiles

		set bat_binfilesdir=!bat_submissiondir!\ERROR1&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\BinFiles
		set bat_avifilesdir=!bat_submissiondir!\ERROR2&		rem C:\CAMS\SubmissionFiles\2011_08_15_04_28_20\AviFiles
		
		if "!bat_dirname!" equ "" (
			echo.
			echo.
			echo     ERROR - bat_dirname="!bat_dirname!"   ConfirmedFiles dir="%%a"
			echo.
			echo.
		) else (
			call :CREATEDIRS "!bat_dirname!"
			call :MOVEFILES "!bat_dirname!"
			call :READFILE

			call :COPYCALFILE "!bat_calfilename!" "!bat_camera!"

			
			call :STRIPHEADER bat_countconfirmed "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "confirmed"
			call :STRIPHEADER bat_countarchived  "!bat_emailfilesdir!" "!bat_dirname!" "!bat_camera!" "scanned"

			call :COUNTFILE !bat_countarchived! !bat_countconfirmed!
		)

		echo.
		echo call submit.email "!bat_dirdate!"
		     call submit.email "!bat_dirdate!"
	)&	rem end of for /f %%a in (`dir "!bat_mainspec!" /s/b /ad /on !bat_mainfilter! 2^>nul`)
	
%return%


	rem usage: call :CREATEDIRS "!bat_dirname!"
:CREATEDIRS
	echo :CREATEDIRS %*
	echo     md "!bat_emailfilesdir!"
	         md "!bat_emailfilesdir!"
		     
	echo     md "!bat_emailfilesdir!\Cal-!bat_camera!"
	         md "!bat_emailfilesdir!\Cal-!bat_camera!"
		     
	echo     md "!bat_submissiondir!\ArchivedFiles"	     
	         md "!bat_submissiondir!\ArchivedFiles"	
	     
	echo     md "!bat_submissiondir!\ConfirmedFiles"	     
	         md "!bat_submissiondir!\ConfirmedFiles"	
	     
	echo     md "!bat_submitcal!"	     
	         md "!bat_submitcal!"
	     
	echo     md "!bat_submitcapturedbase!"	     
	         md "!bat_submitcapturedbase!"	     

%return%


:MOVEFILES
echo :MOVEFILES %*
	echo     copy /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
	         copy /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
	if not exist "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt" (
		echo     Failed to copy
		pause
	)

	if exist "!bat_confirmeddirfull!\comments.txt" (
		echo     copy /Y "!bat_confirmeddirfull!\comments.txt" "!bat_emailfilesdir!"
				 copy /Y "!bat_confirmeddirfull!\comments.txt" "!bat_emailfilesdir!"
		if not exist "!bat_emailfilesdir!\comments.txt" (
			echo     Failed to copy
			pause
		)
	)
		  

	echo     move /Y "!bat_confirmeddirfull!" "!bat_submitconfirmed!"
		     move /Y "!bat_confirmeddirfull!" "!bat_submitconfirmed!"
	if !errorlevel! neq 0 (
		echo     Failed to move
		pause
	)
	
	if exist "!bat_confirmeddirfull!" (
		echo     Failed to move
		pause
	)
		  
		 
    echo     copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned.txt"
             copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned.txt"
             
    echo Packaged for submission on %date% %time%^>"!bat_emailfilesdir!\submit.txt"
    echo Packaged for submission on %date% %time%>"!bat_emailfilesdir!\submit.txt"
    
    rem Can't do this one now because the dir hasn't been created yet
    rem echo Packaged for submission on %date% %time%^>"!bat_captureddir!\submit.txt"
    rem echo Packaged for submission on %date% %time%>"!bat_captureddir!\submit.txt"

    echo     copy /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"
             copy /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"


    echo     copy /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"
             copy /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"

	echo     copy /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"
	         copy /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"

	echo     copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"
	         copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"

	echo     move /Y "!bat_archiveddirfull!" "!bat_submitarchived!"
		     move /Y "!bat_archiveddirfull!" "!bat_submitarchived!"
	if exist "!bat_archiveddirfull!" (
		echo     Failed to move "!bat_confirmeddirfull!" to "!bat_submitconfirmed!"
		pause
	)
		  

	rem echo robocopy.exe "%%~dpnxb" "!bat_submitcapturedbase!\Captured\%%~nxb" /e /move
	rem  robocopy.exe "%%~dpnxb" "!bat_submitcapturedbase!\Captured\%%~nxb" /e /move
	for /f "usebackq tokens=*" %%b in (`dir "!bat_captureddir!*.*" /s/b /ad /on`) do (
		rem echo md "!bat_submitcapturedbase!\%%~nxb"
		rem      md "!bat_submitcapturedbase!\%%~nxb"
		     
		echo     move /y "%%~dpnxb" "!bat_submitcapturedbase!"
		         move /y "%%~dpnxb" "!bat_submitcapturedbase!"
		if exist "%%~dpnxb" (
			echo     Failed to move "!bat_confirmeddirfull!" to "!bat_submitconfirmed!"
			pause
		)
	)

%return%


	rem Loop to read the FTPdetectinfo.txt file.
:READFILE
echo :READFILE "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt", %*

	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	
	echo     for /f "usebackq tokens=*" %%a in ^(`type "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"`^) do ...
	for /f "usebackq tokens=*" %%a in (`type "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"`) do (
		set bat_temp=%%a
		set bat_temp=!bat_temp:~0,5!
		rem title bat_linecount=!bat_linecount! %%a
		set /a bat_linecount+=1
		if !bat_linecount! equ 1 (
			call :GETMETEORCOUNT bat_countconfirmed %%a
		) else (
			if !bat_linecount! equ 5 (
				call :GETFFDIR "%%a"
			) else (
				if !bat_linecount! equ 6 (
					rem call :GETCALDIR "%%a"
				) else (
					if !bat_linecount! equ 13 (
						call :GETCAMERA
						set bat_fffilename=%%a
						title !bat_fffilename!
					) else (
						if !bat_linecount! equ 14 (
							call :GETCALNAME "%%a"
						) else (
							if "!bat_temp!" equ "FF!bat_camera!" (
								set bat_fffilename=%%a
								title working on FF file: "!bat_fffilename!"
								set /a bat_filecount+=1
							)
						)
					)
				)
			)
		)
	)
%return%



:GETMETEORCOUNT
	rem Usage: call :GETMETEORCOUNT {return variable name} Meteor Count = 000533
	
	set bat_temp=%4
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	rem Strip leading zeros
	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set %1=%%a)
	if not defined %1 set %1=0
echo :GETMETEORCOUNT %* [!%1!]
%return%	


:GETEVENTCOUNT [in]detectfile [out]bat_retval
	set bat_tempfile=%~1
	set bat_retval=0

	if exist "!bat_tempfile!" (
		set /a bat_countdashes=0
	echo        for /f "usebackq tokens=3" %%X in ^(`find /i /c  ".bin" "!bat_tempfile!"`^) ...
		for /f "usebackq tokens=3" %%X in  (`find /i /c  ".bin" "!bat_tempfile!"` ) do (
			if "%%X" neq "" (
				set /a bat_countdashes=%%X
				title !bat_countdashes!
			)
		)

		set bat_countdashes=000000!bat_countdashes!
		set bat_countdashes=!bat_countdashes:~-6!
		echo     Meteor Count = !bat_countdashes!
		title Meteor Count = !bat_countdashes!  "!bat_tempfile!" 
		set bat_retval=bat_countdashes
	) else (
		echo     File not found - "!bat_tempfile!"
	)
%return%


:STRIPHEADER
echo :STRIPHEADER %*
	rem Usage: call STRIPHEADER bat_variable sourcefile targetfile
	rem Copy the ".\ConfirmedFiles\[date/time]\FTPdetectinfo.txt file to 
	rem "[date/time]\EmailFiles\FTPdetectinfo_confirmed-[bat_camera]-[meteor count].txt" 
	rem with the header stripped from it.
	
	echo     Stripping header to: "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
	
	set bat_sourcefile=%~5
	
	set /a bat_countscan=0
	set /a bat_countevent=0
	
	set /a bat_remain=0
	TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d

	call :GETEVENTCOUNT "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"

	echo     for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"`)
	echo     This step may take along time, please be patient...
	for /f "usebackq tokens=*" %%d in (`type "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!.txt"`) do (
		set bat_linebuf=%%d
		set /a bat_countscan+=1
		if "!bat_countscan!" equ "1" (
			call :GETMETEORCOUNT  %1 %%~d
			if exist "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt" (
				del "!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
			)
			TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
		) else (
			if !bat_countscan! GTR 11 (
				echo %%d>>"!bat_emailfilesdir!\FTPdetectinfo_!bat_sourcefile!-!bat_camera!-!%1!.txt"
				if /i "!bat_linebuf:~0,6!" equ "FF!bat_camera!_" (
					set /a bat_countevent+=1
					set /a bat_remain=!%1!-!bat_countevent!
					TITLE :STRIPHEADER %* !%1!-!bat_countevent!=!bat_remain!  %%d
				)
			)
		)
	)
	
%return%


:GETFFDIR
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
echo :GETFFDIR %*  [!bat_ffdir!]
%return%


:GETCALDIR
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_caldir=!bat_temp2:C:=%bat_startdrive%!
	)
echo :GETCALDIR %*  [!bat_caldir!]
%return%


:GETCALNAME
	rem 
	set bat_calfilename=%~1
echo :GETCALNAME %*  [!bat_calfilename!]
%return%


:COPYCALFILE
echo :COPYCALFILE %*
	if not exist "!bat_emailfilesdir!\Cal-!bat_camera!" (
		echo     md "!bat_emailfilesdir!\Cal-!bat_camera!"
			     md "!bat_emailfilesdir!\Cal-!bat_camera!"
	)

	echo     copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!\Cal-!bat_camera!"
	         copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!\Cal-!bat_camera!"

	echo     copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_submitcal!"
	         copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_submitcal!"
	
	echo     copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_submitcal!"
	         copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_submitcal!"

	echo     copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_emailfilesdir!\Cal-!bat_camera!"
	         copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_emailfilesdir!\Cal-!bat_camera!"

	echo     copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_submitcal!"
	         copy /Y /b "!bat_caldir!\CameraSites-!bat_camera!.txt" "!bat_submitcal!"

	call :COPYCALFF "!bat_calfilename!"

%return%

:GETCAMERA
	set bat_camera=!bat_temp:~2,3!
echo :GETCAMERA %*  [!bat_camera!]
%return%



:COUNTFILE
	echo :COUNTFILE %1 %2
	rem Create a file that has the meteorcounts
	set bat_countfile=!bat_emailfilesdir!\archived=%1, confirmed=%2.txt

	echo     Meteor Counts:  Archived="%1"   Confirmed="%2"
	echo     Meteor Counts:  Archived="%1"   Confirmed="%2">"!bat_countfile!"

	echo     copy /y /b "!bat_countfile!" + "!bat_emailfilesdir!\comments.txt" "!bat_countfile!"
	         copy /y /b "!bat_countfile!" + "!bat_emailfilesdir!\comments.txt" "!bat_countfile!"
	
	echo.>>"!bat_countfile!"
	echo     call "%~dp0CheckTwilight.bat" !bat_dirname:~5,2!/!bat_dirname:~8,2!/!bat_dirname:~0,4!^>^>"!bat_countfile!!"
	         call "%~dp0CheckTwilight.bat" !bat_dirname:~5,2!/!bat_dirname:~8,2!/!bat_dirname:~0,4!>>"!bat_countfile!!"

	type "!bat_countfile!"
%return%


	rem read the cal file and use the date on line 2 and the time on 
	rem line 3 to create a search for the cal file.  To use the following
	rem example, the search will search in reverse order for the ff*.bin
	rem files from the CapturedFiles directory.
	rem Here is the format of the cal file
1	 Camera number            = 213
2	 Calibration date         = 08/18/2011
3	 Calibration time (UT)    = 03:38:09.187
:COPYCALFF
	echo :COPYCALFF %*

	set /a bat_calff_line=0
	rem if not exist "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!" ^(
	rem 	echo File Not Found: "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"
	rem 	pause
	rem ^)

	echo     for /f "usebackq skip=2 tokens=1-5" %%f in ^(`find /i "Calibration " "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"`^) do ...
	for /f "usebackq skip=2 tokens=1-5" %%f in (`find /i "Calibration " "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"`) do (
		set /a bat_calff_line+=1
		title working on FF file [!bat_calff_line!]: "!bat_fffilename!" %%f %%g %%h %%i %%j
		if !bat_calff_line! equ 1 (
			rem date
			rem echo %%f, %%g, %%h, %%i, %%j
			set bat_calffdate=%%i
			set bat_calffyyyy=!bat_calffdate:~-4!
			set bat_calffmm=!bat_calffdate:~0,2!
			set bat_calffdd=!bat_calffdate:~3,2!
		) else (
			if !bat_calff_line! equ 2 (
				rem time
				rem echo %%f, %%g, %%h, %%i, %%j
				set bat_calfftime=%%j
				set bat_calffhh=!bat_calfftime:~0,2!
				set bat_calffm=!bat_calfftime:~3,2!
				set bat_calffss=!bat_calfftime:~6,2!
			) else (
				rem ignore 
			)
		)
	)


	set bat_filespec=!bat_calffhh!!bat_calffm!!bat_calffss!
	set bat_searchspec=FF!bat_camera!_!bat_calffyyyy!!bat_calffmm!!bat_calffdd!_
	
	set bat_calff_found=0
    echo     for /f "usebackq tokens=*" %%f in ^(`dir !bat_submitcapturedbase!\!bat_searchspec!*.* /s/b /o-n`^) do 
	for /f "usebackq tokens=*" %%f in (`dir "!bat_submitcapturedbase!\!bat_searchspec!*.*" /s/b /o-n`) do (
		rem
		set bat_tempfilefull=%%f
		set bat_tempfilename=%%~nxf
		set bat_tempyyyy=!bat_tempfilename:~6,4!
		set bat_tempmm=!bat_tempfilename:~10,2!
		set bat_tempdd=!bat_tempfilename:~12,2!
		set bat_temphh=!bat_tempfilename:~15,2!
		set bat_tempmin=!bat_tempfilename:~17,2!
		set bat_tempsec=!bat_tempfilename:~19,2!
		
		set bat_tempspec=!bat_temphh!!bat_tempmin!!bat_tempsec!
		
		title working on Cal file: "!bat_fffilename!" %%f
		
		if !bat_found! equ 0 (
			if !bat_tempspec! lss !bat_filespec! (
				set bat_found=!bat_tempfilefull!
				set bat_calffname=!bat_tempfilefull!
				echo                                      FOUND "!bat_found!"
				echo     copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
				         copy /Y /b "!bat_calffname!" "!bat_emailfilesdir!\Cal-!bat_camera!"
			) else (
				rem echo NOT FOUND
				rem set bat_
				rem pause
			)
		)
	)

	echo :COPYCALFF-return Cal File FF name for "!bat_emailfilesdir!\Cal-!bat_camera!\!bat_calfilename!"  ["!bat_calffname"]
%return%

:GETCAMERAFROMDETECT
	echo :GETCAMERAFROMDETECT [%*]
	
	rem Try FTPdetectinfoC.txt
	if exist "%~1\FTPdetectinfoC.txt" (	
		set bat_detectfile1=%~1\FTPdetectinfoC.txt 
	) else (
		if exist "%~1\FTPdetectinfo_????_????_??_??.txt" ( 
			rem Try FTPdetectinfo_###_yyyy_mm_dd.txt
			for /f "usebackq tokens=*" %%b in (`dir "%~1\FTPdetectinfo_???_????_??_??.txt" /a-d /s/b`) do (
				set bat_detectfile1=%%dpnxb
			)
		) else (
			set bat_detectfile1=%~1\FTPdetectinfo.txt
		)
	)
	
	for /f "usebackq skip=2 tokens=*" %%b in (`find /i ".bin" "!bat_detectfile1!"`) do (
		set bat_camera=%%b
		set bat_camera=!bat_camera:~2,3!
	)
	
	echo :GETCAMERAFROMDETECT-return [%*]   [camera=!bat_camera!] [!bat_detectfile1!]
	if "!bat_camera!" equ "" (
		echo     ERROR: couldn't determine camera number
		pause
	)
%return%


:HELP
	@echo off
	echo.
	echo %~nx0
	echo.
	echo Usage: %~nx0 ^<datetimedir^>
	echo.
	echo This script can be run stand-alone (before reprocessing) or called from within
	echo a script.
	echo.
	echo The purpose of this script is to create a collection of files that can be
	echo transmitted to Peter Jenniskens.  The transmissions need to be broken
	echo down into two different collections for the following purposes: 
	echo 	(1) Email the text files to him in a timely manner
	echo 	(2) Mail a DVD archive of the FF*.bin files along with the text files
	echo.
	echo The organization of these files needs to be as follows (with the first first
	echo four containing the original files that match the date:
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\ArchivedFiles
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\Cal
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\CapturedFiles
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\ConfirmedFiles
	echo.
	echo    .\CAMS\SubmissionFiles\2011_08_01_05_00_19\EmailFiles       contains:
	echo        - archived=56, confirmed=6.txt
	echo                            Contains meteor counts for archived and confirmed, 
	echo                            as well as the contents of the comments.txt file.
	echo.
	echo        - CameraSites.txt               From the Cal dir
	echo        - CameraTimeOffsets.txt         From ArchivedFiles
	echo        - comments.txt                  Comments file from the user from ConfirmedFiles dir.
	echo.
	echo        - FTPdetectinfo_confirmed.txt
	echo                            renamed from FTPdetectinfo.txt from the 
	echo                            \cams\ConfirmedFiles directory.
	echo                            Also, it should be patched to reflect where  
	echo                            the ff*.bin files are, relative from the 
	echo                            current dir
	echo.
	echo        - FTPdetectinfo_confirmed-213-6.txt
	echo                            Same as FTPdetecinfo_confirmed.txt but it has
	echo                            the headers stripped out to make it easier to
	echo                            concatenate.  The numbers are the camera and meteor count.
	echo.
	echo        - FTPdetectinfo_scanned.txt
	echo                            Same idea as the FTPdetectinfo_confirmed.txt file
	echo                            except that this one comes from the ArchivedFiles
	echo                            directory
	echo.
	echo        - FTPdetectinfo_scanned-213-56.txt
	echo                            Same as for the confirmed file except that this
	echo                            one has the meteor count the ArchivedFiles.
	echo.
	echo        - LASTSETTINGS.txt               From ArchivedFiles
	echo        - ReprocessParameters.txt        From ArchivedFiles
	echo.
	echo        ..\EmailFiles\Cal-213
	echo            - CAL213_20110801_050019_514.txt
	echo            - CameraSites-213.txt
	echo            - FF213_20110801_050001_960_0023296.bin  (bin file used for calibration)
	echo.				 
	echo After the script verifies the movement of all these files, the user is ready to create a
	echo zip file of everything in the ".\SubmissionFiles\<datetime>\EmailFiles" so that 
	echo they can be sent via email.  Running "submit.email.bat" will take care of copying
	echo the files to the .\Submit dir.  From there, you can create a zip file of the dirs
	echo that you haven't yet submitted.
	echo.
	echo Most of this can be automated in a script in batch mode. We can't make a 
	echo DVD unattended though and that will need to be done manually.
	echo.
	echo To make the DVD, we copy ".\cams\SubmissionFiles\*.*" to the DVD burner.
	echo It might work better with RoboCopy, since I think it might support filling
	echo up a DVD and then continuing, but I'm not quite sure.
	echo.
	echo Once the DVD is burned, the files should be MOVED to ".\cams\SubmittedFiles\..." 
	echo.
	echo After a period of time, the specific ".\cams\SubmittedFiles\<datetime> directories can 
	echo be purged from the hard drive to make room for newer files. 
	echo.
	echo Ideally, all this should run from a copy on an external hard drive 
	echo so it can be processed on another computer and it won't interfere with capture, etc.
	echo.
	echo One issue to resolve is when there is an ArchivedFiles\^<date/time^> directory but no 
	echo matching ConfirmedFiles^<date/time^> directory.  This could have been caused by
	echo not being able to complete the processing due to some bug or corrupt files.  In that
	echo case, we just submit the files from the ArchivedFiles\^<date/time^> directory and 
	echo notate that in the readme.txt file in the directory.
	echo.
	echo Also, we need to start copying the necessary CAL and other files into the ArchivedFiles 
	echo directory as part of the ftp_reprocess.bat steps.  Perhaps we do that by calling
	echo a "complete_reprocessing.bat" routine.  Such a routine should be able to be run at
	echo anytime after FTP_Reprocess.exe is completed (or even while it is running).
	echo.
exit /b 9


:DONE
	echo.
	echo Done with %0 %*
	echo.
