 @echo off
setlocal enabledelayedexpansion enableextensions
rem RENAME THIS FILE TO submit.bat and store it in the C:\CAMS directory.
rem

setlocal enableextensions enabledelayedexpansion

:CHECKHELP
    	echo.%*|find /i "/?">nul:
    	if %errorlevel% equ 0 goto :HELP
    	echo.%*|find /i "/h">nul:
    	if %errorlevel% equ 0 goto :HELP
    	echo.%*|find /i "/help">nul:
    	if %errorlevel% equ 0 goto :HELP
goto :SETUP

	Flowchart:
		- Obtain the processed ".\ConfirmedFiles\<dirname>"
		- Create the target ".\SubmissionFiles\<dirname>" directory tree:
		  - EmailFiles
		  - BinFiles
		  - AviFiles
		- Copy the ".\ArchivedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_scanned.txt"
		- Copy the ".\ConfirmedFiles\<dirname>\FTPdetectinfo.txt" file and change name to
		  ".\SubmissionFiles\<dirname>\FTPdetectinfo_<camera>_<dirname>_confirmed.txt"
		- Copy the ".\ArchivedFiles\<dirname>\CameraTimeOffsets.txt" file 

		- Move the ".\ConfirmedFiles\<dirname>\*.bin" files to 
		  the ".\SubmissionFiles\<dirname>\BinFiles" directory.
		- Read the ".\SubmissionFiles\<dirname>\ftpdetectinfo.txt" file and 
		  get the following:
			- Meteor Count     from line number 1
			- FF  folder       from line number 5
			- CAL folder       from line number 6
			- calibration file from line number 14
			- camera number    from calibration file


:SETUP
	set bat_logfile=%bat_startdrive%\cams\submit.log
	set return=goto :EOF
	
	set bat_startlocation=%cd%
	set bat_startdrive=%cd:~0,2%
	set bat_caldir=%bat_startlocation%\Cal

:MAIN
	rem start the execution of the detection pass in background priority

	echo %date% %time%>"%bat_logfile%"
	set bat_>>"%bat_logfile%"

:GETDIRNAMES
	rem Loop to iterate through all directory names under the ..\ConfirmedFiles structure.
	for /f "usebackq tokens=*" %%a in (`dir "%bat_startlocation%\ConfirmedFiles" /s/b /ad /on`) do (
		echo.
		echo %%a
		set bat_confirmeddirfull=%%a
		set bat_dirname=%%~nxa
		
		set bat_captureddir=%bat_startlocation%\CapturedFiles\!bat_dirname!
		set bat_submissiondir=%bat_startlocation%\SubmissionFiles\!bat_dirname!
		set bat_archiveddirfull=%bat_startlocation%\ArchivedFiles\!bat_dirname!
		set bat_emailfilesdir=!bat_submissiondir!\EmailFiles
		set bat_binfilesdir=!bat_submissiondir!\BinFiles
		set bat_avifilesdir=!bat_submissiondir!\AviFiles

		call :CREATEDIRS "!bat_dirname!"
		call :MOVEFILES "!bat_dirname!"
		call :READFILE
		call :COPYCALFILE "!bat_calfilename!"
		set bat_>>"!bat_logfile!"
		pause
	)
exit /b

:CREATEDIRS
	rem usage: call :CREATEDIRS "!bat_dirname!"
		echo md "!bat_emailfilesdir!"
		     md "!bat_emailfilesdir!"
		echo md "!bat_binfilesdir!\Confirmed"
		     md "!bat_binfilesdir!\Confirmed"
		echo md "!bat_binfilesdir!\Archived"
		     md "!bat_binfilesdir!\Archived"
		echo md "!bat_binfilesdir!\Captured"
		     md "!bat_binfilesdir!\Captured"
		echo md "!bat_avifilesdir!"
		     md "!bat_avifilesdir!"
%return%
	
:MOVEFILES
             echo copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned.txt"
                  copy /Y "!bat_archiveddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_scanned.txt"
             
             echo Packaged for submission on %date% %time%>"!bat_emailfilesdir!\submit.txt"
             echo Packaged for submission on %date% %time%>"!bat_captureddir!\submit.txt"

             echo move /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"
                  move /Y "!bat_archiveddirfull!\CameraTimeOffsets.txt" "!bat_emailfilesdir!"

             echo move /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"
                  move /Y "!bat_archiveddirfull!\LASTSETTINGS.txt" "!bat_emailfilesdir!"

             echo move /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"
                  move /Y "!bat_archiveddirfull!\ReprocessParameters.txt" "!bat_emailfilesdir!"

             echo copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"
                  copy /Y /b "!bat_caldir!\CameraSites.txt" "!bat_emailfilesdir!"
            
		     echo move /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
		          move /Y "!bat_confirmeddirfull!\FTPdetectinfo.txt" "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"
		     
		echo move /Y "!bat_confirmeddirfull!\*.bin" "!bat_binfilesdir!\Confirmed"
		     move /Y "!bat_confirmeddirfull!\*.bin" "!bat_binfilesdir!\Confirmed"
		echo move /Y "!bat_archiveddirfull!\*.bin" "!bat_binfilesdir!\Archived"
		     move /Y "!bat_archiveddirfull!\*.bin" "!bat_binfilesdir!\Archived"
		echo robocopy.exe "!bat_captureddir!" "!bat_binfilesdir!\Captured" /e /move
		     robocopy.exe "!bat_captureddir!" "!bat_binfilesdir!\Captured" /e /move
		     
		echo move /Y "!bat_confirmeddirfull!\*.avi" "!bat_avifilesdir!"
		     move /Y "!bat_confirmeddirfull!\*.avi" "!bat_avifilesdir!"

		ECHO RD /s /q "!bat_confirmeddirfull!"
		     RD /s /q "!bat_confirmeddirfull!"
		ECHO RD /s /q "!bat_archiveddirfull!"
		     RD /s /q "!bat_archiveddirfull!"
%return%


:READFILE
	rem Loop to read the FTPdetectinfo.txt file.
	echo :READFILE
	set bat_msg= 
	set /a bat_linecount=0
	set /a bat_filecount=0
	for /f "usebackq tokens=*" %%a in (`type "!bat_emailfilesdir!\FTPdetectinfo_confirmed.txt"`) do (
		set bat_temp=%%a
		set bat_temp=!bat_temp:~0,5!
		rem title bat_linecount=!bat_linecount! %%a
		set /a bat_linecount+=1
		if !bat_linecount! equ 1 (
			call :GETMETEORCOUNT %%a
		) else (
			if !bat_linecount! equ 5 (
				call :GETFFDIR "%%a"
			) else (
				if !bat_linecount! equ 6 (
					rem call :GETCALDIR "%%a"
				) else (
					if !bat_linecount! equ 13 (
						call :GETCAMERA
						set bat_fffilename=%%a
						title !bat_fffilename!
					) else (
						if !bat_linecount! equ 14 (
							call :GETCALNAME "%%a"
						) else (
							if "!bat_temp!" equ "FF!bat_camera!" (
								set bat_fffilename=%%a
								title working on FF file: "!bat_fffilename!"
								set /a bat_filecount+=1
							)
						)
					)
				)
			)
		)
	)
%return%


:GETMETEORCOUNT
	rem Usage: call :GETMETEORCOUNT Meteor Count = 000533
	echo :GETMETEORCOUNT %1, %2, %3, %4
	set bat_temp=%3
	if "!bat_temp!" equ "000000" (
		set bat_msg=; needs FTP_Reprocess
	)

	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set bat_countconfirmed=%%a)
	if not defined bat_countconfirmed set bat_countconfirmed=0
%return%	




:GETFFDIR
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
%return%

:GETCALDIR
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_caldir=!bat_temp2:C:=%bat_startdrive%!
	)
%return%


:GETCALNAME
	rem 
	set bat_calfilename=%~1
%return%


:COPYCALFILE
	copy /Y /b "!bat_caldir!\!bat_calfilename!" "!bat_emailfilesdir!"
%return%

:GETCAMERA
	set bat_camera=!bat_temp:~2,3!
%return%


	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)

	set ftp_wmdy=%date%

	set ftp_hhmmssdd=%time%

	set ftp_year=%ftp_wmdy:~-4%
	set ftp_mo=%ftp_wmdy:~4,2%
	set ftp_mo2=%ftp_mo%
	if %ftp_mo% LSS 10 (
		set ftp_mo2=!ftp_mo:~-1!
	)
	set ftp_da=%ftp_wmdy:~7,2%
	set ftp_da2=%ftp_da%
	if %ftp_da% LSS 10 (
		set ftp_da2=!ftp_da:~-1!
	)

	set ftp_hr=%ftp_hhmmssdd:~0,2%
	set ftp_mi=%ftp_hhmmssdd:~3,2%
	set ftp_se=%ftp_hhmmssdd:~6,5%

	call :date2jdate ftp_jd %ftp_year% %ftp_mo2% %ftp_da2%
	rem set /a ftp_jd=%ftp_jd%-1
	call :jdate2date %ftp_jd% ftp_year ftp_mo2 ftp_da2

	set ftp_searchdir=%ftp_year%_%ftp_mo2%_%ftp_da2%


	for /f "usebackq tokens=*" %%a in (`dir ".\CapturedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_captureddir=%%~nxa
	)

	set ftp_

	for /f "usebackq tokens=*" %%a in (`dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_archiveddir=%%~nxa
	)

	set ftp_

	if defined ftp_archiveddir (
		dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad>"ftp_reprocess.log"
		dir ".\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad
		goto :ERR1
	)

:SRCHDRIVEC
	for /f "usebackq tokens=*" %%a in (`dir "c:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad`) do (
		echo %%~nxa
		rem set ftp_temp=%%~nxa
		set ftp_archiveddir=%%~nxa
	)

	set ftp_

	if defined ftp_archiveddir (
		dir "C:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad>"ftp_reprocess.log"
		dir "C:\cams\ArchivedFiles\%ftp_searchdir%*.*" /s/b /od /ad
		goto :ERR1
	)

:CONTINUE


	@echo start "FTP_Reprocess" /low ".\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%">>ftp_reprocess.log
	echo start "FTP_Reprocess" /low ".\ftp_reprocess.exe" ".\CapturedFiles\%ftp_captureddir%"
goto :DONE

:ERR1
	@echo.
	@echo.
	@echo "%cd%\ArchivedFiles\%ftp_archiveddir%" already exists. Do you want to
	@echo continue to overwrite the existing files? [Y/N] Y
	@goto :CONTINUE
	@set /p retval=continue to overwrite the existing files? [Y/N] 
	@if /i "%retval%" equ "y" goto :CONTINUE
goto :DONE


:date2jdate JD YYYY MM DD -- converts a gregorian calender date to julian day format
	setlocal
	rem                        -- JD   [out] - julian days
	rem                        -- YYYY [in]  - gregorian year, i.e. 2006
	rem                        -- MM   [in]  - gregorian month, i.e. 12 for december
	rem                        -- DD   [in]  - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	set "yy=%~2"&set "mm=%~3"&set "dd=%~4"
	set /a "yy=10000%yy% %%10000,mm=100%mm% %% 100,dd=100%dd% %% 100"
	if %yy% LSS 100 set /a yy+=2000 &rem Adds 2000 to two digit years
	set /a JD=dd-32075+1461*(yy+4800+(mm-14)/12)/4+367*(mm-2-(mm-14)/12*12)/12-3*((yy+4900+(mm-14)/12)/100)/4
	ENDLOCAL & IF "%~1" NEQ "" (SET %~1=%JD%) ELSE (echo.%JD%)
EXIT /b

:jdate2date JD YYYY MM DD -- converts julian days to gregorian date format
	rem                     -- JD   [in]  - julian days
	rem                     -- YYYY [out] - gregorian year, i.e. 2006
	rem                     -- MM   [out] - gregorian month, i.e. 12 for december
	rem                      -- DD   [out] - gregorian day, i.e. 31
	rem :$reference http://aa.usno.navy.mil/faq/docs/JD_Formula.html
	rem :$created 20060101 :$changed 20080219 :$categories DateAndTime
	rem :$source http://www.dostips.com
	SETLOCAL ENABLEDELAYEDEXPANSION
	set /a L= %~1+68569,     N= 4*L/146097, L= L-(146097*N+3)/4, I= 4000*(L+1)/1461001
	set /a L= L-1461*I/4+31, J= 80*L/2447,  K= L-2447*J/80,      L= J/11
	set /a J= J+2-12*L,      I= 100*(N-49)+I+L
	set /a YYYY= I,  MM=100+J,  DD=100+K
	set MM=%MM:~-2%
	set DD=%DD:~-2%
	( ENDLOCAL & REM RETURN VALUES
	    IF "%~2" NEQ "" (SET %~2=%YYYY%) ELSE echo.%YYYY%
	    IF "%~3" NEQ "" (SET %~3=%MM%) ELSE echo.%MM%
	    IF "%~4" NEQ "" (SET %~4=%DD%) ELSE echo.%DD%
	)
EXIT /b

:HELP
	@echo off
	echo.
	echo %0
	echo.
	echo Usage: %0 ^<datetimedir^>
	echo.
	echo This script can be run stand-alone (before reprocessing) or called from within
	echo a script.
	echo.
	echo The purpose of this script is to create a collection of files that can be
	echo transmitted to Peter Jenniskens.  The transmissions need to be broken
	echo down into two different collections for the following purposes: 
	echo 	(1) Email the text files to him in a timely manner
	echo 	(2) Mail a DVD archive of the FF*.bin files along with the text files
	echo.
	echo The organization of these files needs to be as follows:
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\EmailFiles       contains:
	echo 		- FTPdetectinfo.txt			renamed to FTPdetectinfo_213_2011_08_01_05_00_19_confirmed.txt
	echo 							This is the one from the \cams\ConfirmedFiles directory.
	echo 							Also, it should be patched to reflect where  
	echo 							the ff*.bin files are, relative from the 
	echo 							current dir
	echo 		- FTPdetectinfo.txt			renamed to FTPdetectinfo_213_2011_08_01_05_00_19_scanned.txt
	echo 							This is the one from the \cams\ArchivedFiles directory.
	echo 							Also, it should be patched to reflect where  
	echo 							the ff*.bin files are, relative from the 
	echo 							current dir
	echo 		- CameraTimeOffsets.txt			renamed to CameraTimeOffsets_Brentwood_2011_08_01_05_00_19.txt
	echo 		- LASTSETTINGS.txt			renamed to LASTSETTINGS_Brentwood_2011_08_01_05_00_19.txt
	echo 		- ReprocessParameters.txt		renamed to ReprocessParameters_Brentwood_2011_08_01_05_00_19.txt
	echo 		- \cams\cal\CameraSites.txt		renamed to CameraSites_Brentwood_2011_08_01.txt
	echo 		- \cams\cal\CAL213_20110801_050019_514.txt
	echo.				 
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\BinFiles
	echo 		- contains the FF*.bin files
	echo 	.\cams\SubmissionFiles\2011_08_01_05_00_19\AviFiles
	echo.
	echo After the script verifies the movement of all these files, it is ready to create a
	echo zip file of everything in the ".\SubmissionFiles\<datetime>\EmailFiles" so that 
	echo they can be sent via email.
	echo.
	echo Most of this can be automated in this script in batch mode. We can't make a 
	echo DVD unattended though and that will need to be done manually.
	echo.
	echo To make the DVD, we copy ".\cams\SubmissionFiles\*.*" to the DVD burner.
	echo It might work better with RoboCopy, since I think it might support filling
	echo up a DVD and then continuing, but I'm not quite sure.
	echo.
	echo Once the DVD is burned, the files should be moved to ".\cams\SubmittedFiles\..." 
	echo.
	echo After a period of time, the specific ".\cams\SubmittedFiles\<datetime> directories can 
	echo be purged from the hard drive to make room for newer files. 
	echo.
	echo Ideally, all this should run from a copy on an external hard drive 
	echo so it can be processed on another computer and it won't interfere with capture, etc.
	echo.
	echo One issue to resolve is when there is an ArchivedFiles\^<date/time^> directory but no 
	echo matching ConfirmedFiles^<date/time^> directory.  This could have been caused by
	echo not being able to complete the processing due to some bug or corrupt files.  In that
	echo case, we just submit the files from the ArchivedFiles\^<date/time^> directory and 
	echo notate that in the readme.txt file in the directory.
	echo.
	echo Also, we need to start copying the necessary CAL and other files into the ArchivedFiles 
	echo directory as part of the ftp_reprocess.bat steps.  Perhaps we do that by calling
	echo a "complete_reprocessing.bat" routine.  Such a routine should be able to be run at
	echo anytime after FTP_Reprocess.exe is completed (or even while it is running).
	echo.
exit /b 9


:DONE
